#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

/* Biblioteka unistd.h ma funkcje execl(), ktora
 * bedzie potrzebna w on_cmd_open_click().
 */

#include <unistd.h>

/* Biblioteka stdlib.h zawiera definicje typu pid_t (identyfikator
 * procesu), ktory bedzie potrzebny w on_cmd_open_click().
 */

#include <stdlib.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "kbi_utils.h"


void
on_cmd_close_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   g_print("on_cmd_close_clicked\n");
   gtk_main_quit();
}


void
on_cmd_open_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
   pid_t pid;
   gchar *exe_name = "./kbi";
   gchar *report_name = "another kbi";


   g_print("on_cmd_open_clicked\n");

   /* Pobranie nazwy pliku wykonywalnego
    * i nazwe raportu dla wywolania funkcji execl().
    */

   report_name = get_report_name();
   g_print("nazwa raportu to  %s\n", report_name);

   if (g_strcasecmp(report_name, "") == 0)
     {
        g_print("Nie wybrano zadnego raportu.");
        return;
     }

   exe_name = get_exe_name(report_name);

   g_print("Nazwa pliku wykonywalnego to %s\n", exe_name);

   if (g_strcasecmp(exe_name, "") == 0)
     {
        g_print("Brak pliku wykonywalnego.\n");
        return;
     }
   /* W ponizszym wywolaniu zakladamy, ze plik generujacy raport
    * znajduje sie w katalogu /usr/local/bin.
    * Mozna, oczywiscie, umiescic pliki raportow w innym miejscu,
    * wowczas trzeba podac odpowiednia sciezke dostepu. Mozna takze
    * umiescic sciezke w tabeli przechowujacej nazwy
    * poszczegolnych plikow wykonywalnych.
    */

   exe_name = g_strconcat("/usr/local/bin/", exe_name, 0L);

   /* Sprawdzmy, czy plik wykonywalny istnieje w komputwrze
    * uzytkownika, w katalogu:  /usr/local/bin/.
    */



   g_print("Check that file exists.\n");

   if (check_file_exists(exe_name) == FALSE)
      {
         /* Plik wykonywalny nie istnieje.... */
         g_print("Target exe not found.\n");

         return;
      }


   /* Ta czesc kodu wymaga wyjasnienia. Funkcja fork() sluzy do
    * utworzenia kopii uruchomionego programu jako osobny proces rozgaleziony.
    * Ten proces ma wlasna kopie programu, lacznie ze zmiennymi,
    * odpowiednim blokiem pamieci, i tak dalej.
    *
    * Ponizej wywolamy funkcje execl wewnatrz  warunku if.
    * Funkcja ta zmienia "biezacy" program na
    * inny, podany jako pierwszy parametr.
    */

   g_print("Utworzenie procesu rozgalezionego.\n");
   pid = fork();

   if (pid == 0)
     {
        /* Jesli sterowanie dotarlo do tego miejsca programu,
         * to oznacza, ze proces potomny zostal utworzony.
         * Teraz nalezy zamienic proces potomny na proces glowny,
         * czyli uruchomic program generujacy odpowiedni
         * raport.
         */

        g_print("inicjacja procesu potomnego.\n");
        execl (exe_name, report_name);
        g_print("Proces potomny zainicjowany.\n");
     }
   /* kontynuacja programu... */

}


gboolean
on_frm_kbi_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   g_print("on_frm_kbi_delete_event\n");
   gtk_main_quit();
   return FALSE;
}


void
on_frm_kbi_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
   g_print("on_frm_kbi_show\n");

   if (authenticate_user())
     {
         fill_lst_reports();
     }

}


void
on_frm_kbi_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
   g_print("on_frm_kbi_realize\n");
}


