#include <gtk/gtk.h>
#include <mysql.h>

#include "support.h"

/* Biblioteka stdio.h jest potrzebna do operacji na plikach. */

#include <stdio.h>

#define	SERVER	"localhost"
#define	LOGIN	"kbi_user"
#define PASS	"dengissa"
#define DB	"kbi"

GtkWidget *frm_kbi;

/* Po raz kolejny skorzystamy ze zmiennych o zasiegu
 * globalnym...
 */

MYSQL		*conx;
MYSQL_RES	*result_set;
MYSQL_ROW	row;
gchar		*sql;
gchar		*user_login;

/* Kod zrodlowy funkcji... */

gboolean authenticate_user()
{

   g_print("Rozpoczecie funkcji  authenticate_user.\n");

   conx = mysql_init(0L);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"Problem z mysql_init");
        return FALSE;
     }
   /* Jesli nie ma problemu - kontynuacja... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_init ok");

   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"problem z mysql_real_connect");
        return FALSE;
     }
   /* Nie ma problemu? - kontynuacja... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_real_connect ok");

   /* Utworzenie zapytania sql do sprawdzenia, jaki uzytkownik jest
    * zalogowany.
    */

   sql = g_strconcat("select * from tbl_uzytkownicy_uprawnieni ",
                     "where nazwa_uzytkownika = '",
                     g_get_user_name(), "'", 0L);

   g_print("sql jest w  %s\n", sql);

   /* Sprawdzimy, czy zalogowany uzytkownik jest
    * na liscie uprawnionych.
    */

   if (mysql_query (conx, sql) != 0)
      {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"problem z mysql_query ");
        return FALSE;
      }
   /* kontynuacja... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_query ok");

   result_set = mysql_store_result(conx);

   if (mysql_num_rows(result_set) != 1)
      {
         /* Wystapil jakis problem... */
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"Problem w mysql_num_rows");
        return FALSE;
      }
   /* kontynuacja */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_num_rows ok");

   /* Jesli sterowanie osiagnelo ten punkt programu, uzytkownik
    * jest uprawniony do korzystania z tego programu.
    */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "Zalogowany uzytkownik jest uprawniony.");

   mysql_free_result (result_set);
   mysql_close (conx);

   return TRUE;
}

void fill_lst_reports()
{  /* Ta procedura sluzy do wypelnienia pola listy aplikacji
    * dostepnymi dla danego uzytkownika raportami
    */
   GList *list_of_reports = 0L;

   conx = mysql_init(0L);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"Problem w mysql_init");
        return;
     }
   /* kontynuacja... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_init ok");

   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"Problem w mysql_real_connect");
        return;
     }
   /* kontynuacja... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_real_connect ok");

   sql = "select * from tbl_raporty";

   if (mysql_query (conx, sql) != 0)
      {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"Problem w mysql_query ");
        mysql_close(conx);
        return;
      }
   /* kontynuacja... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_query ok");

   result_set = mysql_store_result(conx);

   /* W tym momencie, result_set przechowuje wykaz raportow
    * ktore mozna wyswietlic.  Utworzymy strukture GList aby przechowac
    * te liste
    */

   while (( row = mysql_fetch_row (result_set)) != 0)
     {
         GtkWidget *list_item;

         //g_print("Nazwa raportu:  %s\n", row[0]);

         list_item = gtk_list_item_new_with_label(row[0]);

         /* Ponizsza funkcja jest wykorzysywana do
          * skojarzenia raportu z elementem listy obiektu GtkList
          * o nazwie lst_reports.  Przekazujemy trzy parametry
          * element listy, klucz i dane zwiazane z tym kluczem.
          * Dzieki temu, uzytkownik moze wybrac z listy dany raport,
          * a funkcja odnajdzie w bazie odpowiednia nazwe programu
          * generujacego dany raport. Procesury odczytujace
          * znajduja sie w funkcji get_report_name()..
          */

         gtk_object_set_data(GTK_OBJECT(list_item), "rept_name", row[0]);

         list_of_reports = g_list_append(list_of_reports,
                list_item);

     }

   /* Obiekt GList o nazwie list_of_reports zawiera wszystkie
    * nazwy raportow zwrocone przez zapytanie sql.  
    * Te liste umiescimy w obiekcie lst_reports.
    */

   gtk_list_append_items(GTK_LIST(lookup_widget(frm_kbi, "lst_reports")),
             list_of_reports);

   mysql_close(conx);

   /* Odswiezymy zawartosc okna. */
   gtk_widget_show_all(frm_kbi);

}

gchar *get_report_name()
{
    GtkWidget *target_list;
    GList     *target_GList;
    GtkObject *list_item;

    g_print("Rozpoczecie wykonywania get_report_name.\n");

    target_list = lookup_widget(frm_kbi, "lst_reports");
    target_GList = GTK_LIST(target_list)->selection;

    if (target_GList)
      {
       g_print("target_GList wypelniono.\n");
      }
    else
      {
       g_print("target_GList nie wypelniono.\n");
       return "";
      }

    g_print("zidentyfikowano target_label.\n");

    list_item = GTK_OBJECT(target_GList->data);

    g_print("zidentyfikowano dany element.\n");

    /* mamy wskaznik do wybranego elementu w liscie.
     * Skorzystamy z niego do odczytania w bazie danych
     * nazwy raportu, ktora jest skojarzona z danym elementem listy.
     * W ponizszym wywolaniu, rept_name stanowi klucz do danych
     * umieszczonych w list_item. Powyzej znajduje sie funkcja fill_list_reports()
     * ktra kojarzy dane z obiektem.
     */

    return gtk_object_get_data(list_item, "rept_name");
}

gchar *get_exe_name(gchar *rept_name)
{
   g_print("Rozpoczecie wykonywania get_exe_name\n");

   sql = g_strconcat("select wykonywalny from tbl_raporty where nazwa_raportu = '",
                      rept_name, "'", 0L);

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);
   if (mysql_query (conx, sql) != 0)
       {
           /* Blad w zapytaniu sql... */
           gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"Wystapil blad w mysql_query w funkcji get_exe_name");
        mysql_close(conx);
        return "";
       }

   result_set = mysql_store_result(conx);

   row = mysql_fetch_row (result_set);

   mysql_free_result(result_set);
   mysql_close(conx);
   return row[0];
}

gboolean check_file_exists(target_file)
{
   /* Ta funkcja sluzy do sprawdzenia, czy dany plik
    * istnieje w komputerze uzytkownika. Proba
    * otwarcia pliku nie ma sensu, jesli nie ma go
    * w komputerze uzytkownika.
    *
    * Jesli plik nie istnieje, to funkcja fopen zwroci
    * wartosc 0L (NULL). Parametr "r" oznacza atrybut 
    * "tylko-do-odczytu".
    */

   g_print("Rozpoczecie wykonywania check_file_exists.\n");

   if ( fopen((char*) target_file, "r") == 0L )
      {
         g_print("dany plik nie istnieje.\n");
         return FALSE;
      }
   else
      /* Plik nie istnieje. */
      g_print("Plik nie istnieje.\n");

   return TRUE;
}
