#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <mysql.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "ddc.h"

GtkWidget *frm_tabular;

void
on_frm_tabular_show                    (GtkWidget       *widget,
                                        gpointer         user_data)
{
  gchar     *sql;
  MYSQL     *conx;
  GtkWidget *scrolledwindow1;
  GtkWidget *statusbar1;

  /* W oknie frm_tabular nalezy wyswietlic sprzedawcow
   * o najwyzszych dochodach, w porzadku malejacym.
   * Aby to zrobic, nalezy wykonac procedure w
   * kilku etapach:
   *
   * W bazie "commish":
   * 1.  Usunac tabele tbl_najlepsi_sprzedawcy (jesli istnieje).
   * 2.  Na podstawie danych tabeli tbl_prowizje utworzyc tbl_najlepsi_sprzedawcy.
   * 3.  Pobrac i wyswietlic dane z nowej tabeli.
   *
   * Pierwsze dwa etapy mozna wykonac w aplikacji Prowizje,
   * jako koncowa instrukcja programu (wowczas nie trzeba
   * bedzie umieszczac tych instrukcji tutaj).
   */

  g_print("on_frm_tabular_show.\n");

  /* Nawiazanie polaczenia z baza danych. */

  conx = mysql_init(0L);
  conx = mysql_real_connect(conx, "localhost", "com_user",
                            "syL0U812", "commish", 0, 0L, 0);

  if (conx == 0L)
      {
          g_print("Nie mozna polaczyc sie z baza danych.\n");
          gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_tabular,
                      "statusbar1")), 1, "Nie mozna polaczyc sie z baza danych.");
          return;
      }

  g_print("Polaczono z baza commish.\n");

  sql = "drop table if exists tbl_najlepsi_sprzedawcy";

  if (mysql_query (conx, sql) != 0)
    {
       g_print("Blad - nie mozna usunac tabeli.\n");
       g_print("Numer bledu %i\n", mysql_errno (conx));
       g_print("Komunikat o bledzie:  %s\n", mysql_error (conx));
       gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_tabular,
                      "statusbar1")), 1, "Nie mozna usunac tabeli.");
       mysql_close (conx);
       return;

    }

  g_print("tabela usunieta.\n");

  sql = g_strconcat("create table tbl_najlepsi_sprzedawcy ",
                    "select distinct sprzedawca, ",
                           "sum(prowizja) as prowizja, "
                           "count(*) as Liczba_rekordow "
                    "from tbl_prowizje "
                    "group by sprzedawca", 0L);

  if (mysql_query (conx, sql) != 0)
    {
       g_print("Blad - nie utworzono tabeli.\n");
       g_print("Numer bledu: %i\n", mysql_errno (conx));
       g_print("Komuniekat o bledzie: %s\n", mysql_error (conx));
       gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_tabular,
                      "statusbar1")), 1, "Nie utworzono tabeli.");
       mysql_close (conx);
       return;

    }

  g_print("Tabela zostala utworzona.\n");

  mysql_close (conx);

  g_print("Polaczenie z baza commish zamknieto.\n");

  sql = "tbl_najlepsi_sprzedawcy order by prowizja DESC";

  gtk_widget_destroy(GTK_WIDGET(lookup_widget(frm_tabular,
                "scrolledwindow1")));

  g_print("Wywolanie create_ddc.\n");
  scrolledwindow1 = create_ddc(sql, "localhost", "com_user",
                               "syL0U812", "commish", frm_tabular);
  g_print("Powrot z  create_ddc.\n");
 
  gtk_widget_ref(scrolledwindow1);
  gtk_object_set_data_full(GTK_OBJECT(frm_tabular),
               "scrolledwindow1", scrolledwindow1,
               0L);

  gtk_box_pack_start(GTK_BOX(lookup_widget(frm_tabular,
               "vbox1")), scrolledwindow1, TRUE, TRUE, 0);

  gtk_widget_show(scrolledwindow1);

  /* Niestety, pojemniki nie pozwalaja na umieszczanie widgetow
   * potomnych w okreslonych miejscach - tylko albo na poczatku,
   * albo na koncu. Dlatego tez, zniszczymy pasek stanu
   * utworzony w Glade i stworzymy nowy..
   *
   * pamietajmy, ze pasek stanu byl potrzebny glownie do
   * chwili uruchomienia programu generujacego raport.
   */
  gtk_widget_destroy(GTK_WIDGET(lookup_widget(frm_tabular,
          "statusbar1")));

  statusbar1 = gtk_statusbar_new();

  gtk_box_pack_start(GTK_BOX(lookup_widget(frm_tabular,
               "vbox1")), statusbar1, FALSE, FALSE, 0);
  gtk_widget_show(statusbar1);

  gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_tabular,
                      "statusbar1")), 1, "Zadanie wykonano.");

}


gboolean
on_frm_tabular_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  g_print("on_frm_delete_event.\n");
  
  gtk_main_quit();
  return FALSE;
}

