#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "piechart_utils.h"

void
on_frm_piechart_show                   (GtkWidget       *widget,
                                        gpointer         user_data)
{
  if (load_data() == FALSE)
      {
          g_print("nie mozna pobrac danych dla wykresu kolowego.\n");
          return;
      }

  parse_colors();

  draw_pie_chart();
  g_print("on_frm_piechart_show\n");
}


gboolean
on_frm_piechart_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  g_print("on_frm_piechart_delete_event\n");
  gtk_main_quit();
  return FALSE;
}
/* Ponizsze funkcje zwrotne umieszczono w celu pokazania 
 * sekwencji zdarzen dla widgetu DrawingArea. W zasadzie nie potrzebujemy
 * ich w niniejszej aplikacji.
 */


gboolean
on_drawingarea1_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  //g_print("on_drawingarea1_delete_event\n");
  return FALSE;
}


void
on_drawingarea1_show                   (GtkWidget       *widget,
                                        gpointer         user_data)
{

  //g_print("on_drawingarea1_show\n");

}


void
on_drawingarea1_draw                   (GtkWidget       *widget,
                                        GdkRectangle    *area,
                                        gpointer         user_data)
{

  //g_print("on_drawingarea1_draw\n");
}


gboolean
on_drawingarea1_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  /* Umiescimy wywolanie funkcji draw_pie_chart w funkcji
   * zwrotnej zwiazanej z widgetem DrawingArea, dzieki
   * czemu bedziemy mieli pewnosc, ze wykres zostanie
   * narysowany ponownie, jesli np. zostanie zasloniety
   * przez inne okno.
   *
   * To rozwiazanie jest dobre dla prostych rysunkow,
   * skladajacych sie z niewielkiej liczby punktow.
   * W przypadku rysunkow zlozonych odswierzanie 
   * wplywa na szybkosc dzialania programu
   * (jest tak w przypadku wykresow punktowych, 
   * skladajacych sie z ok 4000 punktow - w wykresie
   * kolowym korzystamy z okolo 6 punktow znaczacych).
   */
  draw_pie_chart();
  //g_print("on_drawingarea1_event\n");
  return FALSE;
}


void
on_drawingarea1_realize                (GtkWidget       *widget,
                                        gpointer         user_data)
{
  //g_print("on_drawingarea1_realize\n");

}


void
on_frm_piechart_realize                (GtkWidget       *widget,
                                        gpointer         user_data)
{
  //g_print("on_frm_piechart_realize\n");

}


gboolean
on_frm_piechart_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  //g_print("on_frm_piechart_event\n");
  return FALSE;
}

