#include <gtk/gtk.h>
#include <mysql.h>

/* Biblioteka time.h jest potrzebna do odczytu
 * czsu systemowego.
 */

#include <time.h>

/* Biblioteka stdlib.h zawiera funkcje atoi i atof,
 * ktore beda nam potrzebne */

#include <stdlib.h>

#include "support.h"

#define	SERVER  "localhost"
#define	LOGIN   "kbi_user"
#define PASS    "dengissa"
#define DB      "kbi"
/* Zakladamy, ze nie bedziemy tworzyc wiecej niz 10
 * grup towarowych. */

#define max_div 10

GtkWidget *frm_piechart;

MYSQL           *conx;
MYSQL_RES       *result_set;
MYSQL_ROW       row;
gchar           *sql;

gint            number_of_divisions = 0;
gint            total_sales = 0;



gchar           *division_names[max_div];
gint            division_sales[max_div];
GdkColor        color[max_div];
gchar           *color_choices[max_div] = {"Yellow", "Blue", "Red", "Gray", "Black",
                        "White", "Green", "Purple", "Orange", "Gold"};

void draw_legend(gint posit_x, gint posit_y,
                 gchar* legend_text, GdkColor my_color);

void draw_pie_wedge(gint start_deg, gint end_deg, GdkColor my_color)
{
   /* ta funkcja sluzy do narysowania czesci wykresu kolowego
    * o odpowiedniej wielkosci i w odpowiednim kolorze
    * (poczatek, koniec, oraz kolor fragmentu przekazujemy
    * jako parametry wywolania).
    */
   GdkGC  *gc;

   gc = gdk_gc_new(GTK_WIDGET(lookup_widget(frm_piechart,
                   "drawingarea1"))->window);

   if (!gdk_colormap_alloc_color(gdk_colormap_get_system(),
          &my_color, FALSE, TRUE))
     {
      g_print("Nie mozna zlokalizowac mapy z kolorami\n");
      gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
          "statusbar1")), 1, "Nie mozna zlokalizowac mapy z kolorami.");
     }

   gdk_gc_set_foreground(gc, &my_color);

   //g_print("Drawing Arc.\n");
   gdk_draw_arc( GTK_WIDGET(lookup_widget(frm_piechart,
          "drawingarea1"))->window,
          gc, TRUE, 10, 10, 350, 350, start_deg*64, end_deg*64);

   //g_print("exiting draw_pie_wedge\n");
   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
          "statusbar1")), 1, "Zakonczono wykonywanie draw_pie_wedge");
}

void parse_colors()
{  /* Ta funkcja sluzy do rozpoznania nazw kolorow */
   gint     i;

   for (i=0; i<10; i++)
       {

        if (!gdk_color_parse(color_choices[i], &color[i]))
          {
            g_print("Nie rozpoznano koloru %d.\n", i);
            gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                 "statusbar1")), 1, "Nie rozpoznano kolorow.");
          }
       }
}

void draw_pie_chart()
{
   gint   i;
   gint   current_pct;
   gint   current_degree = 0;
   gint   legend_vertical = 405;

   //g_print("Liczba czesci wykresu %d\n", number_of_divisions);

   for (i=1; i<=number_of_divisions; i++)
     {

        /* Najpierw wyznaczymy udzial procentowy kazdej z grup
         * towarow..
         */

        //g_print("div sales i - 1 is %d\n", division_sales[i-1]);
        //g_print("total sales is %d\n", total_sales);

        /* Poniewaz zaokraglimy wyznaczone wartosci,
	 * to bedziemy musieli w jakis sposob skompensowac
	 * to zaokraglenie. Gdybysmy tego nie zrobili,
	 * to kolo nie zostaloby do konca wypelnione.
	 * Zmienna current_pct przechowuje wartosci calkowite,
	 * wiec w trakcie zaokraglania pozbedziemy sie wartosci
	 * z zakresu od .001 do .999. Jako wartosc kompensujaca
	 * nalezy przyjac liczbe znajdujaca sie mniej wiecej w
	 * polowie tego zakresu. My przyjmiemy 0.5. Blad 
	 * polprocentowy nie bedzie zauwazalny przez oko
	 * ludzkie na wykresie. */

        current_pct = ((gdouble) division_sales[i - 1] /
                       (gdouble) total_sales) * 100 + .5;

        //g_print("procent powierzchni:  %d\n", current_pct);

        /* Jesli narysowano ostatni fragment kola, to nalezy
         * "zamknac" kolo - wykres nie moze zwierac
         * niewypelnionych powierzchni. Braki sa przyczyna
	 * zaokraglania.
         */

        /* drugim parametrem funkcji draw_pie_wedge jest  
	 * miara kata luku.*/

        if (i == number_of_divisions)
            {
              /* To jest ostatnia czesc wykresu; lepiej dokonczyc
               * wykres i zamknac kolo, niz zostawiac pusty kawalek
               * ktory powstal w wyniku zaokraglania wartosci
               * (jest to blad zaokraglenia).
               */
              draw_pie_wedge(current_degree,
                     360 - current_degree, color[i - 1]);
            }
        else
            {
	     /* Wspolczynnik 3.6 jest zwiazany z faktem, ze
	      * 100 procent odpowiada katowi 360 stopni
	      * (360/100 = 3.6).
	      */

              draw_pie_wedge(current_degree,
                     current_pct * 3.6, color[i - 1]);
            }

        current_degree += current_pct * 3.6;

        draw_legend(legend_vertical, 0,
                    g_strconcat(division_names[i - 1], " - ",
                    g_strdup_printf("%d", division_sales[i - 1]),
                    " (", g_strdup_printf("%d", current_pct),
                    "%)", 0L),
                    color[i - 1]);
               /* Pomiedzy kolejnymi polami legendy zrobimy odstep
	        * 20 piksli
		*/

        legend_vertical += 20;

        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                 "statusbar1")), 1, "Wykres kolowy narysowano.");
     }
}

void draw_legend(gint posit_x, gint posit_y,
                 gchar* legend_text, GdkColor my_color)
{
  /* ta funkcja bedzie rysowac tylko jeden wiersz pkseli
   * pola legendy - trzeba wywolac ja 
   * odpowiednia liczbe razy.
   */


   GdkGC  *gc;
   GdkColor black;

   gc = gdk_gc_new(GTK_WIDGET(lookup_widget(frm_piechart,
                   "drawingarea1"))->window);

   if (!gdk_colormap_alloc_color(gdk_colormap_get_system(),
          &my_color, FALSE, TRUE))
       {
            gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                 "statusbar1")), 1, "Nie zlokalizowano mapy kolorow.");
       }

   gdk_gc_set_foreground(gc, &my_color);

   gdk_draw_rectangle(GTK_WIDGET(lookup_widget(frm_piechart,
        "drawingarea1"))->window, gc, TRUE, 20, posit_x, 10, 10);

   if (!gdk_color_parse("Black", &black))
        {
            g_print("unable to parse black.\n");
            gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                 "statusbar1")), 1, "Nie zinterpretowano slowa Black.");
        }

   if (!gdk_colormap_alloc_color(gdk_colormap_get_system(),
          &black, FALSE, TRUE))
       {
          g_print("unable to allocate colormap\n");
          gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                 "statusbar1")), 1, "Nie zlokalizowano mapy kolorow.");
       }

   gdk_gc_set_foreground(gc, &black);

   gdk_draw_string(
        GTK_WIDGET(lookup_widget(frm_piechart, "drawingarea1"))->window,
        GTK_WIDGET(lookup_widget(frm_piechart, "drawingarea1"))->style->font,
        gc, 35, posit_x + 10, legend_text);

}

gboolean load_data()
{  /* Funkcja laczy sie z baza danych i zwraca odpowednie
    * dane dla wykresu kolowego
    */

   gchar *str_year, *str_month;
   struct tm *ptr;
   time_t now;

   conx = mysql_init(0L);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                      "statusbar1")), 1,"Problem w mysql_init ");
        return FALSE;
     }
   /* kontynuacja programu... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                      "statusbar1")), 1, "mysql_init ok");

   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                      "statusbar1")), 1,"Problem w mysql_real_connect ");
        return FALSE;
     }
   /* kontynuacja programu ... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                      "statusbar1")), 1, "mysql_real_connect ok");

   /* Odczytamy aktualny czas systemowy i okreslimy
    * biezacy miesiac (wykres utworzymy dla poprzedniego).
    */

   time(&now);
   ptr = localtime(&now);

   /* tm_year to liczba lat, ktora uplynela od roku 1900
    * Aby otrzymac pelny rok, dodamy do tej wartosci 1900.
    */

   str_year =  g_strdup_printf("%d", ptr->tm_year + 1900);

   /* tm_mon zwraca liczbe pomiedzy 0 a 11, ktora oznacza
    * biezacy miesiac (pamietajmy, ze C indeksujemy od zera).
    * Aby 1 oznaczalo Styczen, 2 - luty, itd. nalezy do zwroconej wartosci dodac 1.
    * My jednak tworzymy raport dla miesiaca poprzedzajacego, wiec
    * mozemy uznac, ze zwrocona wartosc oznacza biezacy miesiac minus
    * jeden.
    *
    */

   str_month = g_strdup_printf("%d", ptr->tm_mon);

   /* Jesli biezacym miesiacem jest styczen, to nalezy
    * utworzyc raport dla grudnia z poprzedniego roku
    */

   if (g_strcasecmp(str_month, "0") == 0)
      {
         /* For clarity, use the same function call as before,
          * subtracting one "year".
          */

         str_year =  g_strdup_printf("%d", ptr->tm_year + 1900 - 1);
         str_month = "12";
      }

   g_print("Year and month for query are %s and %s\n", str_year, str_month);

   sql = g_strconcat("select * from tbl_grupy ",
                     "where miesiac = ", str_month,
                     "  and rok  = ", str_year, 0L);

   g_print("sql is %s\n", sql);

   if (mysql_query (conx, sql) != 0)
      {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                      "statusbar1")), 1,"problem w mysql_query ");
        g_print("problem z mysql_query w load_data.\n");
        mysql_close(conx);
        return FALSE;
      }
   /* kontynuacja... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_piechart,
                      "statusbar1")), 1, "mysql_query ok");

   result_set = mysql_store_result(conx);

   /* result_set zawiera odpowiednie dane, ktore trzeba przedsatwic
    * na wykresie. Aby to zrobic, nalezy zwrocone dane umiescic
    * w tablicach, a nastepnie, za ich pomoca, 
    * utworzyc odpowiedni wykres.
    */

   while (( row = mysql_fetch_row (result_set)) != 0)
     {
        static gint i = 0;

        division_names[i] = row[2];
        division_sales[i] = atoi(row[3]);

        //g_print("Dane: %s i %d\n", division_names[i], division_sales[i]);

        total_sales += division_sales[i];
        //g_print("Suma sprzedazy:  %d.\n", total_sales);

        i++;

        //g_print("Liczba grup towarow:  %d\n", i);
        number_of_divisions = i;
     }

   mysql_close(conx);

   return TRUE;

}
