@echo off

rem . This is the gcc command line compile from ch9.
rem . Having WinZip will make all of this MUCH easier.
rem . www.winzip.com.
rem . 
rem . Get the newests file when you go to do this, not
rem . necessarily the files listed here; they are just the ones 
rem . current at the time the book was written.

rem . ====================================================================
rem . URLs and Files needed at various places.
rem . ====================================================================

rem . gcc for Windows
rem . URL:      http://www.mingw.org./
rem . File:     mingw-runtime-0.5-200102
rem . 
rem . MySQL for MinGW files, including libmysqlclient.a
rem . URL:     http://doga.go.cz/ports.html  
rem . File:    MySQL-3.23.32-mingw32-binary.tar.gz
rem .
rem . GTK+, GDK, GLib, etc, for Windows
rem . URL:     http://user.sgic.fi/~tml/gimp/win32/
rem . Files:   glib-dev-20001226.zip, glib-src-2001226.zip,
rem .          gtk+-dev-20001226.zip, gtk+-src-20001226.zip
rem .
rem . zlib library, needed by the MySQL for MinGW files
rem . URL:     http://penguin.at0.net/~fredo/files/
rem . File:    zlib-1.1.3-mingw.zip


rem . ====================================================================
rem . Set the system path to search for the executables.
rem . ====================================================================

rem . Path Variable:  d:\mingw\bin
rem . Location of:    gcc.exe
rem . File (mingw):   gcc-2.95.2-1.msvcrt.zip

rem . Path Variable:  d:\mingw\binutils\bin
rem . Location of:    as.exe, ld.exe
rem . Files (mingw):  binuitls-2.10.91-20010114.zip, ld-2.10.91-20010126.zip

PATH=d:\mingw\bin\;d:\mingw\binutils\bin\;

rem . set the current directory to the location of this batch file.
D:
cd \NewRiders\book\ch12\r3\src\

rem . ====================================================================
echo  Starting compile...
rem . ====================================================================

rem . The order of the *.c files is important.
rem .
rem . -Wall               show all warnings
rem . -o bar_line.exe     the executable name
rem . *.c                 the source files
rem . -I                  "Include" directories for *.h files
rem . -l                  link the following library;  the file
rem .                       gcc will search for is actually called
rem .                       "libwhatever.a", but on the command line
rem .                       the link command is "-lwhatever"
rem . -L                  Look in these directories for the 
rem .                       library files indicated by the -l flags

rem . Option:  -ID:\mingw\bin\mingwbinary\include\mysql\ 
rem . What:    mysql header files for mingw

rem . Option:  -ID:\MySQL\Win32\include\ 
rem . What:    mysql header files from mysql, any not covered previously

rem . Option:  -ID:\gtk\src\gtk+\ 
rem .          -ID:\GLIB\src\glib\ 
rem .          -ID:\GTK\src\gtk+\gdk\
rem .          -ID:\gtk\src\gtk+\gtk\
rem . What:    gtk\gtk.h, glib.h and other header files and 
rem .          any other gtk+ and gdk files not already covered.

rem . Options:  -ID:\MySQL\Win32\lib\opt\ 
rem .           -ID:\mingw\lib\gcc-lib\i386-mingw32msvc\2.95.2\include\ 
rem .           -ID:\mingw\msvcrt\i386-mingw32msvc\include\ 
rem . What:     assorted *.h files
rem . Option:   -ID:\mingw\msvcrt\i386-mingw32msvc\lib\  
rem .           assorted *.a files

rem . Option:  -mno-cygwin 
rem . Purpose: don't compile with the cygwin dll if it is present

rem . Option:  -fnative-struct 
rem . Purpose:

rem . Option:  -lgdk-1.3 
rem .          -lgtk-1.3 
rem .          -lgmodule-1.3 
rem .          -lglib-1.3 
rem . What:    gtk and gdk libraries
rem . URL:
rem . File:

rem . Option:   -lmysqlclient 
rem . What:     link in file libmysqlclient.a

rem . Option:   -lwsock32 
rem . Purpose:  needed with the libmysqlclient.a file used

rem . Option:   -lzlib 
rem . What:     link file libzlib.a
rem . Purpose:  compression and decompression 

rem . Option:   -LD:\mingw\bin\mingwbinary\lib 
rem . What:     location of file libmysqlclient.a;  this one has
rem .              been put first so that any files found in this
rem .              directory gets used, even if duplicates or different
rem .              versions are found in any of the directories below.

rem . Option:   -LD:\mingw\msvcrt\i386-mingw32msvc\lib\ 
rem .           -LD:\MySQL\win32\lib\opt 
rem .           Other directories to search in case libmysqlclient.a 
rem .              not found in previous directory.

rem . Option:  -Ld:\GLIB\src\glib 
rem .          -Ld:\GTK\src\gtk+\gtk 
rem .          -Ld:\GTK\src\gtk+\gdk 
rem .          -LD:\GLib\src\glib\gmodule 
rem . What:    libgtk-1.3.a, libgdk-1.3a, etc.  Same as Chapter 9.

rem . Option:  -LD:\mingw\lib\zlib
rem . What:    location of libzlib.a

rem . ====================================================================
rem . Here is the actual call to gcc...
rem . ====================================================================

gcc -Wall -o bar_line.exe main.c support.c interface.c callbacks.c barline_utils.c -ID:\mingw\bin\mingwbinary\include\mysql\ -ID:\MySQL\Win32\include\ -ID:\gtk\src\gtk+\ -ID:\GLIB\src\glib\ -ID:\GTK\src\gtk+\gdk\ -ID:\gtk\src\gtk+\gtk -ID:\MySQL\Win32\lib\opt\ -ID:\mingw\lib\gcc-lib\i386-mingw32msvc\2.95.2\include\ -ID:\mingw\msvcrt\i386-mingw32msvc\include\ -ID:\mingw\msvcrt\i386-mingw32msvc\lib\  -mno-cygwin -fnative-struct -lgdk-1.3 -lgtk-1.3 -lgmodule-1.3 -lglib-1.3 -lmysqlclient -lwsock32 -lzlib -LD:\mingw\bin\mingwbinary\lib -LD:\mingw\msvcrt\i386-mingw32msvc\lib\ -Ld:\GLIB\src\glib -Ld:\GTK\src\gtk+\gtk -Ld:\GTK\src\gtk+\gdk -LD:\MySQL\win32\lib\opt -LD:\GLib\src\glib\gmodule -LD:\mingw\lib\zlib

echo Done.

rem . You may need to include the math library, -lm.
rem . The Win32 version of -lz is the -lzlib above.   
