#include <gtk/gtk.h>
#include <mysql.h>

/* Biblioteka stdlib.h zawiera funkcje atoi i atof. */

#include <stdlib.h>

#include "support.h"

#define	SERVER  "localhost"
#define	LOGIN   "com_user"
#define PASS    "syL0U812"
#define DB      "commish"

#define HORIZONTAL_LINE 550 // Orientacja osi
#define VERTICAL_LINE    40

GtkWidget *frm_scatter;

MYSQL           *conx;
MYSQL_RES       *result_set;
MYSQL_ROW       row;
gchar           *sql;

gint    vertical_index;   // Liczba calkowita reprezentujaca numer
gint    horizontal_index; // elementu zwroconego w result_set

gint max_vertical = 0;   // Zmienne przechowujace maksymalna i minimalna
gint max_horizontal = 0; // wartosc dla kazdej z osi.
/* Kolejne dwie zmienne beda przechowywac wspolczynniki skalowania 
 * dla kazdej z osi. na przyklad, jesli wartoscia maksymalna w zestawie danych
 * jest 600, a do dyspozycji mamy tylko 540 punktow, to wspolczynnik
 * wyznaczymy jako 540/600 = 0.9.
 */


gdouble vertical_scale_multiplier = 1.0;
gdouble horizontal_scale_multiplier = 1.0;

void set_indices();
gboolean load_data();

GdkGC *get_gc(gchar *in_color)
{
   /* To jest funkcja get_gc() z raportu r3...
    * Funkcja zwraca kontekst narzedzia graficznego
    * w kolorze okreslonym przez in_color .
    */

   GdkGC    *gc;
   GdkColor my_color;

   gc = gdk_gc_new(GTK_WIDGET(lookup_widget(frm_scatter,
           "drawingarea1"))->window);

   if (!gdk_color_parse(in_color, &my_color))
      {
         g_print("Unable to parse %s.\n", in_color);
         gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
               "statusbar1")), 1, "Unable to parse color.\n");
         return 0L;
      }

   if (!gdk_colormap_alloc_color(gdk_colormap_get_system(),
        &my_color, FALSE, TRUE))

      {
         g_print("Unable to allocate colormap for %s.\n", in_color);
         gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
               "statusbar1")), 1, "Unable to allocate colormap.\n");
         return 0L;
      }
  
   gdk_gc_set_foreground(gc, &my_color);
 
   return gc;

}

void draw_axis_and_scales()
{  /* Podobnie, jak w poprzednim przykladzie, ta funkcja sluzy do
    * rysowania osi pionowej i poziomej, a takze ustalenia
    * wartrosci maksymalnych wykresu
    */
   GdkGC    *gc;

   gc = get_gc("Black");

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       gc, 25, HORIZONTAL_LINE, "0"); 

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       gc, 45, HORIZONTAL_LINE + 15, "0"); 
   

   gdk_draw_line(
           GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
           gc, VERTICAL_LINE, 10, VERTICAL_LINE, HORIZONTAL_LINE);

   gdk_draw_line(
           GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
           gc, VERTICAL_LINE, HORIZONTAL_LINE, 875, HORIZONTAL_LINE);

}

void plot_point(gint from_left, gint from_bottom, gchar *legend)
{   /* Ta funkcja rysuje pojedynczy punkt, oraz wprowadza
     * identyfikator punktu (wartosc parametru legend).
     */

    gdk_draw_rectangle(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       get_gc("Black"), FALSE, from_left, from_bottom - 3, 3, 3);

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       get_gc("Black"), from_left + 4, from_bottom + 2, legend); 
}

void set_maximums()
    /* Ta funkcja sluzy do wyszukania wartosci maksymalnych
     * zwroconych w wyniku wykonania zapytania sql. Te wartosci
     * posluza do okreslenia odpowiednich wspolczynnikow
     * skalowania dla osi i rysowanych punktow. */
{
    /* Wyzerujemy result_set aby wskazywal na pierwszy rekord;
     * 0 oznacza pierwszy element.
     */

    mysql_data_seek(result_set, 0);

    while (( row = mysql_fetch_row (result_set)) != 0)
        {
            if (atoi (row[vertical_index]) > max_vertical)
               {
                  max_vertical = atoi(row[vertical_index]);
                  g_print("max_vertical wynosi %d\n", max_vertical);
               }
        }
    vertical_scale_multiplier = (gdouble) 540/max_vertical;
    g_print("vertical_scale_multiplier wynosi %f\n", vertical_scale_multiplier);

    mysql_data_seek(result_set, 0);

    while (( row = mysql_fetch_row (result_set)) != 0)
        {
            if (atoi (row[horizontal_index]) > max_horizontal)
               {
                  max_horizontal = atoi(row[horizontal_index]);
                  g_print("max_horizontal wynosi %d\n", max_horizontal);
               }
        }
    horizontal_scale_multiplier = (gdouble) 835/max_horizontal;
    g_print("horizontal_scale_multiplier wynosi %f\n", horizontal_scale_multiplier);
}

void plot_maximums()

{  /* Ta funkcja sluzy do umieszczenia znacznikow wartosci
    * maksymalnych (w formacie string), ktore znajduja 
    * sie w lewym, gornym rogu (os y) i prawym, dolnym (os x).
    */

   GdkGC    *gc;

   gc = get_gc("Black");

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       gc, 0, 10, g_strdup_printf("%d", max_vertical)); 

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       gc, 845, HORIZONTAL_LINE + 15, g_strdup_printf("%d", max_horizontal)); 

}

void plot_graph()
{   /* Ta funkcja sluzy do rysowania poszczegolnych punktow
     */

    gint i = 0;

    gdk_draw_rectangle(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       get_gc("Gray"), TRUE, 0, 0, 900, 575);

    load_data();
    draw_axis_and_scales();
    set_indices();
    set_maximums();
    plot_maximums();

    mysql_data_seek(result_set, 0);

    while (( row = mysql_fetch_row (result_set)) != 0)
      {
        /*g_print("vertical is %s and horiz is %s\n", row[vertical_index],
         *       row[horizontal_index]);
         */

        plot_point(VERTICAL_LINE + 
                     atoi(row[horizontal_index])*horizontal_scale_multiplier,
                   HORIZONTAL_LINE - 
                     atoi(row[vertical_index])*vertical_scale_multiplier,
                   row[0]);

        i++;
      }


}

void set_indices()
{
    /* Ustalenie wartosci zmiennych horizontal_index i vertical_index.
     * Teraz wiadomo, ktora kolumna z result_set ma byc przedstawiona
     * na wykresie.
     */

    GtkCombo  *cbo;
    gchar     *cbo_text;

    cbo = GTK_COMBO(lookup_widget(frm_scatter, "cbo_vertical"));
    cbo_text = gtk_entry_get_text(GTK_ENTRY(cbo->entry)); 
    g_print("os pionowa: %s\n", cbo_text);

    if (g_strcasecmp(cbo_text, "Liczba sztuk") == 0)
         vertical_index = 1;
    else if (g_strcasecmp(cbo_text, "Cena jednostkowa") == 0)
         vertical_index = 2;
    else if (g_strcasecmp(cbo_text, "Wartosc netto") == 0)
         vertical_index = 3;
    else if (g_strcasecmp(cbo_text, "Liczba towarow na fakturze") == 0)
         vertical_index = 4;
    else if (g_strcasecmp(cbo_text, "Wartosc faktury") == 0)
         vertical_index = 5;
    else vertical_index = -1;            

    g_print("vertical_index wynosi %d\n", vertical_index);

    cbo = GTK_COMBO(lookup_widget(frm_scatter, "cbo_horizontal"));
    cbo_text = gtk_entry_get_text(GTK_ENTRY(cbo->entry)); 
    g_print("horizontal axis is %s\n", cbo_text);

    if (g_strcasecmp(cbo_text, "Liczba sztuk") == 0)
         horizontal_index = 1;
    else if (g_strcasecmp(cbo_text, "Cena jednostkowa") == 0)
         horizontal_index = 2;
    else if (g_strcasecmp(cbo_text, "Wartosc netto") == 0)
         horizontal_index = 3;
    else if (g_strcasecmp(cbo_text, "Liczba towarow na fakturze") == 0)
         horizontal_index = 4;
    else if (g_strcasecmp(cbo_text, "Wartosc faktury") == 0)
         horizontal_index = 5;
    else horizontal_index = -1;          

    g_print("horizontal_index wynosi %d\n", horizontal_index);

}

gboolean load_data()
{   /* Ta funkcja laczy sie z baza danych i odczytuje dane, 
     * ktore maja znalezc sie na wykresie. W naszym
     * przypadku bedziemy korzystac z okolo 4000 rekordow.
     * Dane bedziemy ponierac tylko raz.
     * 
     * Po zakonczeniu ladowania danych nastepuje sprawdzenie,
     * czy proces ladowania przebiegl pomyslnie. Jesli tak, to zmienna
     * already_loaded przyjmie wartosc TRUE
     *
     * Funkcja zwraca wartosc TRUE, jesli dane zaladowano poprawnie,
     * lub jesli moga byc zaladowane poprawnie.
     */


   static gboolean already_loaded = FALSE;

   if (already_loaded)
     {
        g_print("Dane sa juz zaladowane.\n");
        return TRUE;
     }

   conx = mysql_init(0L);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1,"problem w mysql_init ");
        return FALSE;
     }
   /* else continue on... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1, "mysql_init ok");

   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1,"problem w mysql_real_connect ");
        return FALSE;
     }
   /* else continue on... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1, "mysql_real_connect ok");

   sql = g_strconcat("select nr_wiersza, liczba_sztuk, ",
                     "       cena_jedn, wart_netto, ",
                     "       liczba_faktur, wartosc_faktury ",
                     "  from tbl_place ",
                     "  order by nr_wiersza", 0L);

   g_print("sql  %s\n", sql);

   if (mysql_query (conx, sql) != 0)
      {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1,"mysql_query problem");
        g_print("problem z mysql_query  w load_data.\n");
        mysql_close(conx);
        return FALSE;
      }
   /* else continue... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1, "mysql_query ok");

   result_set = mysql_store_result(conx);

   mysql_close(conx);

   already_loaded = TRUE;
   return TRUE;

}
