/* listing 2.2
 * Prezentacja podstawowych widgetow
 * Etykieta, przycisk, przelacznik, przyciski opcji
 * i wyboru, oraz obiekty List i CList.
 * Ten program sluzy do zademonstrowania dzialania
 * tych widgetow.
 */

#include <gtk/gtk.h>

/* To sa zmienne wskazujace na okna najwyzszego poziomu. Tylko te zmienne
 * wskaznikowe powinny miec zasieg globalny, ale w tym programie
 * chodzi tylko o demonstracje dzialania widgetow, wiec
 * wszystkie zmienne wskaznikowe zostaly zadeklarowane jako zmienne globalne,
 * czego nie nalezy robic w prawdziwych aplikacjach.  */

GtkWidget *frm_main;
GtkWidget *frm_buttons;
GtkWidget *frm_text_entry;
GtkWidget *frm_list_widgets;

/* ================ glowne okno ======================= */

void destroy_main(GtkWidget *frm_main, gpointer data);
void show_frm_buttons();
void show_frm_text_entry();
void show_frm_list_widgets();

void MsgBox(gpointer gdata);

gint main(gint argc, gchar * argv[])
{
	GtkWidget *vbox;
	GtkWidget *cmd_buttons;
	GtkWidget *cmd_text_entry;
	GtkWidget *cmd_list_widgets;

	gtk_init(&argc, &argv);
	frm_main = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	/* ostatnia linijka tego komentarza jest instrukcja umozliwiajaca ustalenie
	 * rozmiaru okna w pikselach.  Bez tej instrukcji otrzymamy okno
	 * o najmniejszych, mozliwych wymiarach, umozliwiajacych wyswietlenie jego obiektow potomnych.  */
	/* gtk_window_set_default_size(GTK_WINDOW(frm_main), 200, 300); */
	gtk_window_set_title(GTK_WINDOW(frm_main), "Demonstracja dzialania widgetow");
	/*Utworzenie egzemplarza pionowego prostokata, w ktorym zostana umieszczone trzy przyciski. 
	To bedzie glowny obiekt kontrolny programu.*/
	vbox = gtk_vbox_new(TRUE, 0);
	cmd_buttons = gtk_button_new_with_label("Przyciski");
	cmd_text_entry = gtk_button_new_with_label("Pole tekstowe i pole tekstowe - jednowierszowe");
	cmd_list_widgets = gtk_button_new_with_label("Obiekty List i CList");

	gtk_signal_connect(GTK_OBJECT(cmd_buttons),
					"clicked",
					GTK_SIGNAL_FUNC(show_frm_buttons),
					NULL);
	gtk_signal_connect(GTK_OBJECT(cmd_text_entry),
					"clicked",
					GTK_SIGNAL_FUNC(show_frm_text_entry),
					NULL);
	gtk_signal_connect(GTK_OBJECT(cmd_list_widgets),
					"clicked",
					GTK_SIGNAL_FUNC(show_frm_list_widgets),
					NULL);
	gtk_signal_connect(GTK_OBJECT(frm_main),
			"destroy",
			GTK_SIGNAL_FUNC (destroy_main),
			NULL);
	/* Umieszczenie przyciskow w prostokacie poziomym*/
	gtk_box_pack_start(GTK_BOX(vbox), cmd_buttons, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), cmd_text_entry, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), cmd_list_widgets, TRUE, TRUE, 0);
	gtk_container_add(GTK_CONTAINER(frm_main), vbox);
	/*Wyswietlenie glownego okna, przekazanie sterowania do gtk_main();
	*/
	gtk_widget_show_all (frm_main);
	gtk_main ();
	return 0;
}


void destroy_main(GtkWidget * frm_main, gpointer data)

{  	gtk_main_quit(); }

/*=================== Funkcje uzytkowe =================== */

void MsgBox(gpointer gdata)
{
	GtkWidget *msg_box_window;
	GtkWidget *vbox;
	GtkWidget *top_label;

	/* moglibysmy tu umiescic przycisk zamykajacy program OK
	 * ale ten program demonstracyjny
	 * zamkniemy przyciskiem X ktory jest w prawym, gornym rogu okna.  */

	msg_box_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_default_size(GTK_WINDOW(msg_box_window), 150, 100);
	gtk_window_set_title(GTK_WINDOW(msg_box_window), "Okno informacyjne");
	gtk_window_set_modal(GTK_WINDOW(msg_box_window), TRUE);

	g_print("Utworzono okno informacyjne...\n");

	/* Dla tak prostego programu wlasciwie nie trzeba stosowac pojemnika
	 * Ale dzieki niemu
	 * bedzie mozna latwiej dodac inne widgety
  	 * np. przycisk OK.
 	 */

	vbox = gtk_vbox_new(TRUE, 0);
	top_label = gtk_label_new("to jest etykieta");
	gtk_label_set_text(GTK_LABEL(top_label), gdata);

	g_print("utworzono widgety potomne...\n");

	gtk_box_pack_start(GTK_BOX(vbox), top_label, TRUE, TRUE, 0);
	gtk_container_add( GTK_CONTAINER(msg_box_window), vbox);

	gtk_widget_show_all (msg_box_window);
}

/* ================= okno prezentujace przyciski ================== */

/* ponizsze wskazniki na widgety maja zasieg globalny, co nie jest
 * dobrym sposobem.
 * Wlasciwa obsluga widgetow potomnych jest opisana w funkcji  
 *"lookup widget", umieszczonej w support.csekcji Glade.*/

GtkWidget *lbl_second;
GtkWidget *toggle_third;
GtkWidget *chk_button;

/* zdarzenia przyciskow */
void cmd_top_clicked();
void cmd_top_pressed();
void cmd_top_released();
void cmd_top_enter();
void cmd_top_leave();

/* zdarzenia przelacznikow */
void toggle_third_toggled();
void toggle_third_clicked();
void cmd_toggle_state_clicked();
void cmd_toggle_up_or_down_clicked();
void cmd_toggle_up_clicked();
void cmd_toggle_down_clicked();

/* Funkcje dla pol wyboru */
void cmd_chk_button_state_clicked();

void show_frm_buttons() {
/* Ta funkcja sluzy do tworzenia i wyswietlenia okna 
 *prezentujacego przyciski, ktore pokazano na rysunku 2.2.*/

		GtkWidget *button_vbox;
		GtkWidget *cmd_top;
		GtkWidget *cmd_toggle_state;
		GtkWidget *cmd_toggle_up_or_down;
		GtkWidget *cmd_toggle_up, *cmd_toggle_down;
		GtkWidget *cmd_chk_button_state;
		GtkWidget *rdo_grp1_btnA, *rdo_grp1_btnB, *rdo_grp1_btnC;
		GtkWidget *rdo_grp2_btnA, *rdo_grp2_btnB, *rdo_grp2_btnC;

		/* Grupawanie przyciskow opcji  */

		GSList *grp1 = NULL;

		/* nalezy zauwazyc, ze okno nie jest utworzone az do momentu
		 * wcisniecia przycisku przez uzytkownika. */
		frm_buttons = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(frm_buttons), "Prezentacja przyciskow");

		button_vbox = gtk_vbox_new(TRUE, 0);

		cmd_top = gtk_button_new_with_label("Ten przycisk pokazuje wystepowanie zdarzenia");

		/* podlaczenie sygnalow do odpowiednich funkcji . */
		/* tu mamy 5 sygnalow dla przyciskow. */
	    gtk_signal_connect(GTK_OBJECT(cmd_top),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_top_clicked),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_top),
					"pressed",
					GTK_SIGNAL_FUNC(cmd_top_pressed),
					NULL);
		/* uwaga:  gdy uzytkownik wcisnie przycisk, to zdarzenie clicked
		 * wystapi jeszcze przed zwolnieniem przycisku */
	    gtk_signal_connect(GTK_OBJECT (cmd_top),
					"released",
					GTK_SIGNAL_FUNC(cmd_top_released),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_top),
					"enter",
					GTK_SIGNAL_FUNC(cmd_top_enter),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_top),
					"leave",
					GTK_SIGNAL_FUNC(cmd_top_leave),
					NULL);
		/* sekwencja zdarzen przycisku jest nastepujaca:  entered,
		 * pressed, clicked, released, leave. */

		lbl_second = gtk_label_new("To jest etykieta. Etykieta nie generuje zadnych zdarzen.");

		toggle_third = gtk_toggle_button_new_with_label("To jest przelacznik.");

		/* Przelacznik jest obiektem pochodnym wzgledem przycisku co sprawia,
		 * ze moze generowac takie same zdarzenia, co przycisk i dodatkowe zdarzenie
		 * toggled. Zademonstrowano tu jednak tylko
		 * zdarzenia toggeld i clicked. */

	    gtk_signal_connect(GTK_OBJECT(toggle_third),
					"toggled",
					GTK_SIGNAL_FUNC(toggle_third_toggled),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(toggle_third),
					"clicked",
					GTK_SIGNAL_FUNC(toggle_third_clicked),
					NULL);
		/* uwaga:  gdy uzytkownik wcisnie przycisk, to zdarzenie clicked
		 * wystapi jeszcze przed zwolnieniem przycisku, co sprawia, ze
		 * zdarzenia nastepuja w sekwencji entered, pressed, toggled, clicked,
		 * released, leave. */

		/* przycisk sprawdzajacy stan przelacznika */
		cmd_toggle_state = gtk_button_new_with_label
				("Jaki jest stan przelacznika?");
	    gtk_signal_connect(GTK_OBJECT(cmd_toggle_state),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_toggle_state_clicked),
					NULL);

		/* Oto kolejny przycisk, dzieki ktoremu mozna przelaczyc przelacznik, niezaleznie
		 * od jego stanu  */
		cmd_toggle_up_or_down = gtk_button_new_with_label("Toggle to other position.");
	    gtk_signal_connect(GTK_OBJECT(cmd_toggle_up_or_down),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_toggle_up_or_down_clicked),
					NULL);
		/*Kolejne dwa przyciski sluza do ustawienia przelacznika
		w jednym z dwoch sanow: gora (UP) albo dol (DOWN)*/

		cmd_toggle_up = gtk_button_new_with_label("Przelacznik w gore!");
		cmd_toggle_down = gtk_button_new_with_label("Przelacznik w dol!");
	    gtk_signal_connect(GTK_OBJECT(cmd_toggle_up),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_toggle_up_clicked),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_toggle_down),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_toggle_down_clicked),
					NULL);

		/* teraz zajmiemy sie przyciskiem wyboru... najpierw go utworzymy,
		 * a nastepnie zademonstrujemy.*/
		chk_button = gtk_check_button_new_with_label("Oto przycisk wyboru.");
		cmd_chk_button_state = gtk_button_new_with_label
				("Jaki jest stan przycisku wyboru?");
	    gtk_signal_connect(GTK_OBJECT(cmd_chk_button_state),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_chk_button_state_clicked),
					NULL);

		/* Na koniec umiescimy kontrolke z przyciskami opcji.
		 * Przyciski podzielimy na dwie grupy:
		 * jedna z nich utworzymy recznie, a druga - w sposob automatyczny
		 * najpierw pierwsza grupa...
		 *
		 * Dla kazdego z trzech przyciskowistnieja dwie linijki kodu. W pierwszej
		 * przycisk jest tworzony, a w drugiej - dodawany do pierwszej grupy grp1.
		 * Nalezy pamietac, ze grp1 jest typu GSList.  */

		rdo_grp1_btnA = gtk_radio_button_new_with_label(grp1, "Grupa pierwsza, opcja A");
		grp1 = gtk_radio_button_group(GTK_RADIO_BUTTON(rdo_grp1_btnA));

		rdo_grp1_btnB = gtk_radio_button_new_with_label(grp1, "Grupa pierwsza, opcja B");
		grp1 = gtk_radio_button_group(GTK_RADIO_BUTTON(rdo_grp1_btnB));

		rdo_grp1_btnC = gtk_radio_button_new_with_label(grp1, "Grupa pierwsza, opcja C");
		grp1 = gtk_radio_button_group(GTK_RADIO_BUTTON(rdo_grp1_btnC));

		/* Powyzsze przyciski zostana pozniej umieszczone na dole pojemnika prostokatnego
		 *
		 *
		 * Teraz umiescimy druga grupe przyciskow opcji....  */

		rdo_grp2_btnA = gtk_radio_button_new_with_label(NULL, "Grupa druga, opcja A");

		/* Gdy utworzymy przycisk opcji z parametrem NULL
		 * , GTK+ utworzy domyslnie grupe przyciskow.  Aby dodac kolejny
		 * przycisk do istniejacej grupy, to trzeba przekazac
		 * nazwe pierwszego przeycisku funkcji tworzacej kolejny.
		 * co pokazano ponizej... */
		
		rdo_grp2_btnB = gtk_radio_button_new_with_label
				(gtk_radio_button_group(GTK_RADIO_BUTTON(rdo_grp2_btnA)),
				 "Grupa druga, opcja B");
		rdo_grp2_btnC = gtk_radio_button_new_with_label
				(gtk_radio_button_group(GTK_RADIO_BUTTON(rdo_grp2_btnA)),
				"Grupa druga, opcja C");
		
		/* Ponizsze instrukcje sluza do umieszczenia wczesniej utworzonych obiektow
		 * w kontenerze. Nie deklarujemy tu liczby wprowadzanych elementow -
		 * widgety potomne sa umieszczane dynamicznie w obiekcie vbox.  */

		gtk_box_pack_start(GTK_BOX(button_vbox), cmd_top, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), lbl_second, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), toggle_third, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), cmd_toggle_state, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), cmd_toggle_up_or_down, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), cmd_toggle_up, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), cmd_toggle_down, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), chk_button, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), cmd_chk_button_state, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), rdo_grp1_btnA, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), rdo_grp1_btnB, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), rdo_grp1_btnC, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), rdo_grp2_btnA, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), rdo_grp2_btnB, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(button_vbox), rdo_grp2_btnC, TRUE, TRUE, 0);

		gtk_container_add(GTK_CONTAINER(frm_buttons), button_vbox);

		gtk_widget_show_all(frm_buttons);

}
/* Kolejnych piec funkcji sluzy do demonstracji sekwencji zdarzen przycisku*/
void cmd_top_clicked()
{
		g_print("w cmd_top wystapilo zdarzenie clicked\n");
}
void cmd_top_pressed()
{
		g_print("w cmd_top wystapilo zdarzenie pressed\n");
}

void cmd_top_released()
{
		g_print("w cmd_top wystapilo zdarzenie released\n");
}

void cmd_top_enter()
{
		g_print("w cmd_top wystapilo zdarzenie entered\n");
}

void cmd_top_leave()
{
		g_print("w cmd_top wystapilo zdarzenie leave\n");
}

void toggle_third_toggled()
{
		g_print("przelaczono przelacznik\n");
}

void toggle_third_clicked()
{
		static gint count_toggles = 0;

		count_toggles++;

		g_print("wcisnieto przelacznik, count_toggles to liczba przelaczen: %d\n", count_toggles);
		/*Nalezy zauwazyc, ze ostatnim argumentem wywolania powyzszej 
		funkcji jest NULL, co jest przez ta funkcje wymagane. */
		gtk_label_set_text(GTK_LABEL(lbl_second),
					   	   g_strconcat("Przelaczono przelacznik ", " raz(y)", NULL));
}

void cmd_toggle_state_clicked()
{
	if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle_third)) )
		MsgBox("Przelacznik jest w pozycji dolnej.");
	else
		MsgBox("Przelacznik jest w pozycji gornej");
}

void cmd_toggle_up_or_down_clicked()
{
	g_print("nastepuje przelaczanie obiektu toggle_third...\n");
	gtk_toggle_button_toggled(GTK_TOGGLE_BUTTON(toggle_third));
}

/* ponizsze dwie funkcje rowniez generuja zdarzenie toggled */
void cmd_toggle_up_clicked()
{
		/* w tym przypadku, "set_active" oznacza "wcisniety" */
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_third), FALSE);
}

void cmd_toggle_down_clicked()
{
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_third), TRUE);
}

void cmd_chk_button_state_clicked()
{
	/* Przycisk opcji nie posiada funkcji "get_active". Dlatego tez, aby
	 * odczytac pozadana informacje nalezy skorzystac z funkcji toggle_button_get_active.
	 * Mozna z tej funkcji skorzystac dlatego, ze przycisk wyboru jest
	 * "pierwszym potomkiem" przelacznika.  Mozna powiedziec, ze przycisk wyboru
	 * jest przelacznikiem, wyswietlonym w inny sposob.
	 * Dzieki dziedziczeniu tej funkcji zaoszczedzono programistom klopotu
	 * z tworzeniem funkcji "check_button_get_active"
	 *
	 * Makro GTK_TOGGLE_BUTTON "otaczajace" chk_button, "podnosi" tymczasowo
	 * obiekt chk_button do rangi przelacznika, dzieki czemu mozna zastosowac te funkcje.
	 * chk_button nadal jest przyciskiem wyboru, ale ta funkcje mozna zastosowac
	 * tylko z przelacznikiem, dlatego tez skorzystalismy z tego makra.  */


	if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_button)) )
		MsgBox("Przycisk wyboru jest w pozycji dolnej.");
	else
		MsgBox("Przycisk wyboru jest w pozycji gornej.");
}

/* =================== Pola tekstowe (jedno- i wielowierszowe) ================*/

GtkWidget *entry_1;
GtkWidget *text_1;
GtkWidget *opt_text, *opt_entry;
GtkWidget *target_widget;
GtkWidget *spin_start, *spin_end;

void cmd_vis_true_clicked();
void cmd_vis_false_clicked();
void cmd_line_wrap_true_clicked();
void cmd_line_wrap_false_clicked();
void cmd_word_wrap_true_clicked();
void cmd_word_wrap_false_clicked();
void cmd_editable_true_clicked();
void cmd_editable_false_clicked();
void cmd_editable_get_chars_clicked();

void show_frm_text_entry()
{
/*Ta funkcja sluzy do utworzenia i wyswietlenia okna pokazanego na rysunku 2.2,
* "Pola tekstowe"
*/
		GtkWidget *main_hbox;
		GtkWidget *text_entry_vbox, *text_vbox;
		GtkWidget *lbl_entry, *lbl_text;
		GtkWidget *cmd_vis_true, *cmd_vis_false;
		GtkWidget *cmd_line_wrap_true, *cmd_line_wrap_false;
		GtkWidget *cmd_word_wrap_true, *cmd_word_wrap_false;
		GtkWidget *cmd_editable_true, *cmd_editable_false;
		GtkWidget *cmd_editable_get_chars;
		GtkWidget *get_chars_hbox;
		GtkWidget *lbl_get_chars, *lbl_to;

		/* Nalezy zauwazyc, ze ponizsze obiekty regulacyjne sa typu
		 *  GtkObject, a nie GtkWidget.  Definicja regulacji
		 * jest obiektem, wiec zadeklarowanie jej jako obiekt
		 * pozwala na unikniecie wystapienia bledu zwiazanego z
		 * niepoprawna operacja rzutowania, ktory moglby
		 * wystapic w trakcie kompilacji.  Gdybysmy zadeklarowali ten
		 * obiekt jako typu  GtkWidget, program skompilowalby sie i uruchomil
		 * ale moglby dzialac niezgodnie z naszymi oczekiwaniami. */

		GtkObject *spin_start_adjustment, *spin_end_adjustment;

		frm_text_entry = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(frm_text_entry),
						"Prezentacja pol tekstowych");

		/* ponizej utworzono trzy obiekty-pojemniki.
		 * main_hbox dzieli ekran na dwie polowy (prawa i lewa).
		 * text_entry_vbox umozliwia umieszczenie pionowej kolumny obiektow
		 * w lewej czesci, a text_vbox zawiera widget GtkText
		 * widoczny w prawej czesci ekranu. */

		main_hbox = gtk_hbox_new(TRUE, 0);
		text_entry_vbox = gtk_vbox_new(TRUE, 0);
		text_vbox = gtk_vbox_new(TRUE, 0);

		lbl_text = gtk_label_new("Po prawej stronie znajduje sie pole tekstowe (GtkText).");
		lbl_entry = gtk_label_new("Ponizej jest jednowierszowe pole tekstowe (GtkEntry");

		/* Glowna roznica miedzy obiektem GtkEntry a
		 * GtkText jest fakt, ze ten drugi stanowi
		 * jednowierszowe pole tekstowe, podczas gdy GtkText moze
		 * wyswietlic wiele wierszy tekstu.
		 *
		 * Najpierw zajmiemy sie widgetem GtkEntry . */

		entry_1 = gtk_entry_new();

		/* Mozemy zainicjowac to pole tekstem, ktory bedzie widoczny
		 *po uruchomieniu programu... */

		gtk_entry_set_text(GTK_ENTRY(entry_1), "Oto tekst poczatkowy.");

		cmd_vis_true = gtk_button_new_with_label("Set Entry Visibility = True");
		cmd_vis_false = gtk_button_new_with_label("Set Entry Visibility = False");
		/*Oto funkcje zwrotne dla dwoch powyzszych przyciskow*/

	    gtk_signal_connect(GTK_OBJECT(cmd_vis_true),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_vis_true_clicked),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_vis_false),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_vis_false_clicked),
					NULL);

		/* Teraz zajmiemy sie obiektem GtkText */

		text_1 = gtk_text_new(NULL, NULL);
		gtk_text_insert(GTK_TEXT(text_1), NULL, NULL, NULL,
						"Oto tekst poczatkowy pola tekstowego. Gdy uzytkownik zmieni rozmiary okna,  GtkText rozbije lancuch znakow nie uwzgledniajac slow.", -1);

		/* W GtkText domyslna opcja jest otaczanie wiersza tekstu. */
		cmd_line_wrap_true = gtk_button_new_with_label("Ustawienie opcji Text Line Wrap = True");
		cmd_line_wrap_false = gtk_button_new_with_label("Ustawienie opcji Text Line Wrap = False");

	    gtk_signal_connect(GTK_OBJECT(cmd_line_wrap_true),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_line_wrap_true_clicked),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_line_wrap_false),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_line_wrap_false_clicked),
					NULL);

		/* W GtkText  domyslna opcja jest nieotaczanie slow tekstu. */
		cmd_word_wrap_true = gtk_button_new_with_label("Ustawienie opcji Text Word Wrap = True");
		cmd_word_wrap_false = gtk_button_new_with_label("Ustawienie opcji Text Word Wrap = False");

	    gtk_signal_connect(GTK_OBJECT(cmd_word_wrap_true),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_word_wrap_true_clicked),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_word_wrap_false),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_word_wrap_false_clicked),
					NULL);

		opt_entry = gtk_radio_button_new_with_label(NULL, "Uaktywniono jednowierszowe pole tekstowe.");
		opt_text  = gtk_radio_button_new_with_label
				(gtk_radio_button_group(GTK_RADIO_BUTTON(opt_entry)),
				 "Uaktywniono pole tekstowe.");

		cmd_editable_true = gtk_button_new_with_label("Ustawienie opcji Editable = True");
	    gtk_signal_connect(GTK_OBJECT(cmd_editable_true),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_editable_true_clicked),
					NULL);

		cmd_editable_false = gtk_button_new_with_label("Ustawienie opcji Editable = False");
	    gtk_signal_connect(GTK_OBJECT(cmd_editable_false),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_editable_false_clicked),
					NULL);

		/* ponizej zastosowano  dwa pola przewijane, ktore wykorzystano do
		 * wyciecia odpowiedniej porcji tekstu z obiektu gtk_editable
		 *
		 *
		 * Najpierw potrzebny jest niewielki, poziomo ustawiony prostokatny pojemnik na dwa nowe pola. */

		get_chars_hbox = gtk_hbox_new(FALSE, 0);

		/* Najlepiej korzystac z pol przewijanych wraz z obiektem
		 * regulacyjnym (patrz: deklaracje obiektow w gornej czesci funkcji).
		 *  Obiekt regulacyjny modyfikuje zachowanie sie pola przwijanego,
		 * dzieki czemu mozemy ustawic wartosc minimalna maksymalna, domyslna, itd.
		 * niezaleznie od samego obiektu listy przewijanej.  Nalezy zwrocic uwage na parametry
		 * funkcji gtk_adjustment_new, ktore sa wartosciami typu gfloat.
		 * Nic nie stoi na przeszkodzie, zeby wykorzystac liczby calkowite.
		 *
		 * Kolejna uwaga:  jeden obiekt regulacyjny mozna wykorzystac w
		 * wielu polach przewijanych, ale wowczas beda one zalezne od siebie.
		 * regulacja jednego pola pociagnie za soba zmiany
		 * w pozostalych polach */

		spin_start_adjustment = gtk_adjustment_new(1.0, 1.0, 99.0, 1.0, 1.0, 1.0);
		spin_end_adjustment = gtk_adjustment_new(1, 2, 99, 1, 1, 1);
		lbl_get_chars = gtk_label_new("Pobierz znaki od");
		spin_start = gtk_spin_button_new(GTK_ADJUSTMENT(spin_start_adjustment), 1.0, 0);
		lbl_to = gtk_label_new(" do ");
		spin_end = gtk_spin_button_new(GTK_ADJUSTMENT(spin_end_adjustment), 1.0, 0);

		cmd_editable_get_chars = gtk_button_new_with_label("Pobierz wybrane znaki");
	    gtk_signal_connect(GTK_OBJECT(cmd_editable_get_chars),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_editable_get_chars_clicked),
					NULL);

		gtk_box_pack_start(GTK_BOX(get_chars_hbox), lbl_get_chars, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(get_chars_hbox), spin_start, FALSE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(get_chars_hbox), lbl_to, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(get_chars_hbox), spin_end, FALSE, TRUE, 0);

		gtk_box_pack_start(GTK_BOX(text_entry_vbox), lbl_text, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), lbl_entry, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), entry_1, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_vis_true, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_vis_false, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_line_wrap_true, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_line_wrap_false, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_word_wrap_true, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_word_wrap_false, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), opt_entry, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), opt_text, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_editable_true, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_editable_false, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), get_chars_hbox, FALSE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(text_entry_vbox), cmd_editable_get_chars, TRUE, TRUE, 0);

		gtk_box_pack_start(GTK_BOX(text_vbox), text_1, TRUE, TRUE, 0);

		gtk_box_pack_start(GTK_BOX(main_hbox), text_entry_vbox, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(main_hbox), text_vbox, TRUE, TRUE, 0);
		gtk_container_add(GTK_CONTAINER(frm_text_entry), main_hbox);

		gtk_widget_show_all(frm_text_entry);
}

void cmd_vis_true_clicked()
{
		gtk_entry_set_visibility(GTK_ENTRY(entry_1), TRUE);
		g_print("Wlasciwosc odpowiedzialna za widocznosc obiektu entry_1 ma wartosc True.\n");
}

void cmd_vis_false_clicked()
{
		gtk_entry_set_visibility(GTK_ENTRY(entry_1), FALSE);
		g_print("Wlasciwosc odpowiedzialna za widocznosc obiektu entry_1 ma wartosc False.\n");
}


void cmd_line_wrap_true_clicked()
{
	gtk_text_set_line_wrap(GTK_TEXT(text_1), TRUE);
}

void cmd_line_wrap_false_clicked()
{
	gtk_text_set_line_wrap(GTK_TEXT(text_1), FALSE);
}

void cmd_word_wrap_true_clicked()
{
	gtk_text_set_word_wrap(GTK_TEXT(text_1), TRUE);
}

void cmd_word_wrap_false_clicked()
{
	gtk_text_set_word_wrap(GTK_TEXT(text_1), FALSE);
}

void cmd_editable_true_clicked()
{
	if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(opt_entry)) )
	{
		gtk_editable_set_editable(GTK_EDITABLE(entry_1), TRUE);
		MsgBox("Jednowierszowe pole tekstowe\nw lewym, gornym rogu\njest gotowe do uzycia.");
	}
	else
	{
		gtk_editable_set_editable(GTK_EDITABLE(text_1), TRUE);
		MsgBox("Pole tekstowe\njest gotowe do uzycia.");
	}
}

void cmd_editable_false_clicked()
{
	if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(opt_entry)) )
	{
		gtk_editable_set_editable(GTK_EDITABLE(entry_1), FALSE);
		MsgBox("Nie  \nmozna\nskorzystac z pola\nw lewym, gornym\nrogu.");
	}
	else
	{
		gtk_editable_set_editable(GTK_EDITABLE(text_1), FALSE);
		MsgBox("Nie  \nmozna\nskorzystac z pola\ntekstowego.");
	}
}

void cmd_editable_get_chars_clicked()
{
	if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(opt_entry)) )
	{
		/* Uwaga:  Poniewaz gtk_editable_get_chars nie zawiera znaku
		 * jako drugi parametr, to trzeba bedzie cofnac sie o jedna pozycje, aby
		 * wyswietlic wlasciwa liczbe znakow.  Na przyklad, jesli uzytkownik wybierze znaki od
		 * 1. do 4., to funkcja domyslnie zwroci tylko znaki od 2. do 4. 
		 * jedna z zalet wykorzystywania pol przewijanych jest fakt, ze posiadaja funkcje zwracajace
		 * wartosci calkowite. Gdybysmy skorzystali tu z jednowierszowego pola tekstowego, musieli-
		 * bysmy samodzielnie dokonac konwersji typow*/
		MsgBox(g_strconcat("Wybrane znaki z \njednowierszowego pola to: ",
					gtk_editable_get_chars(GTK_EDITABLE(entry_1),
							gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin_start)) - 1,
							gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin_end))),
					NULL));
	}
	else
	{
		MsgBox(g_strconcat("Wybrane znaki z\npola tekstowego to: ",
					gtk_editable_get_chars(GTK_EDITABLE(text_1),
							gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin_start)) - 1,
							gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin_end))),
					NULL));
	}

}

/* ====================== prezentacja obiektow List i CList ===========================*/

void cmd_add_checkbox_clicked();
void cmd_add_pixmap_clicked();
void cmd_SINGLE_clicked();
void cmd_BROWSE_clicked();
void cmd_MULTIPLE_clicked();
void cmd_EXTENDED_clicked();

void cmd_prepend_clicked();
void cmd_append_clicked();
void cmd_insert_row_2_clicked();
void cmd_set_text_clicked();
void cmd_set_pixmap_clicked();
void cmd_set_pixtext_clicked();
void cmd_sort_clicked();

GtkWidget *list_left;
GtkWidget *clist_right;

/* Ponizsze tablice sluza nam jako dane dla obiektu CList.
 * Nalezy zauwazyc, ze liczba elementow tablicy
 * musi zgadzac sie z liczba elementow obiektu CList.
 */

gchar *a_row[3] = {"pusty", "", ""};

void show_frm_list_widgets()
{
		/*Ta funkcja tworzy i wyswietla okno 
		 *zatytulowane "Prezentacja obiektow List i CList",
		 *ktore pokazano na rysunku 2.2.*/
		GtkWidget *lists_hbox;  
		/* Obiekt List po lewej, a CList po prawej stronie. */
		GtkWidget *lbl_list_box, *lbl_clist_box;
		GtkWidget *vbox_left, *vbox_right;
		GtkWidget *cmd_SINGLE, *cmd_BROWSE, *cmd_MULTIPLE, *cmd_EXTENDED;
		GtkWidget *cmd_add_checkbox;
		GtkWidget *cmd_add_pixmap;
		GtkWidget *cmd_append, *cmd_prepend, *cmd_insert_row_2;
		GtkWidget *cmd_set_text, *cmd_set_pixmap, *cmd_set_pixtext;
		GtkWidget *cmd_sort;

		/* Oto tablca naglowkow dla obiektu CList. */
		gchar *col_heads[3] = {"Autor", "Tytul", "Rok"};

		GList *list_box_items = NULL;

		frm_list_widgets = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(frm_list_widgets), 
						"List and CList Demo Form");

		/* Oto glowne obiekty umieszczone w oknie.*/

		lists_hbox = gtk_hbox_new(TRUE, 0);

		lbl_list_box = gtk_label_new("Ponizej znajduje sie obiekt List.");
		lbl_clist_box = gtk_label_new("... a to jest obiekt CList.");

		vbox_left = gtk_vbox_new(FALSE, 0);
		vbox_right = gtk_vbox_new(FALSE, 0);

		list_left = gtk_list_new();

		/* Skupmy sie teraz na obiekcie List. */

		/* Bardzo duza zaleta obiektu CList jest mozliwosc
		 * umieszczenia w nim dowolnego widgeta.  Warto podkreslic 
		 * tu slowo DOWOLNEGO. Najczesciej umieszca sie w nich
		 * etykiety, pixmapy (Linuxowe odpowiedniki ikon),
		 * pola wyboru.  Takich obiektow spodziewamy sie w
		 * obiekcie List.  Czy slowo DOWOLNY oznacza, ze mozna tu umiescic nawet okno?
		 * Albo kilka obiektow CList?
		 * Autor nie probowal eksperymentow z takimi,
		 * nietypowymi obiektami w widgecie List,
		 * ale nigdy nie wiadomo, czy to sie
		 * kiedys nie przyda.
		 *
		 */

		/* Lista elementow umieszczonych w obiekcie List
		 * stanowi jeden, niezalezny od samego obiektu List, obiekt,
		 * ktory jest tylko "podlaczony" do obiektu List.
		 * W gornej czesci niniejszej funkcji zadeklarowalismy obiekt GList
		 * o nazwie list_box_items.  Taki obiekt jest wypelniany "elementami
		 * listy".  Poniewaz "lista etykiet" jest bardzo czesto spotykanym obiektem
		 * w GTK+ umieszczobno specjalna funkcje, ktorej zadaniem jest
		 * dodanie obiektow "listy elementow":  gtk_list_item_new_with_label().
		 * Utworzymy obiekt GList, a nastepnie wypelnimy go widgetami GtkListItem
		 *
		 */

		list_box_items = g_list_append(list_box_items,
						    gtk_list_item_new_with_label("list item 1"));
		list_box_items = g_list_append(list_box_items,
						    gtk_list_item_new_with_label("list item 2"));
		list_box_items = g_list_append(list_box_items,
						    gtk_list_item_new_with_label("list item 3"));

		/* Gdy juz mamy obiekt GList zawierajacy obiekty  GtkListItem,
		 * mozemy cala liste wrzucic do wczesniej utworzonego obiektu GtkListBox
		 *
		 */

		g_print("Rozpoczeto dodawanie elementow listy...\n");

		gtk_list_append_items(GTK_LIST(list_left), list_box_items);

		/* To bylo w miare proste zadanie.  Zobaczmy, czy oprocz etykiet
		 * nie mozemy umiescic w liscie innych obiektow
		 *
		 * Niech to bedzie pole wyboru
		 */

		cmd_add_checkbox = gtk_button_new_with_label("Dodanie pola wyboru.");
	    gtk_signal_connect(GTK_OBJECT(cmd_add_checkbox),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_add_checkbox_clicked),
					NULL);

		/* a pixmapa? */
		cmd_add_pixmap = gtk_button_new_with_label("Dodanie pixmapy.");
	    gtk_signal_connect(GTK_OBJECT(cmd_add_pixmap),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_add_pixmap_clicked),
					NULL);

		/* przyciski, dzieki ktorym mozna wybrac tryb wybierania elementow obiektu List */

		cmd_SINGLE = gtk_button_new_with_label("Ustaw tryb wybierania SINGLE");
		cmd_BROWSE = gtk_button_new_with_label("Ustaw tryb wybierania BROWSE");
		cmd_MULTIPLE = gtk_button_new_with_label("Ustaw tryb wybierania MULTIPLE");
		cmd_EXTENDED = gtk_button_new_with_label("Ustaw tryb wybierania EXTENDED");

	    gtk_signal_connect(GTK_OBJECT(cmd_SINGLE),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_SINGLE_clicked),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_BROWSE),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_BROWSE_clicked),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_MULTIPLE),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_MULTIPLE_clicked),
					NULL);
	    gtk_signal_connect(GTK_OBJECT(cmd_EXTENDED),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_EXTENDED_clicked),
					NULL);

		/* Teraz skorzystamy z widgeta CList.
		 *
		 * Jest to najbardziej przystosowany obiekt GTK+ do pracy
		 * z danymi. Jedynym problemem, jaki trzeba rozwiazac samodzielnie
		 * jest nawiazanie polaczenia z baza danych.
		 *
		 * W przeciwienstwie do obiektu List, ktory akceptuje niemal
		 * kazdy widget w liscie,  CList ogranicza sie do przyjmowania
		 * tekstu i pixmap.
		 *
		 * Nalezy zauwazyc, ze CList moze pracowac
		 * w tych samych trybach, co List.
		 */

		clist_right = gtk_clist_new_with_titles(3, col_heads); 

		/* Obsluga obiektu CList jest bardzo prosta*/

		gtk_clist_append(GTK_CLIST(clist_right), a_row);

		cmd_append = gtk_button_new_with_label("Dodanie wiersza");
	    gtk_signal_connect(GTK_OBJECT(cmd_append),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_append_clicked),
					NULL);
		cmd_prepend = gtk_button_new_with_label("Usuniecie wiersza");
	    gtk_signal_connect(GTK_OBJECT(cmd_prepend),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_prepend_clicked),
					NULL);
		cmd_insert_row_2 = gtk_button_new_with_label("Wprowadzenie do wiersza 2");
	    gtk_signal_connect(GTK_OBJECT(cmd_insert_row_2),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_insert_row_2_clicked),
					NULL);

		cmd_set_text = gtk_button_new_with_label("Wstawienie 3 wiersza 1 kolumny do tekstu");
	    gtk_signal_connect(GTK_OBJECT(cmd_set_text),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_set_text_clicked),
					NULL);
		cmd_set_pixmap = gtk_button_new_with_label("Wstawienie 3 wiersza 1 kolumny do  pixmapy");
	    gtk_signal_connect(GTK_OBJECT(cmd_set_pixmap),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_set_pixmap_clicked),
					NULL);
		cmd_set_pixtext = gtk_button_new_with_label("Wstawienie 3 wiersza 1 kolumny do PixText");
	    gtk_signal_connect(GTK_OBJECT(cmd_set_pixtext),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_set_pixtext_clicked),
					NULL);

		cmd_sort = gtk_button_new_with_label("Sortowanie kolumny 1");
	    gtk_signal_connect(GTK_OBJECT(cmd_sort),
					"clicked",
					GTK_SIGNAL_FUNC(cmd_sort_clicked),
					NULL);


		/* Na koniec zostal interfejs.  Tak, jak poprzednio,
		 * "zapakujemy" widgety do odpowiednich pojemnikow.  */

		gtk_box_pack_start(GTK_BOX(vbox_left), lbl_list_box, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_left), list_left, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_left), cmd_add_checkbox, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_left), cmd_add_pixmap, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_left), cmd_SINGLE, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_left), cmd_BROWSE, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_left), cmd_MULTIPLE, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_left), cmd_EXTENDED, TRUE, TRUE, 0);
		
		gtk_box_pack_start(GTK_BOX(vbox_right), lbl_clist_box, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_right), clist_right, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_right), cmd_append, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_right), cmd_prepend, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_right), cmd_insert_row_2, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_right), cmd_set_text, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_right), cmd_set_pixmap, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_right), cmd_set_pixtext, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(vbox_right), cmd_sort, TRUE, TRUE, 0);

		gtk_box_pack_start(GTK_BOX(lists_hbox), vbox_left, TRUE, TRUE, 0);
		gtk_box_pack_start(GTK_BOX(lists_hbox), vbox_right, TRUE, TRUE, 0);
		gtk_container_add(GTK_CONTAINER(frm_list_widgets), lists_hbox);

		gtk_widget_show_all(frm_list_widgets);
}

void cmd_add_checkbox_clicked()
{
		GtkWidget *chk_box_item;
		GtkWidget *list_item;

		chk_box_item = gtk_check_button_new_with_label("Element pola wyboru");
		list_item = gtk_list_item_new();
		gtk_container_add(GTK_CONTAINER(list_item), chk_box_item);

		gtk_container_add(GTK_CONTAINER(list_left), list_item);

		/* Ponizsza linijka kodu powoduje odswierzenie formy. */
		gtk_widget_show_all(frm_list_widgets);
}

/* Wyglada na to, ze przyszedl czas na zastosowanie pixmapy, ktora
 * bedzie potrzebna w nastepnej funkcji.
 *
 * Pamietajmy, ze pixmapy mozna tworzyc w oddzielnych plikach, a nastepnie
 * dolaczac je do programu za pomoca instrukcji include.
 *
 * Oto znaczenie danych pixmapy:
 *
 * Pierwsza linijka ("26 7 2 1") oznacza rozmiary i kolorypixmapy.
 * W tym przypadku jest to obiekt o wymiarach 26 x 7 , 2 kolorach, a 1 znak
 * jest potrzebny do wyswietlenia koloru.
 *
 * Nastepne dwie linijki stanowia definicje koloru.  None oznacza
 * brak koloru (przezroczysty), a w drugiej linijce zapisano kolor za pomoca liczby szesnastkowej.
 *
 * Kolejne wiersze zawieraja poszczegolne wartosci umieszczone w cydzyslowach,
 * ktore musza odpowiadac wczesniej zadeklarowanym
 * wartosciom.
 */



static const gchar *pixmap_xpm[] = {
		"26 7 2 1",
		"	c None",
		".	c #AA8800",
       /*123456789.123456789.123456 <-- odstep */
		"                          ",
		" ..  . .   . .   .  .  .. ",
		" . . .  . .  .. .. . . . .",
	    " ..  .   .   . . . ... .. ",
	    " .   .  . .  .   . . . .  ",
	    " .   . .   . .   . . . .  ",
		"                          ",
};

/* Important Safety Tip:  the semicolon on the above
 * line is necessary because the entire pixmap structure
 * above is a single variable.  If you don't include the
 * pixmap, you will get a "parse error before ..." message
 * when you compile.
 */

void cmd_add_pixmap_clicked()
{
		GtkWidget *my_pixmap;
		GtkWidget *list_item;

		/* Ponizsze obiekty sa potrzebne do narysowania pixmapy */

		GdkBitmap *a_bitmap;
		GdkPixmap *a_pixmap;

		a_pixmap = gdk_pixmap_colormap_create_from_xpm_d
				(NULL,
				 gdk_colormap_get_system(),
				 &a_bitmap,
				 NULL,
				 (gchar **) pixmap_xpm);

		my_pixmap = gtk_pixmap_new(a_pixmap, a_bitmap);

		list_item = gtk_list_item_new();
		gtk_container_add(GTK_CONTAINER(list_item), my_pixmap);

		gtk_container_add(GTK_CONTAINER(list_left), list_item);

		gtk_widget_show_all(frm_list_widgets);

}

void cmd_SINGLE_clicked()
{
	/* Tryb SINGLE umozliwia pojedynczy wybor.  W tym trybie mozna
	 * zaznaczyc tylko jeden element.  Klikniecie, przytrzymanie i przeciaganie wskaznika myszy
	 * wplywa tylko na ..., a nie na element wybrany .  Wybor elementu nastepuje przy zdarzeniu mouse up.
	 * Wciskanie klawiszy Ctrl i Shift nie ma zadnego wplywu.
	 */

	gtk_list_set_selection_mode(GTK_LIST(list_left), GTK_SELECTION_SINGLE);
}
void cmd_BROWSE_clicked()
{
	/* W tym trybie mozliwy jest tylko wybor jednego elementu.  Wybor nastepuje przy zdarzeniu mouse down.
	 * Klikniecie, przytrzymanie i opuszczenie wplywa na zaznaczony element.
	 * Wciskanie klawiszy Ctrl i Shift nie ma zadnego wplywu.
	 */

	gtk_list_set_selection_mode(GTK_LIST(list_left), GTK_SELECTION_BROWSE);
}
void cmd_MULTIPLE_clicked()
{
	/* Tu mozna zaznaczyc wiele elementow;  inne zachowania sa podobne do trybu SINGLE.
	 * Zdarzenie Mouse up event powoduje zaznaczenie elementu, aby go wybrac
	 * trzeba kliknac i zwolnic przycisk myszy.  Click, hold, and drag changes focus, not selection.
	 * Wciskanie klawiszy Ctrl i Shift nie ma zadnego wplywu.
	 */

	gtk_list_set_selection_mode(GTK_LIST(list_left), GTK_SELECTION_MULTIPLE);
}
void cmd_EXTENDED_clicked()
{
	/* Mozna wybrac wiele elementow;  wybor nastepuje przy zdarzeniu ouse down.  Klikniecie,
	 * przytrzymanie przycisku i przeciagniecie wskaznika powoduje zaznaczenie wszystkich pozadanych elementow listy.
	 * Klawisze Ctrl i Shift spelniaja swoje zadanie:  Shift powoduje
	 * zaznaczenie elementow pomiedzy poprzednim, a biezacym kliknieciem myszy, a Ctrl powoduje
	 * wybor dodatkowych elementow.
	 */
	gtk_list_set_selection_mode(GTK_LIST(list_left), GTK_SELECTION_EXTENDED);
}

void cmd_prepend_clicked()
{
	a_row[0] = "Ayn Rand";
	a_row[1] = "Atlas Shrugged";
	a_row[2] = "1957";

	gtk_clist_prepend(GTK_CLIST(clist_right), a_row);
	gtk_clist_columns_autosize(GTK_CLIST(clist_right));
}

void cmd_append_clicked()
{
	a_row[0] = "Hermann Hesse";
	a_row[1] = "Steppenwolf";
	a_row[2] = "1898";

	gtk_clist_append(GTK_CLIST(clist_right), a_row);
	gtk_clist_columns_autosize(GTK_CLIST(clist_right));
}

void cmd_insert_row_2_clicked()
{
	a_row[0] = "Jack Kerouac";
	a_row[1] = "On The Road";
	a_row[2] = "1958";

	/*  Wartosc 1 w ponizszej instrukcji oznacza wiersz 2;
	 * Numeracja w C rozpoczyna sie od 0, a nie od 1.
	 */
	gtk_clist_insert(GTK_CLIST(clist_right), 1, a_row);
	gtk_clist_columns_autosize(GTK_CLIST(clist_right));

}

/* Nastepne trzy funkcje sluza do umieszczenia odpowiedniego tekstu
 * lub pixmap w widgecie CList
 *
 * Odpowiedni wiersz i kolumna elementow CList musi zaistniec przed
 * wprowadzeniem obiektow, bo nie kontrolujemy tu
 * zwracanych wartosci (nie wiemy, czy wystapi blad).
 *
 * Wartosc "2" roznacza trzeci wiersz
 * "row 3" bo kolumny i wiersze widgeta CList
 * sa numerowane od zera.
 */

void cmd_set_text_clicked()
{
	gtk_clist_set_text(GTK_CLIST(clist_right), 2, 0, "Tekst");
	gtk_clist_columns_autosize(GTK_CLIST(clist_right));
}

void cmd_set_pixmap_clicked()
{
	GtkWidget *my_pixmap;

	GdkBitmap *a_bitmap;
	GdkPixmap *a_pixmap;

	a_pixmap = gdk_pixmap_colormap_create_from_xpm_d
				(NULL,
				 gdk_colormap_get_system(),
				 &a_bitmap,
				 NULL,
				 (gchar **) pixmap_xpm);

	my_pixmap = gtk_pixmap_new(a_pixmap, a_bitmap);

	gtk_clist_set_pixmap(GTK_CLIST(clist_right), 2, 1, a_pixmap, a_bitmap);
	gtk_clist_columns_autosize(GTK_CLIST(clist_right));

}

void cmd_set_pixtext_clicked()
{
	GtkWidget *my_pixmap;

	GdkBitmap *a_bitmap;
	GdkPixmap *a_pixmap;

	a_pixmap = gdk_pixmap_colormap_create_from_xpm_d
				(NULL,
				 gdk_colormap_get_system(),
				 &a_bitmap,
				 NULL,
				 (gchar **) pixmap_xpm);

	my_pixmap = gtk_pixmap_new(a_pixmap, a_bitmap);
	
	gtk_clist_set_pixtext(GTK_CLIST(clist_right), 2, 2, "Tekst",
					10, a_pixmap, a_bitmap);
	gtk_clist_columns_autosize(GTK_CLIST(clist_right));

}

void cmd_sort_clicked()
{
	gtk_clist_set_sort_column(GTK_CLIST(clist_right), 0);
	gtk_clist_sort(GTK_CLIST(clist_right));

	/* Aby posortowac dane w kontrolce CList automatycznie
	 * po dokonaniu zmian, mozna skorzystac z funkcji gtk_clist_set_auto_sort() .
	 */

}
