/* listing 3.1
 * Prezentacja GtkCombo.
 */

#include <gtk/gtk.h>

GtkWidget *frm_combo;
GtkWidget *cbo_first;

void destroy_main();
void cmd_set_use_arrows_false_clicked();
void cmd_set_use_arrows_true_clicked();
void cmd_set_use_arrows_always_false_clicked();
void cmd_set_use_arrows_always_true_clicked();
void cmd_set_case_sensitive_true_clicked();
void cmd_set_case_sensitive_false_clicked();
void cmd_get_text_clicked();

gint main(gint argc, gchar *argv[])
{

   GtkWidget *vbox_main;
   GtkWidget *cmd_set_use_arrows_false, *cmd_set_use_arrows_true;
   GtkWidget *cmd_set_use_arrows_always_false, *cmd_set_use_arrows_always_true;
   GtkWidget *cmd_set_case_sensitive_true, *cmd_set_case_sensitive_false;
   GtkWidget *cmd_get_text;
   /* Nalezy zauwazyc, ze lista obiektu Combo jest zarzadzana niezaleznie od widgetu. 
    * GList jest typem pochodzacym z biblioteki GLib.
    */

   GList *list_of_months = NULL;

   gtk_init(&argc, &argv);

   frm_combo = gtk_window_new(GTK_WINDOW_TOPLEVEL);

   gtk_window_set_title(GTK_WINDOW(frm_combo), "Lista rozwijana i jej opcje");

   gtk_signal_connect(GTK_OBJECT(frm_combo),
        "destroy",
        GTK_SIGNAL_FUNC(destroy_main),
        NULL);

   vbox_main = gtk_vbox_new(TRUE, 0);

   /* Jesli kursor znajduje sie w jednowierszowym polu tekstowym,
    * to klawisz Enter powoduje rozwiniecie listy, a Esc
    * zwiniecie listy.
    */

   cbo_first = gtk_combo_new();

   list_of_months = g_list_append(list_of_months, "Styczen");
   list_of_months = g_list_append(list_of_months, "Luty");
   list_of_months = g_list_append(list_of_months, "Marzec");
   list_of_months = g_list_append(list_of_months, "Kwiecien");
   list_of_months = g_list_append(list_of_months, "Maj");
   list_of_months = g_list_append(list_of_months, "Czerwiec");
   list_of_months = g_list_append(list_of_months, "Lipiec");
   list_of_months = g_list_append(list_of_months, "Sierpien");
   list_of_months = g_list_append(list_of_months, "SIERPIEN");

   gtk_combo_set_popdown_strings(GTK_COMBO(cbo_first), list_of_months);

   /* Jesli najpierw umiescimy wszystkie wartosci listy GList,
    * to mozemy w sposob jawny ustawic domyslnie wyswietlana w polu wartosc.
    * Gdybysmy umiescili ponizsza linijke przed wywolaniem
    * funkcji gtk_combo_set_popdown_strings() ,lista
    * zostalaby wysiwetlona z domyslnie ustawionym pierwszym elementem GList,
    * ("Styczen"), a nie wartoscia ustawiona przez nas.
    */

   gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_first)->entry), "Pazdziernik");

   /* Powyzej po raz pierwszy wywolano funkcje, w ktorej wykorzystano
    * "obiekt potomny".  W tym przypadku obiektem nadrzednym jest GtkCombo,
    * a jednym z jego obiektow potomnych - jednowierszowe pole tekstowe.Strzalka -> oznacza
    * odwolanie przez wskaznik.
    *
    * Jezeli biezaca wartosc wyswietlana w polu nie znajduje sie
    * w obiekcie GList, to strzalki przycisku przewijania sa zablokowane
    * Jest tak, gdyz najpierw nastepuje porownanie
    * wartosci wpisanej w polu z wartosciami umieszczonymi w GList,
    * a obiekt sluzacy do przewijania zawartosci listy
    * jest zwiazany z GList. Kazde nacisniecie przycisku powoduje
    * zmiane aktywnego ustawienia listy.
    */

   /* Kilka przyciskow pomocnych przy demonstracji mozliwosci GtkCombo. */

   cmd_set_use_arrows_true = gtk_button_new_with_label("Wykorzystanie strzalek");
   gtk_signal_connect(GTK_OBJECT(cmd_set_use_arrows_true),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_set_use_arrows_true_clicked),
                      NULL);
   cmd_set_use_arrows_false = gtk_button_new_with_label("Zablokowanie strzalek");
   gtk_signal_connect(GTK_OBJECT(cmd_set_use_arrows_false),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_set_use_arrows_false_clicked),
                      NULL);

   cmd_set_use_arrows_always_true = gtk_button_new_with_label("Strzalki zawsze aktywne");
   gtk_signal_connect(GTK_OBJECT(cmd_set_use_arrows_always_true),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_set_use_arrows_always_true_clicked),
                      NULL);
   cmd_set_use_arrows_always_false = gtk_button_new_with_label("Strzalki zawsze wylaczone");
   gtk_signal_connect(GTK_OBJECT(cmd_set_use_arrows_always_false),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_set_use_arrows_always_false_clicked),
                      NULL);

   cmd_set_case_sensitive_true = gtk_button_new_with_label("Wrazliwosc na wielkosc liter");
   gtk_signal_connect(GTK_OBJECT(cmd_set_case_sensitive_true),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_set_case_sensitive_true_clicked),
                      NULL);
   cmd_set_case_sensitive_false = gtk_button_new_with_label("Wylaczenie wrazliwosci na wielkosc liter");
   gtk_signal_connect(GTK_OBJECT(cmd_set_case_sensitive_false),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_set_case_sensitive_false_clicked),
                      NULL);

   cmd_get_text = gtk_button_new_with_label("Pobranie tekstu");
   gtk_signal_connect(GTK_OBJECT(cmd_get_text),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_get_text_clicked),
                      NULL);

   /* czas na zlozenie interfejsu */

   gtk_box_pack_start(GTK_BOX(vbox_main), cbo_first, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_set_use_arrows_true, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_set_use_arrows_false, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_set_use_arrows_always_true, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_set_use_arrows_always_false, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_set_case_sensitive_true, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_set_case_sensitive_false, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_get_text, TRUE, TRUE, 0);

   gtk_container_add(GTK_CONTAINER(frm_combo), vbox_main);

   gtk_widget_show_all (frm_combo);
   gtk_main ();
   return 0;

}

void destroy_main()
{   gtk_main_quit();
}

void cmd_set_use_arrows_true_clicked()
{
   /* To jest opcja domyslna. */
   gtk_combo_set_use_arrows(GTK_COMBO(cbo_first), TRUE);
}

void cmd_set_use_arrows_false_clicked()
{
   gtk_combo_set_use_arrows(GTK_COMBO(cbo_first), FALSE);
}

void cmd_set_use_arrows_always_true_clicked()
{
   /* To jest opcja domyslna. */
   gtk_combo_set_use_arrows_always(GTK_COMBO(cbo_first), TRUE);

   /* Ta funkcja sluzy do ustawienia "blokady przewijania"
    * elementow listy, przydatnej, gdy uzytkownik korzysta ze strzalek.
    * Jesli ustawimy tu wartosc TRUE, to uzycie strzalki
    * jest niemozliwe, gdy zostanie wybrany pierwszy badz ostatni element listy.
    * My wybierzemy wartosc FALSE, dzieki czemu uzytkownik moze
    * "na okraglo" przemieszczac sie po elementach za pomoca strzalek.
    */
}

void cmd_set_use_arrows_always_false_clicked()
{
   gtk_combo_set_use_arrows_always(GTK_COMBO(cbo_first), FALSE);

   /*  FALSE oznacza "opakowanie" wartosci wyswietlanej w liscie
    *
    */
}

void cmd_set_case_sensitive_true_clicked()
{
	gtk_combo_set_case_sensitive(GTK_COMBO(cbo_first), TRUE);
}

void cmd_set_case_sensitive_false_clicked()
{
   /* To jest opcja domyslna */

   /* Dzieki niej obiekt nie jest wrazliwy na wielkosc liter.
    * wystarczy wpisac nazwe pasujacego elementu,
    * nie zwracajac na wielkosc liter, a obiekt sam wybierze
    * poprawny element z listy. Mozna wpisac "SIerpIeN",
    * co zostanie automatycznie zamienione na "Sierpien".
    *
    *
    * Zwrocmy uwage, ze gdy ta opcja jest aktywna
    * to mozemy przesuwac elementy az do "Sierpien",
    * ale kolejnego elementu ("SIERPIEN") nie zobaczymy.
    * 
    */

   gtk_combo_set_case_sensitive(GTK_COMBO(cbo_first), FALSE);
}

void cmd_get_text_clicked()
{
   g_print("Lista jest: %s\n",
            gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(cbo_first)->entry)));
}
