/* listing 3.2
 * Prezentacja paska stanu i paska postepu
 */

#include <gtk/gtk.h>

GtkWidget *frm_bars;
GtkWidget *top_progress_bar, *bottom_status_bar;

/* Zmienna timeout bedzie nam sluzyc jako zegar;  co xxx milisekund
 * bedzie wywolywac inna funkcje, uaktualniajaca pasek postepu.
 * Zadeklarujemy ja jako zmienna globalna, dzieki czemu bedzie mozna ja wykorzystac
 * w kazdym miejscu programu. Dzieki niej bedziemy zatrzymywac ruch paska
 * postepu.
 */

gint timeout_1 = 0;

void destroy_main();
void cmd_default_progress_clicked();
void cmd_zero_clicked();
void cmd_stop_clicked();
void cmd_lr_clicked();
void cmd_rl_clicked();
void cmd_bt_clicked();
void cmd_tb_clicked();
void cmd_activity_true_clicked();
void cmd_activity_false_clicked();
void cmd_string_clicked();
 
/* Oto funkcja zwrotna paska stanu. */
void cmd_pop_clicked();

gint main(gint argc, gchar *argv[])
{

   GtkWidget *vbox_main;
   GtkWidget *cmd_zero;
   GtkWidget *cmd_default_progress;
   GtkWidget *cmd_stop;
   GtkWidget *cmd_lr, *cmd_rl, *cmd_bt, *cmd_tb;
   GtkWidget *cmd_activity_true, *cmd_activity_false;
   GtkWidget *cmd_string;
   GtkWidget *cmd_pop;

   gtk_init(&argc, &argv);

   frm_bars = gtk_window_new(GTK_WINDOW_TOPLEVEL);

   gtk_window_set_title(GTK_WINDOW(frm_bars), "Prezentacja paska stanu i paska postepu");

   gtk_signal_connect(GTK_OBJECT(frm_bars),
        "destroy",
        GTK_SIGNAL_FUNC(destroy_main),
        NULL);

   vbox_main = gtk_vbox_new(FALSE, 0);

   top_progress_bar = gtk_progress_bar_new();

   /* Pasek postepu mozna utworzyc za pomoca obiektu regulacji, podobnie, jak
    * w listingu 2.2 (przyciski przeijania).  W tym przypadku nalezy wywolac funkcje,
    *
    *
    * gtk_progress_bar_new_with_adjustment(GTK_ADJUSTMENT(adj_widget))
    *
    * Dzieki tej funkcji mozna ustanowic wartosc minimalna, maksymalna i podobne
    * wartosci majace znaczenie dla danego obiektu.
    * W tym przypadku moznaby ustawic wartosc maks. i min. dla paska postepu.
    * W wiekszosci aplikacji wykorzystuje sie pelny zakres paska (0 - 100%),
    * wiec skorzystamy z domyslnych ustawien.
    */

   cmd_zero = gtk_button_new_with_label("Powrot do poczatku...");
   gtk_signal_connect(GTK_OBJECT(cmd_zero),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_zero_clicked),
                      NULL);
  
   cmd_default_progress = gtk_button_new_with_label("Rozpocznij wykonywanie zadania...");
   gtk_signal_connect(GTK_OBJECT(cmd_default_progress),
                      "released",
                      GTK_SIGNAL_FUNC(cmd_default_progress_clicked),
                      NULL);

   cmd_stop = gtk_button_new_with_label("Zatrzymanie wykonywania zadania");
   gtk_signal_connect(GTK_OBJECT(cmd_stop),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_stop_clicked),
                      NULL);

   /* Ponizsze przyciski sluza do ustalenia kierunku wypelniania paska,
    * z lewej do prawej, z gory na dol.
    */

   cmd_lr = gtk_button_new_with_label("Przesuwanie paska z lewej do prawej");
   gtk_signal_connect(GTK_OBJECT(cmd_lr),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_lr_clicked),
                      NULL);
   cmd_rl = gtk_button_new_with_label("Przesuwanie paska z prawej do lewej");
   gtk_signal_connect(GTK_OBJECT(cmd_rl),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_rl_clicked),
                      NULL);
   cmd_bt = gtk_button_new_with_label("Przesuwanie paska z dolu do gory");
   gtk_signal_connect(GTK_OBJECT(cmd_bt),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_bt_clicked),
                      NULL);
   cmd_tb = gtk_button_new_with_label("Przesuwanie paska z gory do dolu");
   gtk_signal_connect(GTK_OBJECT(cmd_tb),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_tb_clicked),
                      NULL);

   cmd_activity_true = gtk_button_new_with_label("Wlaczony tryb aktywny");
   gtk_signal_connect(GTK_OBJECT(cmd_activity_true),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_activity_true_clicked),
                      NULL);
   cmd_activity_false = gtk_button_new_with_label("Wylaczony tryb aktywny");
   gtk_signal_connect(GTK_OBJECT(cmd_activity_false),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_activity_false_clicked),
                      NULL);

   cmd_string = gtk_button_new_with_label("Wyswietlenie informacji na pasku");
   gtk_signal_connect(GTK_OBJECT(cmd_string),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_string_clicked),
                      NULL);

   cmd_pop = gtk_button_new_with_label("Wyswietlenie ostatniej wiadomosci");
   gtk_signal_connect(GTK_OBJECT(cmd_pop),
                      "clicked",
                      GTK_SIGNAL_FUNC(cmd_pop_clicked),
                      NULL);

   bottom_status_bar = gtk_statusbar_new();

   /* zlozenie interfejsu */

   gtk_box_pack_start(GTK_BOX(vbox_main), top_progress_bar, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_zero, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_default_progress, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_stop, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_lr, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_rl, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_bt, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_tb, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_activity_true, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_activity_false, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_string, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_pop, TRUE, TRUE, 0);

   gtk_box_pack_start(GTK_BOX(vbox_main), bottom_status_bar, TRUE, TRUE, 0);

   gtk_container_add(GTK_CONTAINER(frm_bars), vbox_main);

   gtk_widget_show_all (frm_bars);
   gtk_main ();
   return 0;

}

void destroy_main()
{   gtk_main_quit(); }

gint update_progress()
{

  /* Zwrocmy uwage na wywolanie *_get_value(). Wartoscia zwrocona
   * przez funkcje jest liczba calkowita, a nie zmiennoprzecinkowa,
   * pomiedzy 0 a 1. Funkcja *_set_value() przyjmuje argumenty z przedzialu <0,1>
   * czyli wartosci zmiennoprzecinkowe. Aby je otrzymac,
   * podzielimy liczby calkowite przez 100.
   */

  if (gtk_progress_get_value(GTK_PROGRESS(top_progress_bar)) <= 98)
  {
     /* Aby wyswietlic postep w oknie wiersza polecen, nalezy
      * usunac komentarz z ponizszej instrukcji
      */

     /* g_print("Postep: %f\n",
              gtk_progress_get_value(GTK_PROGRESS(top_progress_bar)) );
     */
     gtk_progress_bar_update(GTK_PROGRESS_BAR(top_progress_bar),
                             gtk_progress_get_value
                                 (GTK_PROGRESS(top_progress_bar))/100 + .01
                            );
   return(TRUE);
  }
  else
  {
     gtk_progress_bar_update(GTK_PROGRESS_BAR(top_progress_bar), 1);

     /* Jesli funkcja wywolana przez funkcje gtk_timeout_add zwraca FALSE
      * to obiekt timeout jest usuwany
      */

     gtk_statusbar_push(GTK_STATUSBAR(bottom_status_bar),
                       1, "Zakonczono wykonywanie zadania.");
     return(FALSE);
  }

}

void cmd_default_progress_clicked()
{
   /* To jest "podstawowe" dzialanie paska postepu, polegajace  na
    * ziwekszaniu sie wartosci od 0 do 100%.
    *
    * Jesli wcisniemy kilka razy przycisk "predkosc domyslna",
    * to pasek postepu bedzie uzupelniany coraz szybciej.  Jest tak, gdyz
    * z kazdym przycisnieciem tworzymy nowy obiekt timeout, a kazdy
    * z nich dotyczy tego samego paska. To oznacza utrate kontroli nad poprzednimi
    * obiektami, bo istnieje tylko jedna zmienna timeout_1
    * przechowujaca znacznik ostatniego obiektu timeout:
    */

   g_print("Rozpoczeto wykonywanie zadania....\n");
   gtk_statusbar_push(GTK_STATUSBAR(bottom_status_bar),
                       1, "Rozpoczeto wykonywanie zadania.");

   /* Powyzej wykonano te sama czynnosc, na dwa rozne sposoby.
    */

   timeout_1 = gtk_timeout_add(50, update_progress, NULL);
}

void cmd_stop_clicked()
{
   gtk_timeout_remove(timeout_1);
}

void cmd_zero_clicked()
{
   gtk_progress_bar_update(GTK_PROGRESS_BAR(top_progress_bar), 0);
}

void cmd_lr_clicked()
{
   gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(top_progress_bar),
                                    GTK_PROGRESS_LEFT_TO_RIGHT);
}

void cmd_rl_clicked()
{
   gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(top_progress_bar),
                                    GTK_PROGRESS_RIGHT_TO_LEFT);
}

void cmd_bt_clicked()
{
   /* Zwrocmy uwage na zmiane ksztaltu paska postepu
    * wraz ze zmiana jego orientacji (gora-dol, prawa-lewa).
    */

   gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(top_progress_bar),
                                    GTK_PROGRESS_BOTTOM_TO_TOP);
}

void cmd_tb_clicked()
{
   gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(top_progress_bar),
                                    GTK_PROGRESS_TOP_TO_BOTTOM);
}

void cmd_activity_true_clicked()
{
   /* Tryb aktywny oznacza umozliwienie przemieszczania sie paska do konca i
    * z powrotem.  W tym programie, po nacisnieciu przycisku "Wlaczony tryb aktywny"
    * nalezy wcisnac przycisk "Ustawienie wartosci domyslnej paska postepu"
    * W trybie aktywnym pasek rowniez zatrzymuje sie, gdy wartosc postepu przekroczy 1.
    * aby utrzymac pasek w ciaglym ruchu, nalezy czesto zerowac te wartosc.
    *
    */

   gtk_progress_set_activity_mode(GTK_PROGRESS(top_progress_bar), TRUE);
   gtk_statusbar_push(GTK_STATUSBAR(bottom_status_bar),
                       1, "Wlaczono tryb aktywny...");
}

void cmd_activity_false_clicked()
{
   gtk_progress_set_activity_mode(GTK_PROGRESS(top_progress_bar), FALSE);
   gtk_statusbar_push(GTK_STATUSBAR(bottom_status_bar), 
                       1, "Wylaczono tryb aktywny");
}

void cmd_string_clicked()
{

   /* Ta funkcja sluzy do umieszczenia odpowiednio sformatowanego lancucha
    * w pasku postepu. Instrukcja ta przypomina znana z C printf. Roznica jest
    * fakt, ze w tym przypadku mozna skorzystac ze specyficznych znakow formatujacych:
    *
    *      %u - wartosc maksymalna postepu
    *      %l - wartosc minimalna
    *      %p - procent wykonanego zadania
    *      %v - zakres
    * W niniejszym przykladzie skorzystano z czterech wartosci, wyswietlonych
    * w postaci czystego tekstu.
    */

   gtk_progress_set_format_string(GTK_PROGRESS(top_progress_bar),
                                  "Procent zaaw.:%p Wartosc:%v Min:%l Max:%u");
   gtk_progress_set_show_text(GTK_PROGRESS(top_progress_bar), TRUE);

   /* Umieszczenie tego tekstu na pasku postepu sklada sie z
    * dwoch czynnosci.  Zwrocmy uwage na to, ze gdy pasek jest w trybie
    * aktywnym, to nie mozna umiescic tekstu na pasku postepu.
    * Nasz tekst zniknie az do chwili, gdy pasek bedzie ponownie
    * w trybie nieaktywnym.
    *
    * Ponizsza funkcja sluzy do precyzyjnego okreslenia pozycji wyswietlanego tekstu.
    * Ostatnie 2 parametry moga przybrac wartosci pomiedzy 0 a 1.
    * (0,0) oznacza lewy, gorny rog, a (1,1) - prawy, dolny rog.
    * Pierwszy z nich jest odpowiedzialny za orientacje pozioma,
    * a drugi - za pionowa. Latwo zgadnac, ze (0, 1) oznacza lewy, dolny rog, a (1, 0)
    * - prawy, gorny rog.
    *
    */

   gtk_progress_set_text_alignment(GTK_PROGRESS(top_progress_bar), 0.5, 0.5);
}

void cmd_pop_clicked()
{
   /* Obiekt paska stanu przypomina dziala jak stos posiadajacy funkcje
    * nakladajace/zdejmujace elementy ze stosu.  Gdy chcemy wyswietlic komunikat,
    * to "wrzucamy" go na stos za pomoca wywolania funkcji
    *
    *   gtk_status_bar_push()
    *
    * Funkcja przyjmuje trzy parametry:  tpierwszym jest docelowy pasek stanu,
    * drugim - identyfikator kontekstu, a trzecim - komunikat, ktory ma byc
    * wyswietlony.  W naszym przykladzie korzystamy z kontekstu o identyfikatorze 1,
    * ale warto wiedziec, ze mozna zastosowac takze inne identyfikatory,
    * odpowiedzialne za inne funkcje paska stanu.  Przykladem jest zdjecie
    * wiadomosci ze stosu.  W tym przypadku skorzystano z kolejki
    * LIFO (last-in-first-out), co jest wystarczajacym rozwiazaniem w wiekszosci
    * aplikacji.
    *
    * Identyfikator kontekstu musi byc wartoscia niezerowa.  W tym przypadku "1"
    * jest wartoscia latwa do zapamietania, bo oznacza wrzucenie lub zdjecie ze stosu
    * jednej wiadomosci.
    *
    * Funkcja gtk_status_bar_pop() powoduje usuniecie ze stosu komunikatu o
    * najwyzszym priorytecie (najwiekszym identyfikatorze).  W tym przypadku,
    * wszystkie wiadomosci maja ten sam priorytet, wiec calosc dziala na zasadzie kolejki
    * LIFO.  MOzna, oczywiscie, utworzyc kilka klas wiadomosci
    * i umieszczac je w odpowiednim porzadku na stosie.  Jesli nie wykorzystamy
    * zadnego identyfikatora w wiadomoisci, to zawartosc
    * paska stanu bedzie niezmieniona..
    */

    gtk_statusbar_pop(GTK_STATUSBAR(bottom_status_bar), 1);
}
