/* listing 3.5
 * Demonstracja menu
 */

#include <gtk/gtk.h>

GtkWidget *frm_menus;
GtkWidget *frm_item_factory;
GtkWidget *frm_popup;
GtkWidget *popup_menu;

void destroy_main();
void cmd_manual_menu_clicked();
void cmd_item_factory_clicked();
void item_factory_clicked();
void cmd_popup_clicked();

void popup_mnu_1_clicked();
void popup_mnu_2_clicked();
void popup_mnu_3_clicked();
void text_right_click_event();

gint main(gint argc, gchar *argv[])
{
   GtkWidget *vbox_main;
   GtkWidget *cmd_manual_menu;
   GtkWidget *cmd_item_factory;
   GtkWidget *cmd_popup;

   gtk_init(&argc, &argv);

   frm_menus = gtk_window_new(GTK_WINDOW_TOPLEVEL);

   gtk_window_set_title(GTK_WINDOW(frm_menus), "Prezentacja systemu menu");

   gtk_signal_connect(GTK_OBJECT(frm_menus),
        "destroy",
        GTK_SIGNAL_FUNC(destroy_main),
        NULL);

   vbox_main = gtk_vbox_new(TRUE, 2);

   cmd_manual_menu = gtk_button_new_with_label("Prezentacja systemu menu utworzonego recznie");
   gtk_signal_connect(GTK_OBJECT(cmd_manual_menu),
      "clicked",
      GTK_SIGNAL_FUNC(cmd_manual_menu_clicked),
      NULL);

   cmd_item_factory = gtk_button_new_with_label("Prezentacja systemu menu utworzonego przez fabryke obiektow");
   gtk_signal_connect(GTK_OBJECT(cmd_item_factory),
      "clicked",
      GTK_SIGNAL_FUNC(cmd_item_factory_clicked),
      NULL);
   
   cmd_popup = gtk_button_new_with_label("Menu kontekstowe");
   gtk_signal_connect(GTK_OBJECT(cmd_popup),
      "clicked",
      GTK_SIGNAL_FUNC(cmd_popup_clicked),
      NULL);

   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_manual_menu, TRUE, TRUE, 0); 
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_item_factory, TRUE, TRUE, 0); 
   gtk_box_pack_start(GTK_BOX(vbox_main), cmd_popup, TRUE, TRUE, 0); 
   gtk_container_add(GTK_CONTAINER(frm_menus), vbox_main);

   gtk_widget_show_all (frm_menus);

   gtk_main ();

   return 0;

}

void destroy_main()
{   gtk_main_quit(); }

/* ============= Tworzenie systemu menu samodzielnie =============== */

void cmd_manual_menu_clicked()
{
   GtkWidget *frm_manual;
   GtkWidget *vbox_manual;
   GtkWidget *menu_bar_manual;
   GtkWidget *menu_file, *menu_edit, *menu_widgets;
   GtkWidget *menu_item_tearoff1, *menu_item_separator1;
   GtkWidget *menu_item_file, *menu_item_open, *menu_item_exit, *menu_item_widgets;
   GtkWidget *menu_item_edit, *menu_item_cut, *menu_item_copy, *menu_item_paste;
   GtkWidget *hbox_cut;
   GtkWidget *icon_scissors;
   GdkPixmap *xpm_scissors;
   GdkBitmap *bmp;
   GtkWidget *lbl_cut, *lbl_ctrl_X;
   GtkAccelGroup *hot_keys;
   GtkWidget *menu_item_check, *chk_box_demo;
   GtkWidget *menu_item_cmd, *cmd_button_demo;
   GtkWidget *menu_item_check2;
   GtkWidget *text_manual;

   frm_manual = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(frm_manual), "System menu utworzony recznie");

   vbox_manual = gtk_vbox_new(FALSE, 0);

   menu_bar_manual = gtk_menu_bar_new();
   menu_file = gtk_menu_new();
   menu_edit = gtk_menu_new();
   menu_widgets = gtk_menu_new();

   /* Menu Plik */
   menu_item_file = gtk_menu_item_new_with_label("Plik");
   menu_item_tearoff1 = gtk_tearoff_menu_item_new();
   menu_item_open = gtk_menu_item_new_with_label("Otworz");
   menu_item_separator1 = gtk_menu_item_new();
   menu_item_exit = gtk_menu_item_new_with_label("Zakoncz");

   /* Menu Edycja */
   menu_item_edit = gtk_menu_item_new_with_label("Edycja");
   menu_item_copy = gtk_menu_item_new_with_label("Kopiuj");
   menu_item_cut = gtk_menu_item_new();
   hbox_cut = gtk_hbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(menu_item_cut), hbox_cut);
   xpm_scissors = gdk_pixmap_colormap_create_from_xpm(
                       NULL,
                       gdk_colormap_get_system(),
                       &bmp,
                       NULL,
                       "/usr/share/icons/mini/mini.cut.xpm");
   icon_scissors = gtk_pixmap_new(xpm_scissors, bmp);
   gdk_pixmap_unref(xpm_scissors);
   gtk_box_pack_start_defaults(GTK_BOX(hbox_cut), icon_scissors);
   lbl_cut = gtk_label_new("Wytnij");
   lbl_ctrl_X = gtk_label_new("Ctl+X");
   gtk_label_set_justify(GTK_LABEL(lbl_ctrl_X), GTK_JUSTIFY_RIGHT);
   gtk_box_pack_start(GTK_BOX(hbox_cut), lbl_cut, TRUE, FALSE, 0);
   gtk_box_pack_start(GTK_BOX(hbox_cut), lbl_ctrl_X, FALSE, FALSE, 3);
   menu_item_paste = gtk_menu_item_new_with_label("Wklej");

   /* Jak widac z powyzszego przykladu, utworzenie elementu menu
    * z ikona jest bardzo proste.  Poniewaz widget elementu menu
    * pochodzi od obiektu GtkBin, ktory moze zawierac tylko jeden obiekt
    * potomny, bedziemy musieli wykorzystac obiekt pojemnika poziomego w
    * elemencie menu.  Nastepnie skorzystamy z odpowiedniej ikony (czyli pixmapy)
    * z lewej strony i etykiety z prawej strony.
    *
    * Aby zobaczyc przyklad umieszcenia pixmapy w obiekcie List
    * nalezy spojrzec na listuing 2.2
    * (prezentacja obiektu List).
    *
    * Jesli po uruchomieniu programu nie zobaczymy pozadanej ikony,
    * to znaczy, ze w naszym systemie nie jej ma (albo znajduje sie w innym katalogu).
    * Ostatnim parametrem funkcji gdk_pixmap_colormap_create_from_xpm
    * jest odpowiednia sciezka dostepu do ikony.  Nalezy wprowadzic
    * odpowiednia sciezke dostepu, albo skopiowac pixmape do
    * katalogu, ktorego nazwa jest juz wpisana.
    */

   hot_keys = gtk_accel_group_new();
   gtk_accel_group_attach(hot_keys, GTK_OBJECT(frm_manual));
   gtk_widget_add_accelerator(menu_item_copy, 
                              "activate", 
                              hot_keys,
                              'C', 
                              GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
   gtk_widget_add_accelerator(menu_item_cut, 
                              "activate", 
                              hot_keys,
                              'X', 
                              GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
   gtk_widget_add_accelerator(menu_item_paste, 
                              "activate", 
                              hot_keys,
                              'V', 
                              GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  
   /* Menu widgetow */

   menu_item_widgets = gtk_menu_item_new_with_label("Widgety");

   /* Poniewaz  element menu jest pochodny wzgledem GtkBin, to
    * oznacza, ze (teoretycznie) mozna umiescic
    * dowolny widget w elemencie menu.
    */

   menu_item_check = gtk_menu_item_new();
   chk_box_demo = gtk_check_button_new_with_label("Wybierz mnie!");
   gtk_container_add(GTK_CONTAINER(menu_item_check), chk_box_demo);

   /* Pola wyboru sa w menu najczesciej wykorzystywane do wlaczania
    * (wylaczania) pewnych opcji.  My sprobujemy
    * zrobic cos innego...
    */

   menu_item_cmd = gtk_menu_item_new();
   cmd_button_demo = gtk_button_new_with_label("Nacisnij na mnie!");
   gtk_container_add(GTK_CONTAINER(menu_item_cmd), cmd_button_demo);

   /* Poniewaz umieszczanie pol wyboru w systemach menu stalo
    * sie zjawiskiem nagminnym, w tym xcelu utworzono specjalny widget.
    * Roznica pomiedzy "zwyklym" a "wyspecjalizowanym" obiektem
    * polega na tym, ze element *_check_menu_item_* nie wyswietli
    * pola wyboru, jesli nie jest wybrany.
    */

   menu_item_check2 = gtk_check_menu_item_new_with_label("Pole wyboru 2");

   /* Zlozenie okien. */

   gtk_menu_bar_append(GTK_MENU_BAR(menu_bar_manual), menu_item_file);
   gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item_file), menu_file);
   gtk_menu_append(GTK_MENU(menu_file), menu_item_tearoff1);
   gtk_menu_append(GTK_MENU(menu_file), menu_item_open);
   gtk_menu_append(GTK_MENU(menu_file), menu_item_separator1);
   gtk_menu_append(GTK_MENU(menu_file), menu_item_exit);

   gtk_menu_bar_append(GTK_MENU_BAR(menu_bar_manual), menu_item_edit);
   gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item_edit), menu_edit);
   gtk_menu_append(GTK_MENU(menu_edit), menu_item_cut);
   gtk_menu_append(GTK_MENU(menu_edit), menu_item_copy);
   gtk_menu_append(GTK_MENU(menu_edit), menu_item_paste);

   gtk_menu_bar_append(GTK_MENU_BAR(menu_bar_manual), menu_item_widgets);
   gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item_widgets), menu_widgets);
   gtk_menu_append(GTK_MENU(menu_widgets), menu_item_check);
   gtk_menu_append(GTK_MENU(menu_widgets), menu_item_cmd);
   gtk_menu_append(GTK_MENU(menu_widgets), menu_item_check2);

   text_manual = gtk_text_new(NULL, NULL);

   gtk_box_pack_start(GTK_BOX(vbox_manual), menu_bar_manual, FALSE, FALSE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_manual), text_manual, TRUE, TRUE, 0);
   gtk_container_add(GTK_CONTAINER(frm_manual), vbox_manual);

   gtk_widget_show_all(frm_manual);
}

/* ============= Tworzenie systemu Menu w sposob "automatyczny" =============== */

/* Ponizej umieszczono kilka uwag dotyczacych struktury GtkItemFactoryEntry.
 *
 * Parametry przekazywane w postaci lancuchow tekstowych sa
 * wrazliwe na wielkosc liter. Parametr  "<separator>" wywola
 * blad w trakcie dzialania programu.  Tak samo, checkitem lub
 * Checkitem ine sa nazwa obiektu CheckItem.
 *
 * Nalezy unikac wykorzystywaniem znaku podkreslenia,
 * w separatorach (chociaz nie spowoduje to wystapienia bledu),
 * mozna wpisac sep_1 zamiast sep1. Podkreslenie oznacza
 * konkretny klawisz, ktory nalezy wcisnac wraz z przyciskiem ALT
 * w celu wykonania danego polecenia menu (jest to tzw. klawisz
 * skrotu).
 *
 */

static GtkItemFactoryEntry items[] = {
   {"/_Plik", NULL, 0, 0, "<Branch>"},
   {"/Plik/tear1", NULL, NULL, 0, "<Tearoff>"},
   {"/Plik/_Otworz", "<control>O", item_factory_clicked, 0},
   {"/Plik/sep1", NULL, NULL, 0, "<Separator>"},
   {"/Plik/_Zakoncz", "<alt>Z", item_factory_clicked, 0},
   {"/Po_moc", NULL, 0, 0, "<LastBranch>"},
   {"/Pomoc/Przycisk Wyboru", NULL, NULL, 0, "<CheckItem>"},
   {"/Pomoc/O programie", "<shift>A", item_factory_clicked, 0}
};

/* Wykorzystanie fabryki elementow oszczedzilo nam nieco pracy.
 * W ten sposob nie mozna dodac obrazkow oraz znakow /, czy innych
 * "fantazyjnych" widgetow .  Fabryka elementow
 * umozliwia tworzenie tylko podstawowych systemow menu.
 */

void cmd_item_factory_clicked()
{
   GtkWidget *vbox_item_factory;
   GtkWidget *text_item_factory;
   GtkItemFactory *menu_item_factory;
   GtkWidget *menu_bar_item_factory;
   GtkAccelGroup *accel_group_item_factory;

   frm_item_factory = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(frm_item_factory), "Prezentacja systemu menu utworzonego przez fabryke elementow");

   vbox_item_factory = gtk_vbox_new(FALSE, 0);

   accel_group_item_factory = gtk_accel_group_new();
   gtk_accel_group_attach(accel_group_item_factory,
                          GTK_OBJECT(frm_item_factory));

   /* Umieszczanie grupy *accel_group* w systemie menu nie jest wymogiem,
    * ale bez wciskanie podkreslonych klawiszy z przyciskiem ALT
    * (np. "ALT+P" dla menu Plik) nie wywola pozadanej opcji.
    *
    * Uwaga dotyczaca klawiatory:  Nalezy sprawdzic, ktory z klawiszy
    * ALT mozna uzywac w kombinacji z podkreslonymi klawiszami jako skrot do danego polecenia.
    * W niektorych komputerach tylko jeden (najczesciej prawy) ALT mozna
    * wykorzystac.
    */

   menu_item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, 
                                            "<no_path>", 
                                            accel_group_item_factory);
   gtk_item_factory_create_items(menu_item_factory,
                                 sizeof(items)/sizeof(items[0]),
                                 items,
                                 NULL);
   menu_bar_item_factory = gtk_item_factory_get_widget(menu_item_factory, "<no_path>");

   text_item_factory = gtk_text_new(NULL, NULL);

   gtk_box_pack_start(GTK_BOX(vbox_item_factory), menu_bar_item_factory, TRUE, TRUE, 0); 
   gtk_box_pack_start(GTK_BOX(vbox_item_factory), text_item_factory, TRUE, TRUE, 0); 
   gtk_container_add(GTK_CONTAINER(frm_item_factory), vbox_item_factory);

   gtk_widget_show_all(frm_item_factory);
}

/* Warto zauwazyc, ze tu trzeba bylo wpisac znacznie mniej kodu
 * niz w trakcie recznego tworzenia systemu menu
 */

void item_factory_clicked()
{
   g_print("Wcisnieto ...\n");
}

/* ============= Popup menu on Right Click ==================== */

void cmd_popup_clicked()
{
   GtkWidget *vbox_popup;
   GtkWidget *lbl_right_click;
   GtkWidget *text_right_click;
   GtkWidget *mnu_1, *mnu_2, *mnu_3;

   frm_popup = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(frm_popup), "Prezentacja menu kontekstowego");

   vbox_popup = gtk_vbox_new(TRUE, 0);

   lbl_right_click = gtk_label_new("Menu kontekstowe - \nKliknij prawym przycikiem\nw obszarze pola tekstowego");
   text_right_click = gtk_text_new(NULL, NULL);

   /* Przechwycenie zdarzen pola tekstowego.  Ponizszy kod
    * obslugi sygnalow przechwyci wszystkie zdarzenia;  w odpowiedniej,
    * funkcji mozna wybrac tylko pozadane zdarzenia.
    */
 
   gtk_signal_connect(GTK_OBJECT(text_right_click),
                      "event",
                      GTK_SIGNAL_FUNC(text_right_click_event),
                      popup_menu);

   /* Utworzenie menu kontekstowego;  bedzie to proste
    * menu, z trzema poleceniami.
    */

   popup_menu = gtk_menu_new();
   mnu_1 = gtk_menu_item_new_with_label("Polecenie 1");
   mnu_2 = gtk_menu_item_new_with_label("Polecenie 2");
   mnu_3 = gtk_menu_item_new_with_label("Polecenie 3");

   gtk_signal_connect(GTK_OBJECT(mnu_1),
                      "activate",
                      GTK_SIGNAL_FUNC(popup_mnu_1_clicked),
                      NULL);

   gtk_signal_connect(GTK_OBJECT(mnu_2),
                      "activate",
                      GTK_SIGNAL_FUNC(popup_mnu_2_clicked),
                      NULL);

   gtk_signal_connect(GTK_OBJECT(mnu_3),
                      "activate",
                      GTK_SIGNAL_FUNC(popup_mnu_3_clicked),
                      NULL);

   gtk_box_pack_start(GTK_BOX(vbox_popup), lbl_right_click, TRUE, TRUE, 0); 
   gtk_box_pack_start(GTK_BOX(vbox_popup), text_right_click, TRUE, TRUE, 0); 
   gtk_container_add(GTK_CONTAINER(frm_popup), vbox_popup);

   /* Umieszczenie obiektow w menu. */
  
   gtk_menu_append(GTK_MENU(popup_menu), mnu_1);
   gtk_menu_append(GTK_MENU(popup_menu), mnu_2);
   gtk_menu_append(GTK_MENU(popup_menu), mnu_3);

   gtk_widget_show_all(frm_popup);
}

void popup_mnu_1_clicked()
{
   g_print("Wcisnieto Polecenie 1...\n");
}

void popup_mnu_2_clicked()
{
   g_print("Wcisnieto Polecenie 2...\n");
}

void popup_mnu_3_clicked()
{
   g_print("Wcisnieto Polecenie 3...\n");
}

void text_right_click_event(GtkWidget *Widget, GdkEvent *event)
{
   /* g_print("zdarzenie w polu tekstowym...\n"); */
  
   if (event->type == GDK_BUTTON_PRESS)
     {
        GdkEventButton *buttonevent = (GdkEventButton *) event;
        /* g_print("zdarzenie przycisku...\n"); */

        if (buttonevent->button == 3)
           {
              /* g_print("zdarzenie zwiazane z kliknieciem prawego przycisku...\n"); */
              gtk_widget_show_all(popup_menu);
              gtk_menu_popup(GTK_MENU(popup_menu),
                             NULL, NULL, NULL, NULL,
                             buttonevent->button,
                             0);
           }
     }
}

