/* listing 4.1
 * Prezentacja obiektu .
 */

#include <gtk/gtk.h>

GtkWidget *frm_table;
GtkWidget *tbl;

/* Ponizsze przyciski zostana umieszczone w GtkTable w
 * 1 kolumnie.  Pierwszy z nich bedzie znajdowal sie w 1 rzedzie.
 * 1 kolumny, drugi w 2 rzedzie 1 kolumny, i tak dalej.
 */

GtkWidget *cmd_1_1;
GtkWidget *cmd_2_1;
GtkWidget *cmd_4_1;
GtkWidget *cmd_1_2;
GtkWidget *cmd_1_3;
GtkWidget *cmd_3_2;
GtkWidget *cmd_2_3;
GtkWidget *cmd_3_3;
GtkWidget *chk_1;

void destroy_main();
void make_table_buttons();
void attach_widgets();
void cmd_1_1_clicked();
void cmd_2_1_clicked();
void cmd_4_1_clicked();
void cmd_1_2_clicked();
void cmd_1_3_clicked();
void cmd_3_2_clicked();
void cmd_2_3_clicked();
void cmd_3_3_clicked();

gint main(gint argc, gchar *argv[])
{

   gtk_init(&argc, &argv);

   frm_table = gtk_window_new(GTK_WINDOW_TOPLEVEL);

   gtk_window_set_title(GTK_WINDOW(frm_table), "Prezentacja tablicy obiektow");

   gtk_signal_connect(GTK_OBJECT(frm_table),
        "destroy",
        GTK_SIGNAL_FUNC(destroy_main),
        NULL);

   make_table_buttons();

   /* Inicjacja przyciskow wartosciami domyslnymi.
    *
    * Skorzystamy tu z gtk_table_attach_defaults() zamiast
    * z funkcji attach_widgets(), aby zademonstrowac dzialanie
    * funkcji gtk_table_attach_defaults() .
    */

   gtk_table_attach_defaults(GTK_TABLE(tbl), cmd_1_1, 0, 1, 0, 1);
   gtk_table_attach_defaults(GTK_TABLE(tbl), cmd_2_1, 0, 1, 1, 3);
   gtk_table_attach_defaults(GTK_TABLE(tbl), cmd_4_1, 0, 4, 3, 4);
   gtk_table_attach_defaults(GTK_TABLE(tbl), cmd_1_2, 1, 2, 0, 2);
   gtk_table_attach_defaults(GTK_TABLE(tbl), cmd_1_3, 2, 3, 0, 1);
   gtk_table_attach_defaults(GTK_TABLE(tbl), cmd_3_2, 1, 2, 2, 3);
   gtk_table_attach_defaults(GTK_TABLE(tbl), cmd_3_3, 2, 3, 2, 3);
   gtk_table_attach_defaults(GTK_TABLE(tbl), cmd_2_3, 2, 4, 1, 2);

   chk_1 = gtk_check_button_new_with_label("Przycisk wyboru");

   gtk_table_attach_defaults(GTK_TABLE(tbl), chk_1, 3, 4, 0, 1);

   gtk_container_add(GTK_CONTAINER(frm_table), tbl);

   gtk_widget_show_all (frm_table);
   gtk_main ();
   return 0;

}

void destroy_main()
{   gtk_main_quit();
}

void attach_widgets(gint _OPTIONS, gint _PACKING)
{
   gtk_table_attach(GTK_TABLE(tbl), cmd_1_1, 0, 1, 0, 1, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
   gtk_table_attach(GTK_TABLE(tbl), cmd_2_1, 0, 1, 1, 3, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
   gtk_table_attach(GTK_TABLE(tbl), cmd_4_1, 0, 4, 3, 4, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
   gtk_table_attach(GTK_TABLE(tbl), cmd_1_2, 1, 2, 0, 2, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
   gtk_table_attach(GTK_TABLE(tbl), cmd_1_3, 2, 3, 0, 1, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
   gtk_table_attach(GTK_TABLE(tbl), cmd_3_2, 1, 2, 2, 3, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
   gtk_table_attach(GTK_TABLE(tbl), cmd_3_3, 2, 3, 2, 3, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
   gtk_table_attach(GTK_TABLE(tbl), cmd_2_3, 2, 4, 1, 2, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
   gtk_table_attach(GTK_TABLE(tbl), chk_1, 3, 4, 0, 1, _OPTIONS, _OPTIONS, _PACKING, _PACKING);
}


void make_table_buttons()
{
   tbl = gtk_table_new(4, 4, TRUE);

   /* Parametry powyzszej funkcji to:  rzedy, kolumny, oznaczenie jednorodnosci.
    */

   cmd_1_1 = gtk_button_new_with_label("Wypelnienie 9 obiektami");
   gtk_signal_connect(GTK_OBJECT(cmd_1_1),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_1_1_clicked),
        NULL);
   cmd_2_1 = gtk_button_new_with_label("Ustaw\nopcje\nFILL");
   gtk_signal_connect(GTK_OBJECT(cmd_2_1),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_2_1_clicked),
        NULL);
   cmd_4_1 = gtk_button_new_with_label("Wybierz opcje SHRINK");
   gtk_signal_connect(GTK_OBJECT(cmd_4_1),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_4_1_clicked),
        NULL);
   cmd_1_2 = gtk_button_new_with_label("Wybierz\nOpcje\nEXPAND");
   gtk_signal_connect(GTK_OBJECT(cmd_1_2),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_1_2_clicked),
        NULL);
   cmd_1_3 = gtk_button_new_with_label("Wybierz\nOpcje\nFILL\ni\nSHRINK");
   gtk_signal_connect(GTK_OBJECT(cmd_1_3),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_1_3_clicked),
        NULL);
   cmd_3_2 = gtk_button_new_with_label("Wybierz\nOpcje\nSHRINK\ni\nEXPAND");
   gtk_signal_connect(GTK_OBJECT(cmd_3_2),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_3_2_clicked),
        NULL);
   cmd_3_3 = gtk_button_new_with_label("Wybierz\nopcje\nFILL\ni\nEXPAND");
   gtk_signal_connect(GTK_OBJECT(cmd_3_3),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_3_3_clicked),
        NULL);
   cmd_2_3 = gtk_button_new_with_label("Wybierz opcje\nFILL, EXPAND i SHRINK");
   gtk_signal_connect(GTK_OBJECT(cmd_2_3),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_2_3_clicked),
        NULL);
   chk_1 = gtk_check_button_new_with_label("Przycisk wyboru");
}

void cmd_1_1_clicked()
{
   /* Tu wykorzystamy po raz pierwszy funkcje gtk_widget_destroy.
    * Po nacisnieciu przycisku przez uzytkownika, bedziemy
    * niszczyc i tworzyc od nowa cala tablice z obiektami.
    * Musimy tak postapic, bo obiekt GtkTable nie posiada funkcji
    *  *_set_* .
    *
    *
    * Nawet gdyby taka instrukcja istniala, moznaby i tak wykorzystac
    * omawiany sposob. WPisywanie podobnych funkcji dla kazdego przycisku
    * jest nudne, ale jesli samodzielnie wykonamy zmiany rozmieszczenia obiektow
    * w interfejsie, to nauczymy sie zarzadzac powierzchnia tablicy.
    */

   gtk_widget_destroy(tbl);
   make_table_buttons();
   attach_widgets(0, 9);
   gtk_container_add(GTK_CONTAINER(frm_table), tbl);
   gtk_widget_show_all (frm_table);
}

void cmd_2_1_clicked()
{
   gtk_widget_destroy(tbl);
   make_table_buttons();
   attach_widgets(GTK_FILL, 0);
   gtk_container_add(GTK_CONTAINER(frm_table), tbl);
   gtk_widget_show_all (frm_table);
}

void cmd_4_1_clicked()
{
   gtk_widget_destroy(tbl);
   make_table_buttons();
   attach_widgets(GTK_SHRINK, 0);
   gtk_container_add(GTK_CONTAINER(frm_table), tbl);
   gtk_widget_show_all (frm_table);
}

void cmd_1_2_clicked()
{
   gtk_widget_destroy(tbl);
   make_table_buttons();
   attach_widgets(GTK_EXPAND, 0);
   gtk_container_add(GTK_CONTAINER(frm_table), tbl);
   gtk_widget_show_all (frm_table);
}

void cmd_1_3_clicked()
{
   gtk_widget_destroy(tbl);
   make_table_buttons();
   attach_widgets(GTK_FILL | GTK_SHRINK, 0);
   gtk_container_add(GTK_CONTAINER(frm_table), tbl);
   gtk_widget_show_all (frm_table);
}

void cmd_3_2_clicked()
{
   gtk_widget_destroy(tbl);
   make_table_buttons();
   attach_widgets(GTK_SHRINK | GTK_EXPAND, 0);
   gtk_container_add(GTK_CONTAINER(frm_table), tbl);
   gtk_widget_show_all (frm_table);
}

void cmd_3_3_clicked()
{
   gtk_widget_destroy(tbl);
   make_table_buttons();
   attach_widgets(GTK_FILL | GTK_EXPAND, 0);
   gtk_container_add(GTK_CONTAINER(frm_table), tbl);
   gtk_widget_show_all (frm_table);
}

void cmd_2_3_clicked()
{
   gtk_widget_destroy(tbl);
   make_table_buttons();
   attach_widgets(GTK_SHRINK | GTK_FILL | GTK_EXPAND, 0);
   gtk_container_add(GTK_CONTAINER(frm_table), tbl);
   gtk_widget_show_all (frm_table);
}
