/* listing 4.2
 * Prezentacja GtkTree i GtkCTree.
 */

#include <gtk/gtk.h>

GtkWidget *frm_trees;
GtkWidget *tree_left, *ctree_right;
GtkWidget *subtree_item2;
GtkWidget *subtree_item3;
GtkWidget *subtree_widgets;

void destroy_main();
void cmd_cycle_line_style_clicked();
void cmd_cycle_expander_clicked();

gint main(gint argc, gchar *argv[])
{

   GtkWidget *hbox_main, *vbox_left, *vbox_right;
   GtkWidget *lvl1_item1, *lvl1_item2;
   GtkWidget *widgets_item;
   GtkWidget *label_widget, *button_widget, *check_box_widget;
   GtkWidget *item2_item1, *item2_item1_item1;
   GtkWidget *label_item, *button_item, *check_box_item;
   GtkWidget *cmd_cycle_line_style, *cmd_cycle_expander;

   GtkCTreeNode *root_node_1;
   GtkCTreeNode *root_node_2;
   GtkCTreeNode *root_node_3;

   /* Ponizej wpiszemy naglowki kolumn w obiekcie CTree
    * Szerokosc kolumny jest okreslona przez jej naglowek, a
    * tnie przez dane, jakie zawiera.
    */

   gchar *column_titles[2] = {"Pozycja", "Informacja"};

   gchar *root1_data[2] = {"root1", "test"};
   gchar *root2_data[2] = {"root2", "Ten posiada wezly podrzedne"};
   gchar *root3_data[2] = {"Podwezel1", "Podwezel."};

   gtk_init(&argc, &argv);

   frm_trees = gtk_window_new(GTK_WINDOW_TOPLEVEL);

   gtk_window_set_title(GTK_WINDOW(frm_trees), "Prezentacja widgetow drzew");

   gtk_signal_connect(GTK_OBJECT(frm_trees),
        "destroy",
        GTK_SIGNAL_FUNC(destroy_main),
        NULL);

   hbox_main = gtk_hbox_new(TRUE, 0);
   vbox_left = gtk_vbox_new(TRUE, 0);
   vbox_right = gtk_vbox_new(FALSE, 0);

   /* Glowna roznica pomiedzy GtkTree a GtkCTree
    * jest (tak samo, jak miedzy GtkList a GtkCList) fakt, ze
    * GtkTree akceptuje wszystkie widgety, a
    *  GtkCTree - tylko pixmapy i tekst.
    */

   tree_left = gtk_tree_new();

   /* Drzewo nie jest przydatnym obiektem, jesli nic nie zawiera.
    * Na szczescie, dodawanie nowych elementow do drzewa jest bardzo proste....
    */

   lvl1_item1 = gtk_tree_item_new_with_label("Poziom 1, Element 1");
   lvl1_item2 = gtk_tree_item_new_with_label("Poziom 1, Element 2");

   gtk_tree_append(GTK_TREE(tree_left), lvl1_item1);
   gtk_tree_append(GTK_TREE(tree_left), lvl1_item2);

   /* Na razie nasze drzewo przypomina bardziej pole listy.
    * Zalety drzewa beda bardziej widoczne, gdy umiescimy w nim
    * poddrzewo.  Poddrzewa dodaje sie troche inaczej od wezlow i
    * wskaznikow, ktore zapewniaja strukture poddrzewa.
    *
    * Nie bedziemy umieszczac drzewa w drzewie, lecz dodamy
    * drzewo do elementu drzewa.
    */

   subtree_item2 = gtk_tree_new();
   item2_item1 = gtk_tree_item_new_with_label("Poziom 2, Element 1");
   gtk_tree_append(GTK_TREE(subtree_item2), item2_item1);

   gtk_tree_item_set_subtree(GTK_TREE_ITEM(lvl1_item2), subtree_item2);

   /* Teraz trzeba jawnie pokazac elementy poddrzewa.
    *
    * Jesli uzytkownik zanzaczy eleemnty poddrzewa, a nastepnie zwinie
    * jego galaz, to te elementy nadal beda zaznaczone.
    */

   gtk_widget_show(item2_item1);

   subtree_item3 = gtk_tree_new();
   item2_item1_item1 = gtk_tree_item_new_with_label("Poziom 3, Element 1");
   gtk_tree_append(GTK_TREE(subtree_item3), item2_item1_item1);

   gtk_tree_item_set_subtree(GTK_TREE_ITEM(item2_item1), subtree_item3);

   gtk_widget_show(item2_item1_item1);

   widgets_item = gtk_tree_item_new_with_label("Widgety");
   gtk_tree_append(GTK_TREE(tree_left), widgets_item);

   subtree_widgets = gtk_tree_new();
   gtk_tree_item_set_subtree(GTK_TREE_ITEM(widgets_item), subtree_widgets);

   /* Dodajmy kilka widgetow do ddrzewa.
    *
    * Najpierw utworzymy etykiete
    *
    */

   label_item = gtk_tree_item_new();
   label_widget = gtk_label_new("To jest etykieta");
   gtk_container_add(GTK_CONTAINER(label_item), label_widget);
   gtk_tree_append(GTK_TREE(subtree_widgets), label_item);
   gtk_widget_show(label_widget);
   gtk_widget_show(label_item);

   /* Nastepnie, umiescimy w drzewie przycisk.
    */

   button_item = gtk_tree_item_new();
   button_widget = gtk_button_new_with_label("To jest przycisk.");
   gtk_container_add(GTK_CONTAINER(button_item), button_widget);
   gtk_tree_append(GTK_TREE(subtree_widgets), button_item);
   gtk_widget_show(button_widget);
   gtk_widget_show(button_item);

   /* A teraz pole wyboru.
    */

   check_box_item = gtk_tree_item_new();
   check_box_widget = gtk_check_button_new_with_label("To jest pole wyboru.");
   gtk_container_add(GTK_CONTAINER(check_box_item), check_box_widget);
   gtk_tree_append(GTK_TREE(subtree_widgets), check_box_item);
   gtk_widget_show(check_box_widget);
   gtk_widget_show(check_box_item);

   /* Porownajmy to z drzewem CTree .
    */

   ctree_right = gtk_ctree_new_with_titles(2, 0, column_titles);

   root_node_1 = gtk_ctree_insert_node(GTK_CTREE(ctree_right), NULL, NULL, root1_data,
                   0, NULL, NULL, NULL, NULL, FALSE, TRUE);
   root_node_2 = gtk_ctree_insert_node(GTK_CTREE(ctree_right), NULL, NULL, root2_data,
                   0, NULL, NULL, NULL, NULL, FALSE, TRUE);
   root_node_3 = gtk_ctree_insert_node(GTK_CTREE(ctree_right), root_node_2, NULL, root3_data,
                   0, NULL, NULL, NULL, NULL, FALSE, TRUE);

   /* Konstrukcja drzewa CTree jest znacznie prostsza.
    * Wystarczy utworzyc jeden egzemplarz tego widgeta, a natepnie
    * tworzyc wezly i laczyc je z wezlami w drzewie.  Oto
    * parametry dla funkcji gtk_ctree_insert_node:
    *
    *     ctree              Obiekt CTree.
    *     parent             Oznacza wezel nadrzedny, NULL dla wezla glownego.
    *     sibling            Oznacza wezel "siostrzany";  NULL to zakonczenie galezi.
    *     text               Tablica z wartosciami poszczegolnych kolumn; musi
    *                            liczba wartosci jest rowna liczbie kolumn
    *                           umieszczopnych w ctree.
    *     spacing            Liczba pikseli pomiedzy struktura drzewa
    *                            a tekstem.
    *     pixmap_closed      \
    *     bitmask_closed      \  Odpowiednie ikony do wyswietlenia
    *     pixmap_opened       /  gdy wezel jest rozwiniety lub zwiniety.
    *     bitmask_opened     /
    *     is_leaf            Wartosc logiczna okreslajaca, czy element nie jest wezlem;
    *                        TRUE, oznacza, ze element nie zawiera wezlow podrzednych
    *                            (nie mozna tam umiescic zadnych wezlow podrzednych)
    *     expanded          Wartosc logiczna okreslajaca, czy dany wezel jest rozwiniety,
    *                            czy nie.
    *
    */

   cmd_cycle_line_style = gtk_button_new_with_label("Style linii");
   gtk_signal_connect(GTK_OBJECT(cmd_cycle_line_style),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_cycle_line_style_clicked),
        NULL);

   cmd_cycle_expander = gtk_button_new_with_label("Style rozwijaczy");
   gtk_signal_connect(GTK_OBJECT(cmd_cycle_expander),
        "clicked",
        GTK_SIGNAL_FUNC(cmd_cycle_expander_clicked),
        NULL);

   gtk_box_pack_start(GTK_BOX(vbox_left), tree_left, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_right), ctree_right, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_right), cmd_cycle_line_style, TRUE, FALSE, 0);
   gtk_box_pack_start(GTK_BOX(vbox_right), cmd_cycle_expander, TRUE, FALSE, 0);
  
   gtk_box_pack_start(GTK_BOX(hbox_main), vbox_left, TRUE, TRUE, 0);
   gtk_box_pack_start(GTK_BOX(hbox_main), vbox_right, TRUE, TRUE, 0);
   gtk_container_add(GTK_CONTAINER(frm_trees), hbox_main); 

   gtk_widget_show_all (frm_trees);
   gtk_main ();
   return 0;

}

void destroy_main()
{   gtk_main_quit();
}


void cmd_cycle_line_style_clicked()
{
   static gint line_style = 1;

   if (line_style == 4)
       line_style = 1;
   else line_style++;

   switch (line_style)
    {
      case 1: gtk_ctree_set_line_style(GTK_CTREE(ctree_right),
                                       GTK_CTREE_LINES_NONE);
              break;
      case 2: gtk_ctree_set_line_style(GTK_CTREE(ctree_right), 
                                       GTK_CTREE_LINES_SOLID);
              break;
      case 3: gtk_ctree_set_line_style(GTK_CTREE(ctree_right), 
                                       GTK_CTREE_LINES_DOTTED);
              break;
      case 4: gtk_ctree_set_line_style(GTK_CTREE(ctree_right), 
                                       GTK_CTREE_LINES_TABBED);
              break;
      default:  g_print("Ta linia nie powinna byc widoczna!!");
                break;
    }

}

void cmd_cycle_expander_clicked()
{
   static gint expander_style = 1;

   if (expander_style == 4)
       expander_style = 1;
   else expander_style++;

   switch (expander_style)
    {
      case 1: gtk_ctree_set_expander_style(GTK_CTREE(ctree_right), 
                                           GTK_CTREE_EXPANDER_NONE);
              break;
      case 2: gtk_ctree_set_expander_style(GTK_CTREE(ctree_right), 
                                           GTK_CTREE_EXPANDER_SQUARE);
              break;
      case 3: gtk_ctree_set_expander_style(GTK_CTREE(ctree_right), 
                                           GTK_CTREE_EXPANDER_TRIANGLE);
              break;
      case 4: gtk_ctree_set_expander_style(GTK_CTREE(ctree_right), 
                                           GTK_CTREE_EXPANDER_CIRCULAR);
              break;
      default:  g_print("Ta linia nie powinna byc widoczna!!");
                break;
    }

}
