/* listing 4.3
 *Prezentacja GtkFixed .
 */

#include <gtk/gtk.h>
#include <stdlib.h>
/* Biblioteka <stdlib.h> jest potrzebna do
 * wyznaczania wartosci losowych w funkcji zwrotnej Wartosci 
 * losowe beda potrzebna do przemieszczania przycisku po 
 * powierzchni obiektu GtkFixed.
 */

GtkWidget *frm_fixed;
GtkWidget *fixed_main;
GtkWidget *cmd1;

void destroy_main();
void cmd1_clicked();

gint main(gint argc, gchar *argv[])
{
   gtk_init(&argc, &argv);

   frm_fixed = gtk_window_new(GTK_WINDOW_TOPLEVEL);

   gtk_window_set_title(GTK_WINDOW(frm_fixed), "Prezentacja obiektu GtkFixed");

   gtk_signal_connect(GTK_OBJECT(frm_fixed),
        "destroy",
        GTK_SIGNAL_FUNC(destroy_main),
        NULL);

   fixed_main = gtk_fixed_new();

   /* GtkFixed jest obiektem prostym w uzyciu.  Nalezy
    * podac wspolrzedne polozenia kazdego widgetu potomnego,
    * umieszczanego na powierzchni GtkFixed.  Atrybuty fill,
    * expand, padding, itd., sa tu bezuzyteczne;  obiekty
    * potomne, umieszczone na powierzchni GtkFixed, beda domyslnie
    * zajmowac najmniejszy obszar, pozwalajacy na ich wyswietlenie.
    * Tak samo zachowa sie sam obiekt GtkFixed, ktory bedzie domyslnie
    * zajmowal minimalna powierzchnie ekranu potrzebna do wyswietlenia
    * wszystkich jego obiektow.  Jesli widget potomny zostanie przesuniety
    * poza biezacy obszar GtkFixed, to ten widget zmieni odpowiednio
    * swoje wymiary tak, aby przesuniety obiekt nadal byl widoczny.
    * Jesli obiekt potomny zostanie umieszczony w pozycji pozwalajacej
    * na zmniejszenie rozmiarow okna glownego, GtkFixed
    * nie zmniejszy automatycznie swej powierzchni.
    *
    *
    * To moze prowadzic do dziwnych i nieoczekiwanych zachowan.
    * okna glownego w trakcie dzialania programu. Zalozmy
    * przykladowa pozycje obiektu 1,1. Przesunmy obiekt na pozycje 100, 100
    * (okno glowne sie dostosuje do nowego polozenia). Gdy zmienimy polozenie
    * obiektu na 50,50, okno nie zmniejszy sie. Gdy jednak przeniesiemy
    * obiekt na 150,50, to okno glowne znow zmieni swoj rozmiar do minimum tak, aby
    * wyswietlany obiekt zmiescil sie na jego powierzchni.
    * Okno glowne jest rysowane ponownie za kazdym razem, gdy obiekty nalezace do
    * niego zostana umieszczone poza powierzchnia GtkFixed. Okno glowne, ktore
    * pierwotnie bylo kwadratem, moze stac sie np.
    * bardzo cienkim i dlugim prostokatem.
    *
    * Wprawdzie GtkFixed jest bardzo latwy w implementacji,
    * programisci czesciej korzystaja z GtkLayout
    * Przed dokonaniem wyboru "ulubion4ego okna", sprawdzmy
    * wady i zalety kazdego z nich (GtkFixed i GtkLayout).
    */

   cmd1 = gtk_button_new_with_label("Przycisk 1");
   gtk_signal_connect(GTK_OBJECT(cmd1),
        "clicked",
        GTK_SIGNAL_FUNC(cmd1_clicked),
        NULL);
   gtk_fixed_put(GTK_FIXED(fixed_main), cmd1, 1, 100);

   /* Trzecim i czwartym parametrem powyzszej funkcji
    * sa odpowiednio: odleglosc od lewej krawedzi okna (w pikselach),
    * i odleglosc od gornej krawedzi okna (rowniez w
    * pikselach).
    */

   gtk_container_add(GTK_CONTAINER(frm_fixed), fixed_main);

   gtk_widget_show_all (frm_fixed);
   gtk_main ();
   return 0;

}

void destroy_main()
{   gtk_main_quit();
}

void cmd1_clicked()
{
   gint x_pos, y_pos;

   x_pos = rand();
   y_pos = rand();

   /* Tu generujemy liczby losowe w zakresie od 1 do 200,
    * ktore posluza nam jako nowe lokalizacje przycisku.
    */

   do{
      x_pos = x_pos - 200;
   } while (x_pos > 200);

   do{
      y_pos = y_pos - 200;
   } while (y_pos > 200);

   gtk_fixed_move(GTK_FIXED(fixed_main), GTK_WIDGET(cmd1), x_pos, y_pos);
}

