/* listing 4.4
 * Prezentacja GtkLayout.
 */

#include <gtk/gtk.h>
#include <stdlib.h>

GtkWidget *frm_layout;
GtkWidget *layout_main;
GtkWidget *cmd1;

void destroy_main();
void cmd1_clicked();

gint main(gint argc, gchar *argv[])
{
   gtk_init(&argc, &argv);

   frm_layout = gtk_window_new(GTK_WINDOW_TOPLEVEL);

   gtk_window_set_title(GTK_WINDOW(frm_layout), "Prezentacja obiektu GtkLayout");

   gtk_signal_connect(GTK_OBJECT(frm_layout),
        "destroy",
        GTK_SIGNAL_FUNC(destroy_main),
        NULL);

   layout_main = gtk_layout_new(NULL, NULL);

   /* Zamiast wywolywac funkcje gtk_layout_new(),ktora  jako parametry
    * potrzebuje obiektow regulacyjnych (poziomych i pionowych)
    * mozna skorzystac z poprzedniego listingu
    * i w instrukcjach tworzacych obiekty zamienic
    * slowko "fixed" na "layout".
    *
    * Ten program jest podobny do poprzedniego, ale posiada
    * kilka dodatkowych instrukcji prezentujacych
    * mozliwosci obiektu GtkLayout.
    */

   cmd1 = gtk_button_new_with_label("Przycisk 1");
   gtk_signal_connect(GTK_OBJECT(cmd1),
        "clicked",
        GTK_SIGNAL_FUNC(cmd1_clicked),
        NULL);
   gtk_layout_put(GTK_LAYOUT(layout_main), cmd1, 1, 100);

   gtk_container_add(GTK_CONTAINER(frm_layout), layout_main);

   gtk_widget_show_all (frm_layout);
   gtk_main ();
   return 0;

}

void destroy_main()
{   gtk_main_quit();
}

void cmd1_clicked()
{
   gint x_pos, y_pos;

   x_pos = rand();
   y_pos = rand();

   /* Tu generujemy liczby losowe w zakresie od 1 do 200,
    * ktore posluza nam jako nowe lokalizacje przycisku.
    */


   do{
      x_pos = x_pos - 200;
   } while (x_pos > 200);

   do{
      y_pos = y_pos - 200;
   } while (y_pos > 200);

   /* Oto najwieksza roznica pomiedzy GtkFixed a GtkLayout.
    * Zamiast rysowac od nowa okno wraz z jego elementami, lepiej
    * zablokowac i odblokowac go po uprzednim przemieszczeniu .
    * jego obiektow.
    */

   gtk_layout_freeze(GTK_LAYOUT(layout_main));

   gtk_layout_move(GTK_LAYOUT(layout_main), GTK_WIDGET(cmd1), x_pos, y_pos);

   gtk_layout_thaw(GTK_LAYOUT(layout_main));
}

