/* listing 4.7
 * DePrezentacja obiektu GtkPaned.
 */

#include <gtk/gtk.h>

GtkWidget *frm_paned;

void destroy_main();

gint main(gint argc, gchar *argv[])
{
   GtkWidget *lbl_hpaned1_left;
   GtkWidget *lbl_vpaned1_top;
   GtkWidget *lbl_hpaned2_left;
   GtkWidget *lbl_vpaned2_top;
   GtkWidget *lbl_vpaned2_bottom;
   GtkWidget *hpaned1;
   GtkWidget *vpaned1;
   GtkWidget *hpaned2;
   GtkWidget *vpaned2;

   gtk_init(&argc, &argv);

   frm_paned = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(frm_paned), "Prezentacja GtkPaned");

   gtk_signal_connect(GTK_OBJECT(frm_paned),
        "destroy",
        GTK_SIGNAL_FUNC(destroy_main),
        NULL);

   hpaned1 = gtk_hpaned_new();
   gtk_paned_gutter_size(GTK_PANED(hpaned1), 20);
   gtk_paned_handle_size(GTK_PANED(hpaned1), 20);
   lbl_hpaned1_left = gtk_label_new("hpaned1 na lewo\nOpcja Resize TRUE\nOpcja Shrink TRUE");
   gtk_paned_pack1(GTK_PANED(hpaned1), lbl_hpaned1_left, TRUE, TRUE);

   /* Wywolanie funkcji gtk_paned_gutter_size() umozliwia ustalenie
    * pomiedzy panelem a widgetami istniejacymi obok.  Warto zauwazyc,
    * zw niewielki odstep wyglada estetycznie w interfejsie uzytkownika.
    *
    * gtk_paned_handle_size() powoduje umieszczenie malego, kwadratowego przycisku,
    * dzieki ktoremu uzytkownik moze zmienic rozmiary panela.
    *
    * gtk_paned_pack1() powoduje umieszczenie innego obiektu
    * w lewej, poziomej czesci panelu, lub w gornej
    * pionowej czesci panelu. gtk_paned_pack2() sluzy (patrz ponizej)
    * do umieszczenia obiektow w dolnej lub prawej czesci ,
    * panela hpaned lub vpaned.
    *
    * Parametry funkcji gtk_paned_pack*()
    *    pane     panel docelowy
    *    child     widget potomny, umieszczany w lewej/prawej lub gornej/dolnej czesci.
    *    resize    jesli  wartosc true, obiekt potomny zmieni rozmiary odpowiednio
    *                 do zmian proporcji w oknie glownym
    *
    *    shrink    jwsli wartosc false, panel nie bedzie mogl miec mniejszej powierchni
    *                 niz powierzchnia obiektu potomnego.
    */

   vpaned1 = gtk_vpaned_new();
   gtk_paned_gutter_size(GTK_PANED(vpaned1), 20);
   lbl_vpaned1_top = gtk_label_new("vpaned1 gora\nOpcja Resize TRUE\nOpcja Shrink FALSE");
   gtk_paned_pack2(GTK_PANED(hpaned1), vpaned1, TRUE, FALSE);
   gtk_paned_pack1(GTK_PANED(vpaned1), lbl_vpaned1_top, TRUE, FALSE);

   hpaned2 = gtk_hpaned_new();
   gtk_paned_handle_size(GTK_PANED(hpaned2), 20);
   lbl_hpaned2_left = gtk_label_new("hpaned2 na lewo\nOpcja Resize FALSE\nOpcja Shrink TRUE");
   gtk_paned_pack2(GTK_PANED(vpaned1), hpaned2, FALSE, TRUE);
   gtk_paned_pack1(GTK_PANED(hpaned2), lbl_hpaned2_left, FALSE, TRUE);

   vpaned2 = gtk_vpaned_new();
   gtk_paned_gutter_size(GTK_PANED(vpaned2), 5);
   gtk_paned_handle_size(GTK_PANED(vpaned2), 5);
   lbl_vpaned2_top = gtk_label_new("vpaned2 gora\nResize FALSE\nOpcja Shrink FALSE");
   lbl_vpaned2_bottom = gtk_label_new("vpaned2 dol");
   gtk_paned_pack2(GTK_PANED(hpaned2), vpaned2, FALSE, FALSE);
   gtk_paned_pack1(GTK_PANED(vpaned2), lbl_vpaned2_top, FALSE, FALSE);
   gtk_paned_pack2(GTK_PANED(vpaned2), lbl_vpaned2_bottom, FALSE, FALSE);

   gtk_container_add(GTK_CONTAINER(frm_paned), hpaned1);

   gtk_widget_show_all (frm_paned);
   gtk_main ();
   return 0;

}

void destroy_main()
{   gtk_main_quit();
}
