

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include <mysql.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "comm_utils.h"

GtkWidget *frm_table_display;

GtkWidget *create_ddc (gchar *table_name)
{
/*Ten widget utworzy i zwroci obiekt Scrolled Window, w ktorym
 * zostanie umieszczony obiekt CList, zawierajacy odpowiednie dane. Aby ta
 * funkcja byla bardziej niezalezna od tworzonego projektu,zmienna
 * polaczenia z baza danych zostanie przekazana w postaci
 * parametru  */
  MYSQL     *conx;		// Polaczenie z baza danych.
  GtkWidget *scrolledwindow1;	// Pojemnik dla obiektu clist_table1.
  GtkWidget *clist_table;	// Tabela, w ktorej wyswietlimy dane.
  GtkWidget *label;
  gint      counter;
  gint      cols = 3;		// Domyslna liczba kolumn tabeli
  gchar     *sql;		// Zmienna dla lancucha zapytania sql
  MYSQL_RES *result_set;	// Przechowuje dane zwrocone w wyniku wykonania zapytania
  MYSQL_ROW db_row;		// Pojedynczy rekord obiektu result_set.
  MYSQL_FIELD *field;		// Pojedyncze pole z db_row

  /*row[20] jest zmienna, w ktorej znajduja
   * sie miejsca dla naglowkow kolumn.
   * Utworzymy dwadziescia takich miejsc, 
   * dzieki czemu bedziemy mieli pewnosc,
   * ze kazda tabela sie zmiesci w liscie. 
   */
  gchar     *row[20] = {"", "", "", "", "",
                        "", "", "", "", "",
                        "", "", "", "", "",
                        "", "", "", "", ""};

  /* Teraz utworzymy obiekt Scrolled Window, w ktorym umiescimy liste CList */

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);

  conx = mysql_init(0L);
  if (conx == 0L)
    {
       g_print("blad w mysql_init ...\n");
       return 0L;
    }

  mysql_real_connect (conx, "localhost", "com_user", "syL0U812", "commish", 0, 0L, 0);
  if (conx == 0L)
    {
       g_print("blad w mysql_real_connect ...\n");
       return 0L;
    }

  sql = g_strconcat("select * from ", table_name, 0L);

  g_print("sql :  %s\n", sql);

  if (mysql_query (conx, sql) != 0)
   {
      g_print("blad w zapytaniu...\n");
      return 0L;
   }
  
  result_set = mysql_store_result (conx);
  /* Sprawdzimy, ile kolumn znalazlo sie w wyniku wykonania
   * zapytania. Zwrocona wartosc oznacza liczbe kolumn w CList.
   */

  cols = mysql_num_fields(result_set);

  /* Utworzymy nowy obiekt CList i sprawimy, ze bedzie
   * dostepny w oknie frm_display_table*/

  clist_table = gtk_clist_new (cols);

  gtk_object_set_data_full(GTK_OBJECT(frm_table_display), "clist_table",
             clist_table, 0L);

  gtk_widget_show (clist_table);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist_table);

  gtk_clist_column_titles_show (GTK_CLIST (clist_table));

  /* Teraz umiescimy naglowki kolumn */

  for (counter = 0; counter < cols; counter++)
    {
       mysql_field_seek(result_set, counter);
       field = mysql_fetch_field(result_set);

       label = gtk_label_new (field->name);
       gtk_widget_show (label);
       gtk_clist_set_column_widget (GTK_CLIST (clist_table), counter, label);
       gtk_clist_set_column_width (GTK_CLIST (clist_table), counter, 80);
    }

  /* nastepnie, przejdziemy wiersz po wierszu i dodamy
   * kazdy rekord do obiektu clist_table.  */

  while ((db_row = mysql_fetch_row (result_set)) != 0L)
     {  
        for (counter = 0; counter < cols; counter++)
          {
              row[counter] = db_row[counter];
          }

        gtk_clist_append(GTK_CLIST(clist_table), row);

     }

  mysql_close(conx);
  /*Zwrocimy widget Scrolled Window, ktory zawiera odpowiednie
   * dane. 
   */

  return scrolledwindow1;
}

