
#include <gtk/gtk.h>
#include <mysql.h>

/* string.h zawiera funkcje strlen() */
/* time.h jest potrzebna dla funkcji zwiazanych z data i czasem. */
/* stdio.h jest potrzebna do operacji na plikach. */


#include <string.h>
#include <time.h>
#include <stdio.h>

#include "support.h"
#include "ddc.h"

#define SERVER "localhost"
#define LOGIN  "com_user"
#define PASS   "syL0U812"
#define DB     "commish"

GtkWidget *frm_login;
GtkWidget *frm_table_display;
GtkWidget *frm_commissions;

/* Ponizej znajduje sie deklaracja zmiennych, ktore bedziemy
 * wykorzystywac w wielu funkcjach. Nie musza byc dostepne
 * globalnie, ale jesli nie beda dostepne globalnie, to trzeba bedzie
 * deklarowac je ponownie w kazdej z funkcji i przekazywac odpowiednie
 * wartosci dla kazdej z nich.
 */

MYSQL       *conx;
MYSQL_RES   *result_set;
MYSQL_ROW   row;
gchar       *sql;
gchar       *user_login;

/* Function prototypes. */

/*
void log_event(gchar *event_msg);
void set_message(gchar *msg);
gboolean check_login_and_password();
gboolean set_new_password();
GList *get_table_names();
void fill_table_combos();
void archive_tbl_commissions();
void load_tbl_revenue();
void process_customer_commissions();
void process_worldwide();
void process_state();
void process_area(gchar *area);
*/

/* Begin function code. */

void log_event(gchar *event_msg)
{
    /* Ta procedura sluzy do zapisu informacji o uzytkownikach
     * logujacych sie do systemu.
     *
     * Pozadana dla nas informacja powinna byc nazwa
     * komputera, z ktorego nastapila proba zalogowania sie.
     * My skorzystalismy wczesniej z instrukcji GRANT,
     * dzieki ktorej zapewniamy dostep tylko do wyznaczonych
     * komputerow, wiec nie musimy sprawdzac, z ktorej
     * maszyny zalogowano sie do bazy.
     *
     * Funkcja g_get_user_name() pobiera nazwe uzytkownika
     * na poziomie systemu operacyjnego.
     * W tym przypadku aplikacja posiada wlasny zestaw nazw uzytkownika
     * i hasel;  funkcja g_get_user_name() stanowi "podwojne
     * zabezpieczenie" i jest pomocna, gdy nastepuje
     * proba zalogowania sie przez nieuprawnionego
     * uzytkownika.  Ta funkcja moze byc uzyta w celu
     * bezposredniego przekazania aplikacji nazwy uzytkownika
     * systemu do aplikacji, dzieki czemu mozna uniknac koniecznosci
     * uwierzytelniania uzytkownika w samej aplikacji.
     */

   sql = g_strconcat("insert into tbl_zdarzenia ",
                     "(nazwa_uzytkownika, zdarzenie) ",
                     "values ('", user_login, "', '", event_msg,
                     " local login: ", g_get_user_name(), "')",
                     0L
                    );
     /* Ponizsze funkcje g_print zostaly ujete w komentarzu,
      * bo sluzyly tylko w celu sprawdzenia poprawnosci
      * dzialania poszczegolnych jego czesci - teraz
      * sa niepotrzebne*/

   // g_print ("inicjacja  mysql...\n");
   conx = mysql_init(0L);
   if (conx == 0L) g_print("problem w init...\n");

   // g_print("poolaczenie z mysql...\n");
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);
   // g_print("polaczenie zestawione..\n");
   if (conx == 0L) g_print("problem w real connect...\n");

   // g_print("wykonywanie zapytania...\n");
   mysql_query (conx, sql);

   // g_print("zamykanie polaczenia...\n");
   mysql_close (conx);


}

void set_message(gchar *msg)
{
  /* Istnieja dokladnie trzy obiekty, ktore sluza do przekazyawania :
   * komunikatow uzytkownikowi: etykieta w dolnej czesci frm_login,
   * oraz paski stanu w pozostalych oknach. Dla ulatwienia, bedziemy
   * umieszczac komunikaty jednoczesnie w kazdym z nich.
   */

  g_print("set_message: %s\n", msg);

  gtk_label_set_text(GTK_LABEL(lookup_widget(frm_login,
                     "lbl_messages")), msg);

  gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_table_display,
                                   "statusbar")), 1, msg);

  gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_commissions,
                                   "statusbar_processing")), 1, msg);

  /* Moznaby tu rowniez przekazac komunikat msg do log_evento log_event
   * (bardzo szczegolowe uwierzytelnienie).
   */

  g_print("wyjscie z  set_message...\n");
};

gboolean check_login_and_password()
{
    g_print("kontrola nazwy uzytkownika i hasla.\n");
    /* Pobranie nazwy uzytkownika i hasla z pol tekstowych
     * okna frm_login*/

    user_login = gtk_editable_get_chars(GTK_EDITABLE(
                             lookup_widget(frm_login, "entry_name")),
                             0, -1);

    g_print("user_login is %s\n", user_login);
    /* Utworzenie odpowiedniego zapytania SQL, ktore zwroci odpowiedni rekord,
     * jesli nazwa uzytkownika i haslo sa poprawne */

    sql = g_strconcat("select * from ",
                      "tbl_bezpieczenstwo where nazwa_uzytkownika = '",
                      user_login,
                      "' and haslo = password('",
                      gtk_editable_get_chars(GTK_EDITABLE(
                             lookup_widget(frm_login, "entry_password")),
                             0, -1),
                      "')", 0L);

   /* W niniejszej aplikacji zastosujemy inny sposob wspolpracy
    * z baza danych. Bedziemy sie laczyc na czas wykonania
    * okreslonej operacji, a po jej zakonczeniu - rozlaczymy sie.
    * Nie bedziemy utrzymywac przez caly czas dzialania programu
    * polaczenia z baza danych.
    *
    * Ponizej wykonamy pierwsza probe polaczenia sie z baza,
    * wiec dokladnie sprawdzimy, czy polaczenie zostanie poprawnie
    * nawiazane. Jesi nie, wyswieltlimy uzytkownikowi odpowiedni
    * komunikat o wystapieniu bledu. W dalszej czesci programu,
    * jesli ponizsza proba polaczenia zakonczy sie sukcesem,
    * zalozymy, ze polaczenie na pewno bedzie nazwiazywane poprawnie
    * i nie bedziemy wiecej go sprawdzac.
    */

   g_print("proba inicjacji...\n");
   if ((conx = mysql_init(0L)) == 0L)
      {
         set_message("Nie mozna zainicjaowac polaczenia z mysql.");
         return FALSE;
      }
   g_print("funkcja init wykonana...\n");

   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   if (conx == 0L)
      {
         mysql_close(conx);
         set_message("Nie mozna nawiazac polaczenia z baza danych.");
         return FALSE;
      }
   g_print("funkcja real_connect wykonana...\n");

   if (mysql_query (conx, sql) != 0)
      {
         g_print("blad w zapytaniu...\n");
         mysql_close(conx);
         set_message("Nie mozna wykonac zapytania.");
         return FALSE;
      }

   set_message("Polaczano z baza danych...");

   result_set = mysql_store_result(conx);
   /* Jesli nazwa uzytkownika i hasla sa poprawne, baza powinna zwrocic
    * dokladnie jeden rekord*/

   if (mysql_num_rows (result_set) == 1)
      {
          mysql_free_result (result_set);
          mysql_close(conx);
          set_message("Uzytkownik zalogowany");
   /* Po zalogowaniu uzytkownika musimy zapisac w bazie dokladny
    * czas jego rozpoczecia pracy w systemie. Tabela przechowuje
    * te informacje w postaci znacznika czasu ( w formacie
    * RRRRMMDDggmmss, R - rok, M - miesiac, itd. */

          log_event(g_strconcat("Zalogowano uzytkownika ",
                                user_login, 0L));
          return TRUE;
      }
   else
      {
          mysql_free_result (result_set);
          mysql_close(conx);
          set_message("Nie mozna zalogowac uzytkownika. Skontaktuj sie z administratorem.");

          log_event(g_strconcat("Bledny login uzytkownika ",
                                user_login, 0L));
          return FALSE;
      }

}

gboolean set_new_password()
{
   gchar     *str_new_pwd;
   gchar     *str_new_again;

   /* Najpierw trzeba sprawdzic, czy uzytkownik wpisal
    * cokolwiek w polu haslo, oraz czy haslo i haslo kontrolne sa
    * takie same, itp. Pamietajmy, ze nazwy uzytkownika
    * mozna najczesciej wpisywac literami o dowolnej wielkosci,
    * ale w haslach wielkosc liter ma znaczenie.
    */

   g_print("rozpoczecie funkcji  set_new_password...\n");
   log_event(g_strconcat(user_login, " proba ustanowienia "
                         "nowego hasla. ", 0L));
   /* Uzytkownik wprowadzil haslo i haslo kontrolne*/

   str_new_pwd =  gtk_editable_get_chars(GTK_EDITABLE(
                             lookup_widget(frm_login, "entry_new_password")),
                             0, -1);
   str_new_again =  gtk_editable_get_chars(GTK_EDITABLE(
                             lookup_widget(frm_login,
                             "entry_new_password_again")),
                             0, -1);
   /* Ponizsza funkcja ustawia minimalna wielkosc hasla jako 1 znak.
    * Jesli uzytwkonik nie wpisze zadnego znaku, wystapi blad.
    */

   if (strlen(str_new_pwd) == 0)
     {
        set_message("Nowe haslo musi miec conajmniej jeden znak.");
        return FALSE;
     }
   /* Tu skorzystamy z funkcji strcmp() zamiast z g_strcasecmp().Funkcja
    * g_strcasecmp nie rozroznia wielkosci liter, co jest zachowaniem
    * niepozadanym w tym przypadku.
    */

   if (strcmp(str_new_pwd, str_new_again) == 0)
      {
         set_message("New passwords matched...\n");
         sql = g_strconcat("update tbl_security ",
                           "set pass_word = password('", str_new_pwd, "') ",
                           "where user_login = '", user_login, "'",
                           0L);

         g_print("sql %s\n", sql);
    /* Nowe haslo zostalo wprowadzone pprawnie dwa razy,
     * zaakceptujemy je i wprowadzimy do bazy danych
     */


         conx = mysql_init(0L);
         conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);
         if (mysql_query (conx, sql) != 0)
            {
               set_message("Nie mozna zmienic hasla.  "
                           "Wykonanie zapytania nie powiodlo sie.\n"
                           "Wcisnij Logowanie aby zalogowac sie "
                           "ze starym haslem.");
               mysql_close(conx);
               return FALSE;
            }
         else
            {
               set_message("Haslo zostalo zmienione.");
               mysql_close(conx);

               log_event(g_strconcat(user_login, " haslo zmieniono. ", 0L));
               return TRUE;

            }

      }
   else
      {
         set_message("Haslo nie zgadza sie z haslem kontrolnym.\n");
         return FALSE;
      }

   return FALSE;

}

GList *get_table_names()
{
    GList *list_of_tables = 0L;
    /* Wykonamy odpowiednie zapytanie i dostaniemy w odpowiedzi wykaz
     * tabel dostepnych dla zalogowanego uzytkownika.
     */

    conx = mysql_init(0L);
    conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

    sql = g_strconcat("select * from tbl_uprawnienia ",
                      "where nazwa = '", user_login, "'",
                      0L);
    /* Tabela tbl_permissions zawiera wykaz uprawnien danych
     * uzytkownikow */

    if (mysql_query (conx, sql) != 0)
        {
            set_message("Nie otrzymano wykazu tabel");
            log_event(g_strconcat("Nie otrzymano wykazu tabel",
                             " dla uzytkownika ", user_login, 0L));
        }
    else
        {
            result_set = mysql_store_result (conx);
            while (( row = mysql_fetch_row (result_set)) != 0L)
                {
                  if (strcmp(row[1], "przetwarzanie") != 0)
                     list_of_tables = g_list_append(list_of_tables, row[1]);
                  else
                     gtk_widget_show(lookup_widget(frm_table_display,
                                "cmd_process"));
                }
        }

    mysql_close(conx);
    return list_of_tables;

}

void fill_table_combos()
{
    /* Ta funkcja sluzy do wypelnienia odpowiednimi wartosciami rozwijanych
     * pol tekstowych, zgodnie z uprawnieniami uzytkownika.
     */

    gtk_combo_set_popdown_strings(GTK_COMBO(lookup_widget(frm_table_display,
                     "cbo_tables")), get_table_names());

    gtk_combo_set_popdown_strings(GTK_COMBO(lookup_widget(frm_commissions,
                     "cbo_table")), get_table_names());
}

void archive_tbl_commissions()
{
   gchar       *str_table_name;
   time_t      now;
   gchar       *rows_before, *rows_after;

   /* Ta funkcja sluzy do archiwizacji zawartosci tabeli tbl_prowizje
    * i przygotowania tabeli dla nowych danych.
    *
    * Operacja zostanie przeprowadzona w czterech etapach:
    *     1.  Pobranie liczby rekordow znajdujacych sie obecnie
    *         w tabeli
    *     2.  Utworzenie nowej tabeli i umieszczenie w niej
    *         calej zawartosci tab_prowizje. Nowa tabela zostanie
    *         opatrzona dokladnym czasem utworzenia
    *
    *     3.  Pobranie liczby rekordow nowej tabelii prowownanie z liczba
    *         rekordow w tbl_prowizje
    *     4.  Jesli obie liczby sa takie same, mozna usunac
    *         cala zawartosc tabeli tbl_prowizje.
    *
    */

   log_event("Archiving tbl_commissions. ");

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   sql = "select count(*) from tbl_prowizje";

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad podczas wykonywania zapytania...  */
            set_message("Wystapil blad w trakcie odczytu liczby rekordow tabeli tbl_prowizje.");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                               "lbl_archive")), "Blad w zapytaniu w trakcie odczytu liczby "
                               "rekordow tabeli tbl_prowizje.\n  Skontaktuj sie  "
                               "z administratorem.");

            /* Przerwanie polaczenia*/
            mysql_close(conx);
            return;
        }
   else
       {
            /* Zapytanie wykonano poprawnie... */
            result_set = mysql_store_result (conx);
            row = mysql_fetch_row (result_set);
            g_print("liczba rekordow w tbl_prowizje:  %s...\n", row[0]);

            rows_before = row[0];

       }
   /* Utworzenie nowej tabeli. */

   time(&now);
   str_table_name = g_strstrip((gchar *) ctime(&now));
   str_table_name = g_strdelimit(str_table_name, " :,", '_');

   g_print("nazwa nowej tabeli %s\n", str_table_name);

   /* Ponizej uzyjemy polecenia CREATE tABLE. Z tego polecenia mozna skorzystac
    * na wiele sposobow, ale w tym przypadku skorzystamy z nastepujacej
    * konstrukcji polecenia:
    *
    *    create table tbl instrukcja-select
    *
    * tbl oznacza nazwe nowej tabeli, a  instrukcja-select
    * vjest odpowiednia instrukcja select.  Utworzymy tabele na podstawie
    * wynikow poprawnej instrukcji select, dzieki czemu nie bedziemy musieli
    * jawnie podawac nazw kolumn.
    */

   sql = g_strconcat("create table ", str_table_name,
                     " select * from tbl_prowizje", 0L);

   if (mysql_query (conx, sql) != 0)
      {
            /* Blad podczas wykonywania zapytania...  */
            set_message(g_strconcat("Wystapil blad podczas wykonywania instrukcji create table ",
                      str_table_name, 0L));
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                               "lbl_archive")), "Blad podczas wykonywania instrukcji create  "
                               "table.\n  Zanotuj date, czas i  "
                               "skontaktuj sie z administratorem.");

            /* Przerwanie wykonywania funkcji. */
            mysql_close(conx);
            return;
      }
   else
      {
            /* Zapytanie wykonano poprawnie... */
      }

   /* Teraz wyznaczymy liczbe rekordow nowej tabeli i sprawdzimy, czy
    * jest taka sama, jak liczba rekordow w tbl_prowizje
    */

   sql = g_strconcat("select count(*) from ", str_table_name, 0L);

   if (mysql_query (conx, sql) != 0)
      {
            /* Blad podczas wykonywania zapytania...  */
            set_message(g_strconcat("Wystapil blad podczas wykonywania zapytania zwracajacego liczbe rekordow ",
                      str_table_name, 0L));
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                               "lbl_archive")), "Blad podczas wykonywania zapytania o liczbe rekordow "
                               "nowej tabeli.\n  Zanotuj date, czas i  "
                               "skontaktuj sie z administratorem.");

            mysql_close(conx);
            return;
      }
   else
      {
            /* Zapytanie wykonano poprawnie.. */

      }

   result_set = mysql_store_result (conx);
   row = mysql_fetch_row (result_set);
   g_print("liczba rekordow nowej tabeli %s...\n", row[0]);

   rows_after = row[0];

   /* Porownamyliczby rekordow obu tabel ("starej" i nowej).
    * Niezaleznie od tego, czy porownamy wartosci w postaci lancuchow,
    * czy liczb calkowitych - obie wartosci powinny byc identyczne.
    * W wyniku wykonania zapytania do bazy danych
    * otrzymalismy lancuchy znakow..
    */

   if (g_strcasecmp(rows_after, rows_before) != 0)
      {
          /* Wartosci roznia sie - operacja wykonana
           * blednie...
           */

          set_message("Nowa i stara tabela maja   "
                      "rozna liczbe rekordow.");
          gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_archive")), "Blad - tabele maja  "
                      "arozna liczbe rekordow.\n  Zanotuj date, czas i"
                      "skontaktuj sie z administratorem.");

          mysql_close(conx);
          return;
      }
   else
      {
         /* Liczba kolumn w nowej tabeli jest taka sama,
          * jak liczba kolumn w starej tabeli.
          * To oznacza, ze archiwizacja tabeli tbl_prowizje
          * zostala przeprowadzona poprawnie, wiec
          * mozna kontynuowac przetwarzanie danych
          * w programie.
          */
      }

   sql = "Delete from tbl_prowizje";
   if (mysql_query (conx, sql) != 0)
      {
          /* Blad podczas wykonywania zapytania...  */
          set_message("Podczas usuwania danych tbl_prowizje wystapil blad");
          gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_archive")), "Wystapil blad podczas usuwania rekordow  "
                      "z tabeli tbl_prowizje..\n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");

          mysql_close(conx);
          return;
      }
   else
      {
          /* Wykonanie zapytania powiodlo sie.
           * Pamietajmy o tym, ze funkcja mysql_query()
           * zwraca odpowiednio wartosc w zaleznosci od tego,
           * czy podane zapytanie zostalo napisane poprawnie, czy nie.
           * Funkcja mysql_query() nie reaguje na
           * probe usuniecia danych z bazy, dlatego
           * musimy sami sprawdzic, czy operacja przeniesienia
           * danych do nowej tabeli powiodla sie (w nowej tabeli
	   * jest wowczas taka sama liczba kolumn, co w starej).
           *
           * Kontynuacja przetwarzania...
           */
      }

   sql = "select count(*) from tbl_prowizje";
   if (mysql_query (conx, sql) != 0)
      {
         /* Blad podczas wykonywania zapytania  */
         set_message("Podczas proby pobrania liczby rekordow tabeli tbl_prowizje wystapil blad");
         gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_archive")), "Wystapil blad w trakcie pobierania liczby rekordow "
                      "tabeli tbl_prowizje.\n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");

         mysql_close(conx);
         return;
      }
   else
      {
         /* Zapytanie wykonano poprawnie... */
      }

   result_set = mysql_store_result (conx);
   row = mysql_fetch_row (result_set);
   g_print("liczba rekordow w starej tabeli %s...\n", row[0]);

   if (g_strcasecmp(row[0], "0") != 0)
      {
        /* W "starej" tabeli istnieja jeszcze jakeis rekordy
         * wystapil blad...
         */

        set_message("W tabeli tbl_prowizje pozostaly jeszcze jakies rekordy");
        gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_archive")), "Wystapil blad: w tabeli "
                      "tbl_prowizje pozostaly rekordy.\n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");

        mysql_close(conx);
        return;
      }
   else
      {
         /* Cala operacja zostala wykonana poprawnie. */
         mysql_close(conx);
         gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                               "lbl_archive")), "Archiwizacja zakonczona."
                           );
         log_event("Zarchiwizowano pomyslnoie tabele tbl_prowizje. ");
      }

}

void load_tbl_revenue()
{
   /* Ta funkcja sluzy do zaladowania zawartosci pliku tekstowego
    * do tabeli tbl_place. Funkcja wykonuje to samo zadanie, co
    * kod w listingu 8.1, ale nie usuwa tabeli i nie wykonuje instrukcji
    * select count(*). Instrukcja LOAD DATA jest taka sama,
    * ale nie wykorzystanow  niej cudzyslowow.
    */

   log_event("Import danych do tbl_place. ");

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("Rozpoczecie importu danych...\n");

   /* Najpierw usuniemy dane z tabeli tbl_revenue i sprawdzimy, czy
    * tabela jest pusta.
    */
   sql = "delete from tbl_place";

   if (mysql_query (conx, sql) != 0)
      {
         /* Blad podczas wykonywania zapytania.  */
         mysql_close(conx);
         set_message("Blad podzcas wykonywania zapytania: delete from tbl_place");
         gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                   "lbl_import")), "Wystapil blad podczas usuwania "
                   "danych tbl_place.\n  "
                   "Zanotuj date, czas i "
                   "skontaktuj sie z administratorem.");
         return;
      }
   else
      {
         g_print("Zapytanie delete from tbl_place wykonano poprawnie\n");
      }

   /* Sprawdzmy, czy w tbl_place rzeczywiscie nie ma rekordow. */

   sql = "select count(*) from tbl_place";

   if (mysql_query (conx, sql) != 0)
      {
         /* QBlad wykonania zapytania.  */
         mysql_close(conx);
         set_message("Blad podczas wykonywania zapytania: select count(*) from tbl_place");
         gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                   "lbl_import")), "Blad w wyznaczeniu liczby "
                   "rekordow tabeli tbl_place.\n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");
         return;
      }
   else
      {
         /* Zapytanie powiodlo sie. */
      }

   result_set = mysql_store_result (conx);
   row = mysql_fetch_row (result_set);
   g_print("Liczba rekordow w tabeli tbl_place %s...\n", row[0]);

   if (g_strcasecmp(row[0], "0") != 0)
      {
        /* Tabela tbl_place nie jest pusta. Import danych
         * zostanie przeprowadzony nieprawidlowo - trzeba
	 * oposcic funkcje.
         */

        set_message("W tabeli tbl_place pozostaly jeszcze jakies rekordy");
        gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_import")), "Blad: w tabeli tbl_place istnieja "
                      "jeszcze rekordy.\n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");

        mysql_close(conx);
        return;
      }
   else
      {
        /* Zapytanie wykonano poprawnie - kontynuacja... */
      }

   sql = "LOAD DATA INFILE "
         " \"/home/ch08/tbl_place.txt\" "
         "INTO TABLE tbl_place "
         "FIELDS TERMINATED BY \',\' "
         "IGNORE 1 LINES "
         "(nr_klienta,"
         " nazwa_klienta,"
         " sprzedawca,"
         " kraj,"
         " miasto,"
         " stan,"
         " kod,"
         " data_dost,"
         " nr_towaru,"
         " liczba_sztuk,"
         " cena_jedn,"
         " wart_netto,"
         " nr_faktury,"
         " data_faktury,"
         " liczba_faktur,"
         " wartosc_faktury )";

   g_print("sql: %s\n", sql);

   /* Zwrocmy uwage na to, ze aby wykonac biezace zapytanie sql
    * musimy miec odpowiednie uprawnienia.  W bazie danych mysql
    * (ktora jest wlasciwie baza umieszczona w serwerze MySQL),
    * w tabeli  'user', pole 'File_priv' powinno miec wartosc Y dla
    * okreslonego uzytkownika logujacego sie z okreslonego komputera.
    * W naszym przypadku uzytkownik bazy danych ma nazwe com_user i
    * moze zalogowac sie z dowolnej maszyny, jako "pracownik".
    *
    * Nie zapomnijmy o ponownym zaladowaniu tabeli uprawnieni za pomoca instrukcji 'flush privileges'
    * wydanej z wiersza polecen mysql> (po dokonaniu odpowiednich zmian). Mozna takze uruchomic ponownie system
    * operacyjny.
    */

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad podczas wykonywania zapytania  */
            g_print("Numer bledu  %i...\n", mysql_errno(conx) );
            g_print("Opis bledu %s...\n", mysql_error(conx) );

            mysql_close(conx);
            set_message("Wystapil blad podczas wykonywania instrukcji LOAD DATA");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_import")), "Blad wykonania  "
                      "instrukcji LOAD DATA.\n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");

            return;
        }
   else
        {
           /* Zapytanie wykonano poprawnie */
        }

   sql = "select count(*) from tbl_place";
   if (mysql_query (conx, sql) != 0)
        {
            /* Blad podczas wykonywania zapytania.  */
            mysql_close(conx);
            set_message("Wystapil blad podczas wykonania zapytania: select count(*) from tbl_place");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_import")), "Wystapil blad podczas wykonywania zapytania "
                      "select count(*) from tbl_place.\n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");
            return;
        }
   else
        {
            /* Zapytanie wykonano poprawnie...  */
        }

   result_set = mysql_store_result (conx);
   row = mysql_fetch_row (result_set);
   g_print("Liczba rekordow w tbl_place  %s...\n", row[0]);

   if (g_strcasecmp(row[0], "0") != 0)
      {
          /* Nalezy poinformowac uzytkownika o poprawnym
           * imporcire pliku tbl_place.txt.
           */
           gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_import")), g_strconcat("Import danych z pliku wykonano poprawnie. Zaladowano",
                      row[0], " nowych rekordow.", 0L));

      }
   else
      {
          /* Jesli po zaimportowaniu danych z pliku jest nadal 0 rekordow,
           * to gdzies wystapil blad
           */
           gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_import")), "W tabeli tbl_place znajduje sie "
                      "0 rekordow po zakonczeniu ladowania danych (blad)...\n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");

      }

    mysql_close(conx);

}

void process_customer_commissions()
{
   /*Jesli w tabeli tbl_place znajduje sie numer sprzedawcy,
    * to oznacza, ze sprzedawca o danym numerze otrzyma prowizje
    * od odpowiedniej faktury. Sprzedawca o danym numerze
    * moze otrzymac prowizje takze od innych faktur,
    * wowczas jego numer pojawi sie w innych rekordach
    * tej tabeli. */
   log_event("Prowizje sprzedawcow z tbl_place. ");

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("Rozpoczeto przetwarzanie danych klientow...\n");

   sql = "insert into tbl_prowizje "
         "(sprzedawca, nr_faktury, prowizja) "
         "select tbl_place.sprzedawca, "
         "tbl_place.nr_faktury, "
         "tbl_prac.prowizja * tbl_place.wartosc_faktury "
         "from tbl_place, tbl_prac "
         "where tbl_place.sprzedawca = tbl_prac.sprzedawca";

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad podczas wykonywania zapytania...  */
            mysql_close(conx);
            set_message("Wystapil blad w zapytaniu w process_customer_commissions().");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_customers")), "Wystapil blad podczas  "
                      "przetwarzania danych dotyczacych pracownika w tbl_place. \n  "
                      "Nie wykonano polecenia insert. \n"
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");
            return;
        }
   else
        {
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                   "lbl_customer")), g_strconcat("Zakonczono przetwarzanie danych. Wprowadzono",
                   g_strdup_printf("%d",(gint) mysql_affected_rows(conx)),
                   " rekordow.", 0L));

            mysql_close(conx);
            set_message("Wykonano funkcje process_customer_commissions .");
        }

}

void process_worldwide()
{
   /* W tej funkcji zostana uwzglednieni sprzedawcy, ktorzy
    * otrzymuja prowizje od faktur wystawionych na calym
    * swiesie. To bedzie prosta operacja, bo w naszej bazie
    * istnieja tylko dwie takie osoby.
    */

   log_event("Prowizje - swiat.");

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("Rozpoczecie przetwarzania danych...\n");

   sql = "insert into tbl_prowizje "
         "(sprzedawca, nr_faktury, prowizja) "
         "select tbl_prac_placa_swiat.sprzedawca, "
         "       tbl_place.nr_faktury, "
         "       tbl_prac.prowizja * tbl_place.wartosc_faktury "
         "from tbl_prac_placa_swiat, tbl_place, tbl_prac "
         "where tbl_prac.sprzedawca = "
         "      tbl_prac_placa_swiat.sprzedawca ";

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad podczas wykonywania zapytania...  */
            mysql_close(conx);
            set_message("wystapil w zapytaniu w process_worldwide.");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_worldwide")), "Wystapil blad podczas przetwarzania danych"
                      "dotyczacych prowizji (swiat). \n  "
                      "Nie wykonano polecenia insert. \n"
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");
            return;
        }
   else
        {
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                  "lbl_worldwide")), g_strconcat("Zakonczono przetwarzanie danych. ",
                  g_strdup_printf("Wprowadzono %d",(gint) mysql_affected_rows(conx)),
                  " rekordow.", 0L));

            mysql_close(conx);
            set_message("Wykonano funkcje process_worldwide() .");
        }

}

void process_area(gchar *area)
{
   /* Ta funkcja sluzy do przetwarzania danych
    * dotyczacych prowizji pracownikow w danym kraju lub stanie.
    */


   log_event(g_strconcat("Przetwarzanie danych dla ", area, " ", 0L));

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("Rozpoczecie %s przetwarzania danych...\n", area);

   sql = g_strconcat(
         "insert into tbl_prowizje (sprzedawca, nr_faktury, prowizja) "
         "select tbl_prac_placa_", area, ".sprzedawca, "
         "       tbl_place.nr_faktury, "
         "       tbl_prac.prowizja * tbl_place.wartosc_faktury "
         "from tbl_prac_placa_", area, ", tbl_place, tbl_prac "
         "where tbl_prac.sprzedawca=tbl_prac_placa_",
                area, ".sprzedawca"
         "  and tbl_prac_placa_", area, ".", area, "=tbl_place.", area,
         0L);

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad podczas wykonywania zapytania...  */
            mysql_close(conx);
            set_message(g_strconcat("Wystapil blad podczas wykonywania funkcji dla",
                                    area, ".", 0L));
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      g_strconcat("lbl_", area, 0L))),
                      g_strconcat( "Wystapil blad  podczas "
                      " przetwarzania ", area, ". \n  "
                      "Nie wykonano polecenia insert. \n"
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.",0L));
            return;
        }
   else
        {
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      g_strconcat("lbl_", area, 0L))),
                      g_strconcat(area, " - Przetwarzanie danych zakonczone. ",
                      g_strdup_printf("Wprowadzono %d",(gint) mysql_affected_rows(conx)),
                      " rekordow.", 0L));

            mysql_close(conx);
            set_message(g_strconcat("Przewtarzanie ", area, " zakonczone.", 0L));
        }

}

void process_zipcode()
{
   log_event("Przetwarzanie danych  - kody pocztowe.");

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("Rozpoczecie przetwarzania danych (kody pocztowe)...\n");

   sql = "insert into tbl_prowizje (sprzedawca, nr_faktury, prowizja) "
         "select tbl_prac_placa_kod.sprzedawca, "
         "       tbl_place.nr_faktury, "
         "       tbl_prac.prowizja * tbl_place.wartosc_faktury "
         "from tbl_prac_placa_kod, tbl_place, tbl_prac "
         "where tbl_prac.sprzedawca=tbl_prac_placa_kod.sprzedawca"
         "  and tbl_prac_placa_kod.kod_pocztowy=tbl_place.kod";

   if (mysql_query (conx, sql) != 0)
        {
            /* Wystapil blad podczas wykonywania zapytania...  */
            mysql_close(conx);
            set_message("Wystapil blad w trakcie wykonania zapytania (kod pocztowy)");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_zip")), "Wystapil blad podczas"
                      "przetwarzania danych (kodoy pocztowe). \n  "
                      "Nie wykonano polecenia insert. \n"
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");
            return;
        }
   else
        {
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_zip")), g_strconcat("Zakonczono przetwarzanie danych. ",
                      g_strdup_printf(" Wprowadzono %d",(gint) mysql_affected_rows(conx)),
                      " rekordow.", 0L));

            mysql_close(conx);
            set_message("Zakonczono przetwarzanie danych (kody pocztowe).");
        }

}

void process_paid_on_people()
{
   log_event("Przetwarzanie danych (inni pracownicy).");

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("Rozpoczecie przetwarzania danych (inni pracownicy)...\n");

   sql = "insert into tbl_prowizje (sprzedawca, nr_faktury, prowizja) "
         "select tbl_prac_placa_inni.oplacany_prac, "
         "tbl_place.nr_faktury, "
         "tbl_prac.prowizja * tbl_place.wartosc_faktury "
         "from tbl_place, tbl_prac, tbl_prac_placa_inni "
         "where tbl_place.sprzedawca = "
         "      tbl_prac_placa_inni.placa "
         "  and tbl_prac.sprzedawca = "
         "      tbl_prac_placa_inni.oplacany_prac";

   if (mysql_query (conx, sql) != 0)
        {
            /* Wystapil blad podczas wykonywania zapytania... */
            mysql_close(conx);
            set_message("Wystapil blad podczas wykonywania zapytania w process_paid_on_people");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_people")), "Wystapil blad w trakcie "
                      "przetwarzania danych (inni). \n  "
                      "Nie wykonano polecenia insert. \n"
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");
            return;
        }
   else
        {
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_people")), g_strconcat("Zakonczono przetwarzanie danych.",
                      " Wprowadzono",
                      g_strdup_printf("%d",(gint) mysql_affected_rows(conx)),
                      " rekordow.", 0L));

            mysql_close(conx);
            set_message("Zakonczono przetwarzanie danych.");
        }

}

void write_salespeople_statements()
{
   gchar *file_name;
   FILE  *fp;
   gchar *current_salesperson = "nikt";

   log_event("Zapis instrukcji sprzedawcow.");

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("Rozpoczecie zapisu instrukcji sprzedawcow.\n");
   gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_salespeople")), "Odczytywanie danych "
                      "z bazy...\n "
                      "moze potrwac kilka minut..."
                      );

   gtk_widget_show(lookup_widget(frm_commissions, "lbl_salespeople"));

   sql = "select tbl_prowizje.sprzedawca, "
         "       tbl_prowizje.nr_faktury, "
         "       tbl_prowizje.prowizja, "
         "       tbl_prac.imie, "
         "       tbl_prac.nazwisko, "
         "       tbl_place.nazwa_klienta, "
         "       tbl_place.nr_towaru, "
         "       tbl_place.liczba_sztuk "
         "from tbl_prowizje, tbl_prac, tbl_place "
         "where tbl_prowizje.sprzedawca = tbl_prac.sprzedawca "
         "  and tbl_prowizje.nr_faktury = tbl_place.nr_faktury "
         "order by tbl_prowizje.sprzedawca, tbl_prowizje.nr_faktury";

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad zapytania...  */
            mysql_close(conx);
            set_message("wystapil blad podczas zapisu danych");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_salespeople")), "Blad zapytania "
                      "podczas zapisu danych. \n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");
            return;
        }
   else
        {
            result_set = mysql_store_result (conx);

            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_salespeople")), g_strconcat("Zapisywanie instrukcji ",
                      "na dysk...\n ",
                      "Liczba rekordow: ",
                      g_strdup_printf("%d",(gint) mysql_num_rows(result_set)),
                      0L));

            set_message("Odczytano rekordy dotyczace sprzedawcow.");

            /* Zapytanie zostalo wykonane poprawnie, result_set zawiera
             * liczbe wszystkich rekordow, mozna kontynuowac dzialanie programu...
             */
        }

   /* Teraz zajmiemy sie zapisem danych do pliku. Utworzymy
    * plik dla kazdego pracownika. result_set zawiera dane poszczegolnych
    * pracownikow, wystarczy wiec dla kazdego z rekordow
    * utworzyc osobny plik, gdy dane dotyczace pracownika zostana
    * zmienione.
    *
    * Najpier trzeba okreslic nazwe pliku.
    *
    * Pobierzemy pierwszy rekord.
    */

   if ((row = mysql_fetch_row (result_set)) == 0L)
      {
         /* Nie mozna pobrac pierwszego rekordu. */
         set_message("Nie mozna odczytac pierwszego rekordu z result_set.");

         return;
      }
   else
     {
        /* Kontynuuj... */
     }

   current_salesperson = row[0];
   file_name = g_strconcat(current_salesperson, "-",
                     row[4], ".xls", 0L);

   g_print("Biezacy plik %s.\n", file_name);

   /* Otwarcie nowego pliku. */

   if ((fp = fopen (file_name, "w")) == 0L)
        {
              set_message(g_strconcat("Nie mozna otworzyc pliku ",
                          file_name,
                          " aby dokonac zapisu danych.", 0L));
              return;
        }
   else
        {
              /* Zapis naglowka. */
              fprintf(fp, "Prowizje dla ");
              fprintf(fp, current_salesperson);
              fprintf(fp, ", ");
              fprintf(fp, row[3]);  /* Imie pracownika. */
              fprintf(fp, "\n");

              fprintf(fp, "Wszytskie wielkosci podano w USD .\n\n");

              fprintf(fp, "Numer faktury\t");
              fprintf(fp, "Wysokosc prowizji\t");
              fprintf(fp, "Nazwa klienta\t");
              fprintf(fp, "Numer towaru\t");
              fprintf(fp, "Liczba sztuk\n");
        }

   /* Nazwa pliku bedzie skladac sie z numeru sprzedawcy
    * i jego nazwiska.  Sprzedawcy beda korzystac z
    * Excela do otwierania tych plikow, wiec zapiszemy je
    * w odpowiednim formacie.
    */

   do {
         if (g_strcasecmp(row[0], current_salesperson) == 0)
           {


              fprintf(fp, row[1]); fprintf(fp, "\t");
              fprintf(fp, row[2]); fprintf(fp, "\t");
              fprintf(fp, row[5]); fprintf(fp, "\t");
              fprintf(fp, row[6]); fprintf(fp, "\t");
              fprintf(fp, row[7]); fprintf(fp, "\n");

           }
         else
           {
              /* Rekord zawiera dane dotyczace innego sprzedawcy.
               * Trzeba zamknac biezacy plik.
               */

              fclose(fp);

              /* Utworzenie nazwy nowego pliku. */

              current_salesperson = row[0];
              file_name = g_strconcat(current_salesperson, "-",
                                row[4], ".xls", 0L);

              g_print("Biezacy plik %s.\n", file_name);

              /* Open the new file. */

              if ((fp = fopen (file_name, "w")) == 0L)
                 {
                    /* Nie mozna otworzyc pliku
                     * do zapisu danych.
                     */

                     set_message(g_strconcat("Nie mozna otworzyc pliku ",
                                 file_name,
                                 " aby zapisac dane.", 0L));

                     return;
                 }
              else
                 {
                     /* Plik otwarty i gotowy do zapisu danych. */

                 }

              /* Naglowek pliku. */
              fprintf(fp, "Prowizje dla ");
              fprintf(fp, current_salesperson);
              fprintf(fp, " - ");
              fprintf(fp, row[4]);  /* Nazwisko pracownika. */
              fprintf(fp, ", ");
              fprintf(fp, row[3]);  /* Imie pracownika. */
              fprintf(fp, "\n");

              fprintf(fp, "Wszytskie wartosci podano w USD.\n\n");

              fprintf(fp, "Numer faktury\t");
              fprintf(fp, "Wysokosc prowizji\t");
              fprintf(fp, "Nazwa klienta\t");
              fprintf(fp, "Numer towaru\t");
              fprintf(fp, "Liczba sztuk\n");

           }

      } while ((row = mysql_fetch_row (result_set)) != 0L);

   g_print("Wyjscie z  write_salesperson_statements.\n");
   mysql_close(conx);

}

void write_country_manager_statements()
{
   gchar *file_name;
   FILE  *fp;
   gchar *current_country = "none";

   log_event("Zapis danych dyrektorow regionalnych.");

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("Zapis danych dyrektorow regionalnych.\n");
   gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_country_managers")), "Odczyt danych "
                      "z bazy...\n "
                      "moze potrwac kilka minut..."
                      );

   sql = "select tbl_prac.kraj, tbl_prowizje.sprzedawca, "
         "       tbl_prowizje.prowizja, "
         "       tbl_prowizje.prowizja * tbl_stawki.stawka "
         "from tbl_prowizje, tbl_prac, tbl_stawki "
         "where tbl_prowizje.sprzedawca = tbl_prac.sprzedawca "
         "  and tbl_prac.kraj = tbl_stawki.kraj "
         "group by tbl_prowizje.sprzedawca "
         "order by tbl_prac.kraj ";

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad zapytania...  */
            mysql_close(conx);
            set_message("Blad zapytania: "
                        "podczas zapisu danych dyraktorow regionalnych.");
            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_country_managers")), "Blad zapytania "
                      " podczas zapisu danych dyraktorow regionalnych. \n  "
                      "Zanotuj date, czas i "
                      "skontaktuj sie z administratorem.");
            return;
        }
   else
        {
            result_set = mysql_store_result (conx);

            gtk_label_set_text(GTK_LABEL(lookup_widget(frm_commissions,
                      "lbl_country_managers")),
                      g_strconcat("Zapisano dane ",
                      "dyrektorow regionalnych...\n ",
                      "Liczba rekordow: ",
                      g_strdup_printf("%d",(gint) mysql_num_rows(result_set)),
                      0L));

            set_message("Odczytano dane dotyczace "
                        "dyrektorow regionalnych.");

            /* zapytanie wykonano poprawnie, result_set zawiera
             * liczbe wszystkich rekordow, mozna kontynuowac dzialanie programu...
             */
        }

   /* Pobranie pierwszego rekordu. */

   if ((row = mysql_fetch_row (result_set)) == 0L)
      {
         /* Nie mozna odczytac pierwszego rekordu. */
         set_message("Nie mozna odczytac pierwszego rekordu z result_set "
                     "(dyrektorzy regionalni).");

         return;
      }
   else
     {
        /* Kontynuuj... */
     }

   current_country = row[0];
   file_name = g_strconcat(current_country, ".xls", 0L);

   g_print("Biezacy plik %s.\n", file_name);

   /* Otwarcie nowego pliku. */

   if ((fp = fopen (file_name, "w")) == 0L)
        {
              set_message(g_strconcat("Nie mozna otworzyc ",
                          "pliku: ",
                          file_name,
                          ", do zapisu danych.", 0L));
              return;
        }
   else
        {
              /* Zapis naglowka pliku. */
              fprintf(fp, "Prowizje w kraju: ");
              fprintf(fp, current_country);
              fprintf(fp, "\n");

              fprintf(fp, "Sprzedawca\t");
              fprintf(fp, "USD\t");
              fprintf(fp, "Waluta lokalna\n");
        }

   do {

         if (g_strcasecmp(row[0], current_country) == 0)
           {

              fprintf(fp, row[1]); fprintf(fp, "\t");
              fprintf(fp, row[2]); fprintf(fp, "\t");
              fprintf(fp, row[3]); fprintf(fp, "\n");

           }
         else
           {
              /* Rekord zawiera nowy plik.
               * Zamkniecie pliku biezacego.
               */

              fclose(fp);

              /* Utworzenie nowej nazwy pliku. */

              current_country = row[0];
              file_name = g_strconcat(current_country, ".xls", 0L);

              g_print("Biezacy plik %s.\n", file_name);

              /* Otwarcie pliku. */

              if ((fp = fopen (file_name, "w")) == 0L)
                 {
                    /* Nie mozna otworzyc pliku
                     * i dokonac zapisu danych.
                     */

                     set_message(g_strconcat("nie mozna otworzyc pliku ",
                                 file_name,
                                 " i dokonac zapisu danych.", 0L));

                     return;
                 }
              else
                 {
                     /* Plik otwarty i gotowy do zapisu. */
                 }

              /* Zapis naglowka. */
              fprintf(fp, "Prowizje dla kraju: ");
              fprintf(fp, current_country);
              fprintf(fp, "\n");

              fprintf(fp, "Sprzedawca\t");
              fprintf(fp, "USD\t");
              fprintf(fp, "Waluta lokalna\n");

           }

      } while ((row = mysql_fetch_row (result_set)) != 0L);

   g_print("Zakonczenie polaczenia z baza danych.\n");
   mysql_close(conx);

}

void insert_row()
{
/* Ta funkcja sluzy do wprowadzenia jednego rekordu do tabeli bazy danych
 * Ponizej znajduja sie dodatkowo funkcje update_row() i delete_row(),
 * dzieki ktorym uzytkownik moze modyfikowac dane.*/
   gchar *str_table_name;

   str_table_name = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lookup_widget(
                     frm_commissions, "cbo_table"))->entry));

   sql = g_strconcat("insert into ", str_table_name,
                      "() values()", 0L);


   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   g_print("sql is %s\n", sql);

   if (mysql_query (conx, sql) != 0)
        {
            /* Query failure...  */
            g_print("nieprawidlowe zapytanie sql w insert_row().\n");
            mysql_close(conx);
            g_print("polaczenie zakonczono.\n");
            set_message(g_strconcat("Blad: Wprowadzenie danych nie udane",
                         str_table_name, 0L));
        }
    else
        {
            g_print("zapytanie sql ok.\n");
            set_message(g_strconcat("Nr nowego rekordu: ",
                    g_strdup_printf("%d",(gint) mysql_insert_id(conx)),
                    " w tabeli ", str_table_name,
                    0L));

        }

   log_event(g_strconcat("wprowadzenie danych do ", str_table_name, 0L));
}

void update_row()
{
   gchar *str_table_name;

   str_table_name = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lookup_widget(
                     frm_commissions, "cbo_table"))->entry));

   /* Ponizsze zapytanie sql jest przeznaczone do modyfikacji
    * kolumny znakowej, nie liczbowej.  Nalezy wiedziec,
    * ze MySQL dokona jawnej konwersji z typu znakowego
    * do liczbowegoi jesli konwersja zostanie
    * przeprowadzona poprawnie, uaktualni kolumne liczbowa..
    * Jesli uzytkownik sprobuje blednie wpisac znak
    * do kolumny z wartosciami liczbowymi, to w tym miejscu
    * zostanie wpisana wartosc  0.
    */

   sql = g_strconcat("update ", str_table_name, " set ",
                gtk_editable_get_chars(GTK_EDITABLE(
                             lookup_widget(frm_commissions,
                             "entry_column_name")), 0, -1),
                " = '",
                gtk_editable_get_chars(GTK_EDITABLE(
                             lookup_widget(frm_commissions,
                             "entry_new_value")), 0, -1),
                "'  where nr_wiersza = ",
                g_strdup_printf("%d",
                gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(
                        lookup_widget(frm_commissions,
                        "spinbutton_update_line")))),
                0L);

   g_print("sql : %s\n", sql);

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad zapytania...  */
            g_print("Zapytanie sql jest nieprawidlowe w update_row().\n");
            mysql_close(conx);
            g_print("Polaczenie zakonczone.\n");
            set_message(g_strconcat("Blad: Nie zaktualizowano zawartosci rekordu",
                         str_table_name, 0L));
        }
    else
        {
            g_print("Zapytanie sql ok.\n");
            set_message(g_strconcat("Uaktualniono zawartosc rekordu w tabeli ",
                    str_table_name, 0L));

        }

    mysql_close (conx);

    log_event(g_strconcat(user_login, " aktualizacja danych: ",
                          g_strdelimit(g_strstrip(sql), "*'\"", '^'),
                          0L));

}

void delete_row()
{
/* Ta funkcja sluzy do usuniecia rekordu z tabeli okreslonej
 * w cbo_table
 */
   gchar *str_table_name;

   str_table_name = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lookup_widget(
                     frm_commissions, "cbo_table"))->entry));

   sql = g_strconcat("delete from ", str_table_name, " where ",
                "nr_wiersza = ",
                g_strdup_printf("%d",
                gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(
                        lookup_widget(frm_commissions,
                        "spinbutton_delete_row")))),
                0L);
   g_print("sql: %s\n", sql);

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN,
                             PASS, DB, 0, 0L, 0);

   if (mysql_query (conx, sql) != 0)
        {
            /* Blad zapytania...  */
            g_print("Zapytanie sql jest nieprawidlowe w delete_row().\n");
            mysql_close(conx);
            g_print("Polaczenie zakonczono.\n");
            set_message(g_strconcat("Blad: Nie usunieto rekordu z ",
                         str_table_name, 0L));
        }
    else
        {
            g_print("Zapytanie sql ok.\n");
            set_message(g_strconcat("Usunieto rekord z tabeli ",
                    str_table_name, 0L));

        }

    log_event(g_strconcat(user_login, " usuwanie rekordu: ",
                          g_strdelimit(g_strstrip(sql), "*'\"", '^'),
                          0L));

}

